using System;
using MicrosoftResearch.Infer;
using MicrosoftResearch.Infer.Distributions;
using MicrosoftResearch.Infer.Maths;
using MicrosoftResearch.Infer.Collections;
using MicrosoftResearch.Infer.Factors;

namespace MicrosoftResearch.Infer.Models.User
{
	/// <summary>
	/// Generated algorithm for performing inference
	/// </summary>
	/// <remarks>
	/// The easiest way to use this class is to wrap an instance in a CompiledAlgorithm object and use
	/// the methods on CompiledAlgorithm to set parameters and execute inference.
	/// 
	/// If you instead wish to use this class directly, you must perform the following steps:
	/// 1) Create an instance of the class
	/// 2) Set the value of any externally-set fields e.g. data, priors
	/// 3) Call the Execute(numberOfIterations) method
	/// 4) Use the XXXMarginal() methods to retrieve posterior marginals for different variables.
	/// 
	/// Generated by Infer.NET 2.5 at 00:02 on sexta-feira, 6 de Setembro de 2013.
	/// </remarks>
	public partial class Model4_EP : IGeneratedAlgorithm
	{
		#region Fields
		/// <summary>Field backing the NumberOfIterationsDone property</summary>
		private int numberOfIterationsDone;
		/// <summary>Field backing the prior property</summary>
		private SparseGP Prior;
		/// <summary>Field backing the routineFeaturesTrain property</summary>
		private Vector[] RoutineFeaturesTrain;
		/// <summary>Field backing the observedCountsTrain property</summary>
		private double[] ObservedCountsTrain;
		/// <summary>The number of iterations last computed by Changed_prior_routineFeaturesTrain_observedCountsTrain. Set this to zero to force re-execution of Changed_prior_routineFeaturesTrain_observedCountsTrain</summary>
		public int Changed_prior_routineFeaturesTrain_observedCountsTrain_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_numberOfIterationsDecreased_prior_routineFeaturesTrain_observedCountsTrain. Set this to zero to force re-execution of Changed_numberOfIterationsDecreased_prior_routineFeaturesTrain_observedCountsTrain</summary>
		public int Changed_numberOfIterationsDecreased_prior_routineFeaturesTrain_observedCountsTrain_iterationsDone;
		/// <summary>The number of iterations last computed by Constant. Set this to zero to force re-execution of Constant</summary>
		public int Constant_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_prior_Init_numberOfIterationsDecreased_routineFeaturesTrain_observedCountsTrain. Set this to zero to force re-execution of Changed_prior_Init_numberOfIterationsDecreased_routineFeaturesTrain_observedCountsTrain</summary>
		public int Changed_prior_Init_numberOfIterationsDecreased_routineFeaturesTrain_observedCountsTrain_iterationsDone;
		/// <summary>True if Changed_prior_Init_numberOfIterationsDecreased_routineFeaturesTrain_observedCountsTrain has performed initialisation. Set this to false to force re-execution of Changed_prior_Init_numberOfIterationsDecreased_routineFeaturesTrain_observedCountsTrain</summary>
		public bool Changed_prior_Init_numberOfIterationsDecreased_routineFeaturesTrain_observedCountsTrain_isInitialised;
		public DistributionRefArray<SparseGP,IFunction> f_rep_B;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<SparseGP></summary>
		public SparseGP f_rep_B_toDef;
		/// <summary>Message to marginal of 'f'</summary>
		public SparseGP f_marginal_F;
		public PointMass<SparseGP> prior_marginal;
		public PointMass<Vector[]> routineFeaturesTrain_marginal;
		public DistributionStructArray<Gaussian,double> observedCountsTrain_marginal;
		#endregion

		#region Properties
		/// <summary>The number of iterations done from the initial state</summary>
		public int NumberOfIterationsDone
		{			get {
				return this.numberOfIterationsDone;
			}
		}

		/// <summary>The externally-specified value of 'prior'</summary>
		public SparseGP prior
		{			get {
				return this.Prior;
			}
			set {
				this.Prior = value;
				this.numberOfIterationsDone = 0;
				this.Changed_prior_Init_numberOfIterationsDecreased_routineFeaturesTrain_observedCountsTrain_iterationsDone = 0;
				this.Changed_numberOfIterationsDecreased_prior_routineFeaturesTrain_observedCountsTrain_iterationsDone = 0;
				this.Changed_prior_routineFeaturesTrain_observedCountsTrain_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'routineFeaturesTrain'</summary>
		public Vector[] routineFeaturesTrain
		{			get {
				return this.RoutineFeaturesTrain;
			}
			set {
				if ((value!=null)&&(value.Length!=4031)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+4031)+" was expected for variable \'routineFeaturesTrain\'");
				}
				this.RoutineFeaturesTrain = value;
				this.numberOfIterationsDone = 0;
				this.Changed_prior_Init_numberOfIterationsDecreased_routineFeaturesTrain_observedCountsTrain_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_prior_routineFeaturesTrain_observedCountsTrain_iterationsDone = 0;
				this.Changed_prior_routineFeaturesTrain_observedCountsTrain_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'observedCountsTrain'</summary>
		public double[] observedCountsTrain
		{			get {
				return this.ObservedCountsTrain;
			}
			set {
				if ((value!=null)&&(value.Length!=4031)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+4031)+" was expected for variable \'observedCountsTrain\'");
				}
				this.ObservedCountsTrain = value;
				this.numberOfIterationsDone = 0;
				this.Changed_prior_Init_numberOfIterationsDecreased_routineFeaturesTrain_observedCountsTrain_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_prior_routineFeaturesTrain_observedCountsTrain_iterationsDone = 0;
				this.Changed_prior_routineFeaturesTrain_observedCountsTrain_iterationsDone = 0;
			}
		}

		#endregion

		#region Methods
		/// <summary>Get the observed value of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		public object GetObservedValue(string variableName)
		{
			if (variableName=="prior") {
				return this.prior;
			}
			if (variableName=="routineFeaturesTrain") {
				return this.routineFeaturesTrain;
			}
			if (variableName=="observedCountsTrain") {
				return this.observedCountsTrain;
			}
			throw new ArgumentException("Not an observed variable name: "+variableName);
		}

		/// <summary>Set the observed value of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		/// <param name="value">Observed value</param>
		public void SetObservedValue(string variableName, object value)
		{
			if (variableName=="prior") {
				this.prior = (SparseGP)value;
				return ;
			}
			if (variableName=="routineFeaturesTrain") {
				this.routineFeaturesTrain = (Vector[])value;
				return ;
			}
			if (variableName=="observedCountsTrain") {
				this.observedCountsTrain = (double[])value;
				return ;
			}
			throw new ArgumentException("Not an observed variable name: "+variableName);
		}

		/// <summary>The marginal distribution of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		public object Marginal(string variableName)
		{
			if (variableName=="f") {
				return this.FMarginal();
			}
			if (variableName=="prior") {
				return this.PriorMarginal();
			}
			if (variableName=="routineFeaturesTrain") {
				return this.RoutineFeaturesTrainMarginal();
			}
			if (variableName=="observedCountsTrain") {
				return this.ObservedCountsTrainMarginal();
			}
			throw new ArgumentException("This class was not built to infer "+variableName);
		}

		public T Marginal<T>(string variableName)
		{
			return Distribution.ChangeType<T>(this.Marginal(variableName));
		}

		/// <summary>The query-specific marginal distribution of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		/// <param name="query">QueryType name. For example, GibbsSampling answers 'Marginal', 'Samples', and 'Conditionals' queries</param>
		public object Marginal(string variableName, string query)
		{
			if (query=="Marginal") {
				return this.Marginal(variableName);
			}
			throw new ArgumentException(((("This class was not built to infer \'"+variableName)+"\' with query \'")+query)+"\'");
		}

		public T Marginal<T>(string variableName, string query)
		{
			return Distribution.ChangeType<T>(this.Marginal(variableName, query));
		}

		/// <summary>Update all marginals, by iterating message passing the given number of times</summary>
		/// <param name="numberOfIterations">The number of times to iterate each loop</param>
		/// <param name="initialise">If true, messages that initialise loops are reset when observed values change</param>
		private void Execute(int numberOfIterations, bool initialise)
		{
			if (numberOfIterations<this.Changed_numberOfIterationsDecreased_prior_routineFeaturesTrain_observedCountsTrain_iterationsDone) {
				this.Changed_prior_Init_numberOfIterationsDecreased_routineFeaturesTrain_observedCountsTrain_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_prior_routineFeaturesTrain_observedCountsTrain_iterationsDone = 0;
			}
			this.Constant();
			this.Changed_prior_Init_numberOfIterationsDecreased_routineFeaturesTrain_observedCountsTrain(initialise);
			this.Changed_numberOfIterationsDecreased_prior_routineFeaturesTrain_observedCountsTrain(numberOfIterations);
			this.Changed_prior_routineFeaturesTrain_observedCountsTrain();
			this.numberOfIterationsDone = numberOfIterations;
		}

		public void Execute(int numberOfIterations)
		{
			this.Execute(numberOfIterations, true);
		}

		public void Update(int additionalIterations)
		{
			this.Execute(this.numberOfIterationsDone+additionalIterations, false);
		}

		private void OnProgressChanged(ProgressChangedEventArgs e)
		{
			// Make a temporary copy of the event to avoid a race condition
			// if the last subscriber unsubscribes immediately after the null check and before the event is raised.
			EventHandler<ProgressChangedEventArgs> handler = this.ProgressChanged;
			if (handler!=null) {
				handler(this, e);
			}
		}

		/// <summary>Reset all messages to their initial values.  Sets NumberOfIterationsDone to 0.</summary>
		public void Reset()
		{
			this.Execute(0);
		}

		/// <summary>Computations that do not depend on observed values</summary>
		public void Constant()
		{
			if (this.Constant_iterationsDone==1) {
				return ;
			}
			// Create array for 'f_rep' Backwards messages.
			this.f_rep_B = new DistributionRefArray<SparseGP,IFunction>(4031);
			this.Constant_iterationsDone = 1;
			this.Changed_prior_Init_numberOfIterationsDecreased_routineFeaturesTrain_observedCountsTrain_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of prior and must reset on changes to numberOfIterationsDecreased and routineFeaturesTrain and observedCountsTrain</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_prior_Init_numberOfIterationsDecreased_routineFeaturesTrain_observedCountsTrain(bool initialise)
		{
			if ((this.Changed_prior_Init_numberOfIterationsDecreased_routineFeaturesTrain_observedCountsTrain_iterationsDone==1)&&((!initialise)||this.Changed_prior_Init_numberOfIterationsDecreased_routineFeaturesTrain_observedCountsTrain_isInitialised)) {
				return ;
			}
			for(int Ntrain = 0; Ntrain<4031; Ntrain++) {
				this.f_rep_B[Ntrain] = ArrayHelper.MakeUniform<SparseGP>(this.Prior);
			}
			// Message to 'f_rep' from Replicate factor
			this.f_rep_B_toDef = ReplicateOp_Divide.ToDefInit<SparseGP>(this.Prior);
			this.Changed_prior_Init_numberOfIterationsDecreased_routineFeaturesTrain_observedCountsTrain_iterationsDone = 1;
			this.Changed_prior_Init_numberOfIterationsDecreased_routineFeaturesTrain_observedCountsTrain_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_prior_routineFeaturesTrain_observedCountsTrain_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numberOfIterationsDecreased and prior and routineFeaturesTrain and observedCountsTrain</summary>
		/// <param name="numberOfIterations">The number of times to iterate each loop</param>
		public void Changed_numberOfIterationsDecreased_prior_routineFeaturesTrain_observedCountsTrain(int numberOfIterations)
		{
			if (this.Changed_numberOfIterationsDecreased_prior_routineFeaturesTrain_observedCountsTrain_iterationsDone==numberOfIterations) {
				return ;
			}
			// Buffer for ReplicateOp_Divide.UsesAverageConditional<SparseGP>
			SparseGP f_rep_F_marginal = default(SparseGP);
			// Message to 'f_rep' from Replicate factor
			f_rep_F_marginal = ReplicateOp_Divide.MarginalInit<SparseGP>(this.Prior);
			DistributionRefArray<SparseGP,IFunction> f_rep_F = default(DistributionRefArray<SparseGP,IFunction>);
			// Create array for 'f_rep' Forwards messages.
			f_rep_F = new DistributionRefArray<SparseGP,IFunction>(4031);
			for(int Ntrain = 0; Ntrain<4031; Ntrain++) {
				f_rep_F[Ntrain] = ArrayHelper.MakeUniform<SparseGP>(this.Prior);
			}
			// Create array for replicates of 'vdouble111_B'
			DistributionStructArray<Gaussian,double> vdouble111_B = new DistributionStructArray<Gaussian,double>(4031);
			for(int Ntrain = 0; Ntrain<4031; Ntrain++) {
				vdouble111_B[Ntrain] = Gaussian.Uniform();
				// Message to 'vdouble111' from GaussianFromMeanAndVariance factor
				vdouble111_B[Ntrain] = GaussianFromMeanAndVarianceOp.MeanAverageConditional(this.ObservedCountsTrain[Ntrain], 0.1);
			}
			for(int iteration = this.Changed_numberOfIterationsDecreased_prior_routineFeaturesTrain_observedCountsTrain_iterationsDone; iteration<numberOfIterations; iteration++) {
				// Message to 'f_rep' from Replicate factor
				f_rep_F_marginal = ReplicateOp_Divide.Marginal<SparseGP>(this.f_rep_B_toDef, this.Prior, f_rep_F_marginal);
				for(int Ntrain = 0; Ntrain<4031; Ntrain++) {
					// Message to 'f_rep' from Replicate factor
					f_rep_F[Ntrain] = ReplicateOp_Divide.UsesAverageConditional<SparseGP>(this.f_rep_B[Ntrain], f_rep_F_marginal, Ntrain, f_rep_F[Ntrain]);
					// Message to 'f_rep' from FunctionEvaluate factor
					this.f_rep_B[Ntrain] = SparseGPOp.FuncAverageConditional(vdouble111_B[Ntrain], f_rep_F[Ntrain], this.RoutineFeaturesTrain[Ntrain], this.f_rep_B[Ntrain]);
				}
				// Message to 'f_rep' from Replicate factor
				this.f_rep_B_toDef = ReplicateOp_Divide.ToDef<SparseGP>(this.f_rep_B, this.f_rep_B_toDef);
				this.OnProgressChanged(new ProgressChangedEventArgs(iteration));
			}
			this.f_marginal_F = ArrayHelper.MakeUniform<SparseGP>(this.Prior);
			// Message to 'f_marginal' from Variable factor
			this.f_marginal_F = VariableOp.MarginalAverageConditional<SparseGP>(this.f_rep_B_toDef, this.Prior, this.f_marginal_F);
			this.Changed_numberOfIterationsDecreased_prior_routineFeaturesTrain_observedCountsTrain_iterationsDone = numberOfIterations;
		}

		/// <summary>
		/// Returns the marginal distribution for 'f' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public SparseGP FMarginal()
		{
			return this.f_marginal_F;
		}

		/// <summary>Computations that depend on the observed value of prior and routineFeaturesTrain and observedCountsTrain</summary>
		public void Changed_prior_routineFeaturesTrain_observedCountsTrain()
		{
			if (this.Changed_prior_routineFeaturesTrain_observedCountsTrain_iterationsDone==1) {
				return ;
			}
			this.prior_marginal = new PointMass<SparseGP>(this.Prior);
			this.routineFeaturesTrain_marginal = new PointMass<Vector[]>(this.RoutineFeaturesTrain);
			this.observedCountsTrain_marginal = new DistributionStructArray<Gaussian,double>(4031, delegate(int Ntrain) {
				return Gaussian.Uniform();
			});
			this.observedCountsTrain_marginal = Distribution.SetPoint<DistributionStructArray<Gaussian,double>,double[]>(this.observedCountsTrain_marginal, this.ObservedCountsTrain);
			this.Changed_prior_routineFeaturesTrain_observedCountsTrain_iterationsDone = 1;
		}

		/// <summary>
		/// Returns the marginal distribution for 'prior' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<SparseGP> PriorMarginal()
		{
			return this.prior_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'routineFeaturesTrain' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<Vector[]> RoutineFeaturesTrainMarginal()
		{
			return this.routineFeaturesTrain_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'observedCountsTrain' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionStructArray<Gaussian,double> ObservedCountsTrainMarginal()
		{
			return this.observedCountsTrain_marginal;
		}

		#endregion

		#region Events
		/// <summary>Event that is fired when the progress of inference changes, typically at the end of one iteration of the inference algorithm.</summary>
		public event EventHandler<ProgressChangedEventArgs> ProgressChanged;
		#endregion

	}

}
