using System;
using MicrosoftResearch.Infer;
using MicrosoftResearch.Infer.Distributions;
using MicrosoftResearch.Infer.Factors;
using MicrosoftResearch.Infer.Collections;

namespace MicrosoftResearch.Infer.Models.User
{
	/// <summary>
	/// Generated algorithm for performing inference
	/// </summary>
	/// <remarks>
	/// The easiest way to use this class is to wrap an instance in a CompiledAlgorithm object and use
	/// the methods on CompiledAlgorithm to set parameters and execute inference.
	/// 
	/// If you instead wish to use this class directly, you must perform the following steps:
	/// 1) Create an instance of the class
	/// 2) Set the value of any externally-set fields e.g. data, priors
	/// 3) Call the Execute(numberOfIterations) method
	/// 4) Use the XXXMarginal() methods to retrieve posterior marginals for different variables.
	/// 
	/// Generated by Infer.NET 2.5 at 14:40 on sábado, 27 de Julho de 2013.
	/// </remarks>
	public partial class Model8_EP : IGeneratedAlgorithm
	{
		#region Fields
		/// <summary>Field backing the NumberOfIterationsDone property</summary>
		private int numberOfIterationsDone;
		/// <summary>Field backing the numItems property</summary>
		private int NumItems;
		/// <summary>Field backing the numFeaturesPerItem property</summary>
		private int[] NumFeaturesPerItem;
		/// <summary>Field backing the wPrior property</summary>
		private DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> WPrior;
		/// <summary>Field backing the noisePrecision property</summary>
		private double NoisePrecision;
		/// <summary>Field backing the values property</summary>
		private double[][] Values;
		/// <summary>Field backing the indices property</summary>
		private int[][] Indices;
		/// <summary>The number of iterations last computed by Changed_numItems_numFeaturesPerItem_wPrior_noisePrecision_values_indices. Set this to zero to force re-execution of Changed_numItems_numFeaturesPerItem_wPrior_noisePrecision_values_indices</summary>
		public int Changed_numItems_numFeaturesPerItem_wPrior_noisePrecision_values_indices_iterationsDone;
		/// <summary>The number of iterations last computed by Constant. Set this to zero to force re-execution of Constant</summary>
		public int Constant_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_wPrior_Init_numberOfIterationsDecreased_indices_numItems_numFeaturesPerItem_values_noisePrec2. Set this to zero to force re-execution of Changed_wPrior_Init_numberOfIterationsDecreased_indices_numItems_numFeaturesPerItem_values_noisePrec2</summary>
		public int Changed_wPrior_Init_numberOfIterationsDecreased_indices_numItems_numFeaturesPerItem_values_noisePrec2_iterationsDone;
		/// <summary>True if Changed_wPrior_Init_numberOfIterationsDecreased_indices_numItems_numFeaturesPerItem_values_noisePrec2 has performed initialisation. Set this to false to force re-execution of Changed_wPrior_Init_numberOfIterationsDecreased_indices_numItems_numFeaturesPerItem_values_noisePrec2</summary>
		public bool Changed_wPrior_Init_numberOfIterationsDecreased_indices_numItems_numFeaturesPerItem_values_noisePrec2_isInitialised;
		/// <summary>The number of iterations last computed by Changed_numItems. Set this to zero to force re-execution of Changed_numItems</summary>
		public int Changed_numItems_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_numItems_numFeaturesPerItem. Set this to zero to force re-execution of Changed_numItems_numFeaturesPerItem</summary>
		public int Changed_numItems_numFeaturesPerItem_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_numItems_numFeaturesPerItem_Init_numberOfIterationsDecreased_wPrior_indices_values_noisePrec5. Set this to zero to force re-execution of Changed_numItems_numFeaturesPerItem_Init_numberOfIterationsDecreased_wPrior_indices_values_noisePrec5</summary>
		public int Changed_numItems_numFeaturesPerItem_Init_numberOfIterationsDecreased_wPrior_indices_values_noisePrec5_iterationsDone;
		/// <summary>True if Changed_numItems_numFeaturesPerItem_Init_numberOfIterationsDecreased_wPrior_indices_values_noisePrec5 has performed initialisation. Set this to false to force re-execution of Changed_numItems_numFeaturesPerItem_Init_numberOfIterationsDecreased_wPrior_indices_values_noisePrec5</summary>
		public bool Changed_numItems_numFeaturesPerItem_Init_numberOfIterationsDecreased_wPrior_indices_values_noisePrec5_isInitialised;
		/// <summary>The number of iterations last computed by Changed_numberOfIterationsDecreased_wPrior_indices_numItems_numFeaturesPerItem_values_noisePrecision. Set this to zero to force re-execution of Changed_numberOfIterationsDecreased_wPrior_indices_numItems_numFeaturesPerItem_values_noisePrecision</summary>
		public int Changed_numberOfIterationsDecreased_wPrior_indices_numItems_numFeaturesPerItem_values_noisePrecision_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_numItems_Init_numberOfIterationsDecreased_wPrior_indices_numFeaturesPerItem_values_noisePrec7. Set this to zero to force re-execution of Changed_numItems_Init_numberOfIterationsDecreased_wPrior_indices_numFeaturesPerItem_values_noisePrec7</summary>
		public int Changed_numItems_Init_numberOfIterationsDecreased_wPrior_indices_numFeaturesPerItem_values_noisePrec7_iterationsDone;
		/// <summary>True if Changed_numItems_Init_numberOfIterationsDecreased_wPrior_indices_numFeaturesPerItem_values_noisePrec7 has performed initialisation. Set this to false to force re-execution of Changed_numItems_Init_numberOfIterationsDecreased_wPrior_indices_numFeaturesPerItem_values_noisePrec7</summary>
		public bool Changed_numItems_Init_numberOfIterationsDecreased_wPrior_indices_numFeaturesPerItem_values_noisePrec7_isInitialised;
		/// <summary>Buffer for JaggedSubarrayOp<double>.ItemsAverageConditional<DistributionStructArray<Gaussian,double>,Gaussian,DistributionStructArray<Gaussian,double>></summary>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> wModel_use_F_k__marginal;
		public DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]> wModel_indices_B;
		public DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]> wSparse_B;
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> scorePlusNoise_F;
		public DistributionRefArray<DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]>,double[][][]> scorePlusNoise_k_cond_y_i__index44_rep_F;
		public DistributionStructArray<Gaussian,double>[][][][] scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<Gaussian></summary>
		public DistributionRefArray<DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]>,double[][][]> scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B__gi__toDef;
		public DistributionRefArray<DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]>,double[][][]> scorePlusNoise_k_cond_y_i__index44_rep_B;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<Gaussian></summary>
		public DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]> scorePlusNoise_k_cond_y_i__index44_rep_B_toDef;
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> _hoist6;
		/// <summary>Message to marginal of 'wModel'</summary>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> wModel_marginal_F;
		/// <summary>Message from use of 'wModel'</summary>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> wModel_use_B;
		/// <summary>Message to marginal of 'y'</summary>
		public DistributionRefArray<Discrete,int> y_marginal_F;
		public PointMass<int> numItems_marginal;
		public PointMass<int[]> numFeaturesPerItem_marginal;
		public PointMass<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>> wPrior_marginal;
		public Gaussian noisePrecision_marginal;
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> values_marginal;
		public PointMass<int[][]> indices_marginal;
		#endregion

		#region Properties
		/// <summary>The number of iterations done from the initial state</summary>
		public int NumberOfIterationsDone
		{			get {
				return this.numberOfIterationsDone;
			}
		}

		/// <summary>The externally-specified value of 'numItems'</summary>
		public int numItems
		{			get {
				return this.NumItems;
			}
			set {
				if (this.NumItems!=value) {
					this.NumItems = value;
					this.numberOfIterationsDone = 0;
					this.Changed_numItems_iterationsDone = 0;
					this.Changed_numItems_Init_numberOfIterationsDecreased_wPrior_indices_numFeaturesPerItem_values_noisePrec7_iterationsDone = 0;
					this.Changed_numItems_numFeaturesPerItem_iterationsDone = 0;
					this.Changed_numItems_numFeaturesPerItem_Init_numberOfIterationsDecreased_wPrior_indices_values_noisePrec5_iterationsDone = 0;
					this.Changed_wPrior_Init_numberOfIterationsDecreased_indices_numItems_numFeaturesPerItem_values_noisePrec2_isInitialised = false;
					this.Changed_numberOfIterationsDecreased_wPrior_indices_numItems_numFeaturesPerItem_values_noisePrecision_iterationsDone = 0;
					this.Changed_numItems_numFeaturesPerItem_wPrior_noisePrecision_values_indices_iterationsDone = 0;
				}
			}
		}

		/// <summary>The externally-specified value of 'numFeaturesPerItem'</summary>
		public int[] numFeaturesPerItem
		{			get {
				return this.NumFeaturesPerItem;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumItems)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumItems)+" was expected for variable \'numFeaturesPerItem\'");
				}
				this.NumFeaturesPerItem = value;
				this.numberOfIterationsDone = 0;
				this.Changed_numItems_Init_numberOfIterationsDecreased_wPrior_indices_numFeaturesPerItem_values_noisePrec7_isInitialised = false;
				this.Changed_numItems_numFeaturesPerItem_iterationsDone = 0;
				this.Changed_numItems_numFeaturesPerItem_Init_numberOfIterationsDecreased_wPrior_indices_values_noisePrec5_iterationsDone = 0;
				this.Changed_wPrior_Init_numberOfIterationsDecreased_indices_numItems_numFeaturesPerItem_values_noisePrec2_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_wPrior_indices_numItems_numFeaturesPerItem_values_noisePrecision_iterationsDone = 0;
				this.Changed_numItems_numFeaturesPerItem_wPrior_noisePrecision_values_indices_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'wPrior'</summary>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> wPrior
		{			get {
				return this.WPrior;
			}
			set {
				this.WPrior = value;
				this.numberOfIterationsDone = 0;
				this.Changed_numItems_Init_numberOfIterationsDecreased_wPrior_indices_numFeaturesPerItem_values_noisePrec7_isInitialised = false;
				this.Changed_numItems_numFeaturesPerItem_Init_numberOfIterationsDecreased_wPrior_indices_values_noisePrec5_isInitialised = false;
				this.Changed_wPrior_Init_numberOfIterationsDecreased_indices_numItems_numFeaturesPerItem_values_noisePrec2_iterationsDone = 0;
				this.Changed_numberOfIterationsDecreased_wPrior_indices_numItems_numFeaturesPerItem_values_noisePrecision_iterationsDone = 0;
				this.Changed_numItems_numFeaturesPerItem_wPrior_noisePrecision_values_indices_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'noisePrecision'</summary>
		public double noisePrecision
		{			get {
				return this.NoisePrecision;
			}
			set {
				if (this.NoisePrecision!=value) {
					this.NoisePrecision = value;
					this.numberOfIterationsDone = 0;
					this.Changed_numItems_Init_numberOfIterationsDecreased_wPrior_indices_numFeaturesPerItem_values_noisePrec7_isInitialised = false;
					this.Changed_numItems_numFeaturesPerItem_Init_numberOfIterationsDecreased_wPrior_indices_values_noisePrec5_isInitialised = false;
					this.Changed_wPrior_Init_numberOfIterationsDecreased_indices_numItems_numFeaturesPerItem_values_noisePrec2_isInitialised = false;
					this.Changed_numberOfIterationsDecreased_wPrior_indices_numItems_numFeaturesPerItem_values_noisePrecision_iterationsDone = 0;
					this.Changed_numItems_numFeaturesPerItem_wPrior_noisePrecision_values_indices_iterationsDone = 0;
				}
			}
		}

		/// <summary>The externally-specified value of 'values'</summary>
		public double[][] values
		{			get {
				return this.Values;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumItems)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumItems)+" was expected for variable \'values\'");
				}
				this.Values = value;
				this.numberOfIterationsDone = 0;
				this.Changed_numItems_Init_numberOfIterationsDecreased_wPrior_indices_numFeaturesPerItem_values_noisePrec7_isInitialised = false;
				this.Changed_numItems_numFeaturesPerItem_Init_numberOfIterationsDecreased_wPrior_indices_values_noisePrec5_isInitialised = false;
				this.Changed_wPrior_Init_numberOfIterationsDecreased_indices_numItems_numFeaturesPerItem_values_noisePrec2_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_wPrior_indices_numItems_numFeaturesPerItem_values_noisePrecision_iterationsDone = 0;
				this.Changed_numItems_numFeaturesPerItem_wPrior_noisePrecision_values_indices_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'indices'</summary>
		public int[][] indices
		{			get {
				return this.Indices;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumItems)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumItems)+" was expected for variable \'indices\'");
				}
				this.Indices = value;
				this.numberOfIterationsDone = 0;
				this.Changed_numItems_Init_numberOfIterationsDecreased_wPrior_indices_numFeaturesPerItem_values_noisePrec7_isInitialised = false;
				this.Changed_numItems_numFeaturesPerItem_Init_numberOfIterationsDecreased_wPrior_indices_values_noisePrec5_isInitialised = false;
				this.Changed_wPrior_Init_numberOfIterationsDecreased_indices_numItems_numFeaturesPerItem_values_noisePrec2_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_wPrior_indices_numItems_numFeaturesPerItem_values_noisePrecision_iterationsDone = 0;
				this.Changed_numItems_numFeaturesPerItem_wPrior_noisePrecision_values_indices_iterationsDone = 0;
			}
		}

		#endregion

		#region Methods
		/// <summary>Get the observed value of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		public object GetObservedValue(string variableName)
		{
			if (variableName=="numItems") {
				return this.numItems;
			}
			if (variableName=="numFeaturesPerItem") {
				return this.numFeaturesPerItem;
			}
			if (variableName=="wPrior") {
				return this.wPrior;
			}
			if (variableName=="noisePrecision") {
				return this.noisePrecision;
			}
			if (variableName=="values") {
				return this.values;
			}
			if (variableName=="indices") {
				return this.indices;
			}
			throw new ArgumentException("Not an observed variable name: "+variableName);
		}

		/// <summary>Set the observed value of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		/// <param name="value">Observed value</param>
		public void SetObservedValue(string variableName, object value)
		{
			if (variableName=="numItems") {
				this.numItems = (int)value;
				return ;
			}
			if (variableName=="numFeaturesPerItem") {
				this.numFeaturesPerItem = (int[])value;
				return ;
			}
			if (variableName=="wPrior") {
				this.wPrior = (DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>)value;
				return ;
			}
			if (variableName=="noisePrecision") {
				this.noisePrecision = (double)value;
				return ;
			}
			if (variableName=="values") {
				this.values = (double[][])value;
				return ;
			}
			if (variableName=="indices") {
				this.indices = (int[][])value;
				return ;
			}
			throw new ArgumentException("Not an observed variable name: "+variableName);
		}

		/// <summary>The marginal distribution of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		public object Marginal(string variableName)
		{
			if (variableName=="wModel") {
				return this.WModelMarginal();
			}
			if (variableName=="y") {
				return this.YMarginal();
			}
			if (variableName=="numItems") {
				return this.NumItemsMarginal();
			}
			if (variableName=="numFeaturesPerItem") {
				return this.NumFeaturesPerItemMarginal();
			}
			if (variableName=="wPrior") {
				return this.WPriorMarginal();
			}
			if (variableName=="noisePrecision") {
				return this.NoisePrecisionMarginal();
			}
			if (variableName=="values") {
				return this.ValuesMarginal();
			}
			if (variableName=="indices") {
				return this.IndicesMarginal();
			}
			throw new ArgumentException("This class was not built to infer "+variableName);
		}

		public T Marginal<T>(string variableName)
		{
			return Distribution.ChangeType<T>(this.Marginal(variableName));
		}

		/// <summary>The query-specific marginal distribution of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		/// <param name="query">QueryType name. For example, GibbsSampling answers 'Marginal', 'Samples', and 'Conditionals' queries</param>
		public object Marginal(string variableName, string query)
		{
			if (query=="Marginal") {
				return this.Marginal(variableName);
			}
			if ((variableName=="wModel")&&(query=="MarginalDividedByPrior")) {
				return this.WModelMarginalDividedByPrior();
			}
			throw new ArgumentException(((("This class was not built to infer \'"+variableName)+"\' with query \'")+query)+"\'");
		}

		public T Marginal<T>(string variableName, string query)
		{
			return Distribution.ChangeType<T>(this.Marginal(variableName, query));
		}

		/// <summary>Update all marginals, by iterating message passing the given number of times</summary>
		/// <param name="numberOfIterations">The number of times to iterate each loop</param>
		/// <param name="initialise">If true, messages that initialise loops are reset when observed values change</param>
		private void Execute(int numberOfIterations, bool initialise)
		{
			if (numberOfIterations<this.Changed_numberOfIterationsDecreased_wPrior_indices_numItems_numFeaturesPerItem_values_noisePrecision_iterationsDone) {
				this.Changed_numItems_Init_numberOfIterationsDecreased_wPrior_indices_numFeaturesPerItem_values_noisePrec7_isInitialised = false;
				this.Changed_numItems_numFeaturesPerItem_Init_numberOfIterationsDecreased_wPrior_indices_values_noisePrec5_isInitialised = false;
				this.Changed_wPrior_Init_numberOfIterationsDecreased_indices_numItems_numFeaturesPerItem_values_noisePrec2_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_wPrior_indices_numItems_numFeaturesPerItem_values_noisePrecision_iterationsDone = 0;
			}
			this.Constant();
			this.Changed_numItems();
			this.Changed_numItems_Init_numberOfIterationsDecreased_wPrior_indices_numFeaturesPerItem_values_noisePrec7(initialise);
			this.Changed_numItems_numFeaturesPerItem();
			this.Changed_numItems_numFeaturesPerItem_Init_numberOfIterationsDecreased_wPrior_indices_values_noisePrec5(initialise);
			this.Changed_wPrior_Init_numberOfIterationsDecreased_indices_numItems_numFeaturesPerItem_values_noisePrec2(initialise);
			this.Changed_numberOfIterationsDecreased_wPrior_indices_numItems_numFeaturesPerItem_values_noisePrecision(numberOfIterations);
			this.Changed_numItems_numFeaturesPerItem_wPrior_noisePrecision_values_indices();
			this.numberOfIterationsDone = numberOfIterations;
		}

		public void Execute(int numberOfIterations)
		{
			this.Execute(numberOfIterations, true);
		}

		public void Update(int additionalIterations)
		{
			this.Execute(this.numberOfIterationsDone+additionalIterations, false);
		}

		private void OnProgressChanged(ProgressChangedEventArgs e)
		{
			// Make a temporary copy of the event to avoid a race condition
			// if the last subscriber unsubscribes immediately after the null check and before the event is raised.
			EventHandler<ProgressChangedEventArgs> handler = this.ProgressChanged;
			if (handler!=null) {
				handler(this, e);
			}
		}

		/// <summary>Reset all messages to their initial values.  Sets NumberOfIterationsDone to 0.</summary>
		public void Reset()
		{
			this.Execute(0);
		}

		/// <summary>Computations that do not depend on observed values</summary>
		public void Constant()
		{
			if (this.Constant_iterationsDone==1) {
				return ;
			}
			// Create array for replicates of 'wModel_use_F_k__marginal'
			this.wModel_use_F_k__marginal = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(3);
			// Create array for replicates of 'wModel_indices_B'
			this.wModel_indices_B = new DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]>(3);
			this.Constant_iterationsDone = 1;
			this.Changed_wPrior_Init_numberOfIterationsDecreased_indices_numItems_numFeaturesPerItem_values_noisePrec2_iterationsDone = 0;
			this.Changed_numItems_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numItems</summary>
		public void Changed_numItems()
		{
			if (this.Changed_numItems_iterationsDone==1) {
				return ;
			}
			// Create array for replicates of 'wSparse_B'
			this.wSparse_B = new DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for 'wSparse' Backwards messages.
				this.wSparse_B[i] = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(3);
			}
			// Create array for replicates of 'scorePlusNoise_F'
			this.scorePlusNoise_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for 'scorePlusNoise' Forwards messages.
				this.scorePlusNoise_F[i] = new DistributionStructArray<Gaussian,double>(3);
				for(int k = 0; k<3; k++) {
					this.scorePlusNoise_F[i][k] = Gaussian.Uniform();
				}
			}
			// Create array for replicates of 'scorePlusNoise_k_cond_y_i__index44_rep_F'
			this.scorePlusNoise_k_cond_y_i__index44_rep_F = new DistributionRefArray<DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]>,double[][][]>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for replicates of 'scorePlusNoise_k_cond_y_i__index44_rep_F'
				this.scorePlusNoise_k_cond_y_i__index44_rep_F[i] = new DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]>(3);
				for(int index44 = 0; index44<3; index44++) {
					// Create array for replicates of 'scorePlusNoise_k_cond_y_i__index44_rep_F'
					this.scorePlusNoise_k_cond_y_i__index44_rep_F[i][index44] = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(3);
					for(int _gi = 0; _gi<3; _gi++) {
						// Create array for 'scorePlusNoise_k_cond_y_i__index44_rep' Forwards messages.
						this.scorePlusNoise_k_cond_y_i__index44_rep_F[i][index44][_gi] = new DistributionStructArray<Gaussian,double>(3);
						for(int _a = 0; _a<3; _a++) {
							this.scorePlusNoise_k_cond_y_i__index44_rep_F[i][index44][_gi][_a] = Gaussian.Uniform();
						}
					}
				}
			}
			// Create array for replicates of 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B'
			this.scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B = new DistributionStructArray<Gaussian,double>[this.NumItems][][][];
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for replicates of 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B'
				this.scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B[i] = new DistributionStructArray<Gaussian,double>[3][][];
				for(int index44 = 0; index44<3; index44++) {
					// Create array for replicates of 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B'
					this.scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B[i][index44] = new DistributionStructArray<Gaussian,double>[3][];
					for(int k = 0; k<3; k++) {
						if (!(k==index44)) {
							// Create array for 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses' Backwards messages.
							this.scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B[i][index44][k] = new DistributionStructArray<Gaussian,double>[3];
							for(int _gi = 0; _gi<3; _gi++) {
								// Create array for 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses' Backwards messages.
								this.scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B[i][index44][k][_gi] = new DistributionStructArray<Gaussian,double>(2);
							}
						}
					}
				}
			}
			// Create array for replicates of 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B__gi__toDef'
			this.scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B__gi__toDef = new DistributionRefArray<DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]>,double[][][]>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for replicates of 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B__gi__toDef'
				this.scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B__gi__toDef[i] = new DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]>(3);
				for(int index44 = 0; index44<3; index44++) {
					// Create array for replicates of 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B__gi__toDef'
					this.scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B__gi__toDef[i][index44] = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(3);
					for(int k = 0; k<3; k++) {
						if (!(k==index44)) {
							// Create array for replicates of 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B__gi__toDef'
							this.scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B__gi__toDef[i][index44][k] = new DistributionStructArray<Gaussian,double>(3);
						}
					}
				}
			}
			// Create array for replicates of 'scorePlusNoise_k_cond_y_i__index44_rep_B'
			this.scorePlusNoise_k_cond_y_i__index44_rep_B = new DistributionRefArray<DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]>,double[][][]>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for replicates of 'scorePlusNoise_k_cond_y_i__index44_rep_B'
				this.scorePlusNoise_k_cond_y_i__index44_rep_B[i] = new DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]>(3);
				for(int index44 = 0; index44<3; index44++) {
					// Create array for replicates of 'scorePlusNoise_k_cond_y_i__index44_rep_B'
					this.scorePlusNoise_k_cond_y_i__index44_rep_B[i][index44] = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(3);
					for(int _gi = 0; _gi<3; _gi++) {
						// Create array for 'scorePlusNoise_k_cond_y_i__index44_rep' Backwards messages.
						this.scorePlusNoise_k_cond_y_i__index44_rep_B[i][index44][_gi] = new DistributionStructArray<Gaussian,double>(3);
					}
				}
			}
			// Create array for replicates of 'scorePlusNoise_k_cond_y_i__index44_rep_B_toDef'
			this.scorePlusNoise_k_cond_y_i__index44_rep_B_toDef = new DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for replicates of 'scorePlusNoise_k_cond_y_i__index44_rep_B_toDef'
				this.scorePlusNoise_k_cond_y_i__index44_rep_B_toDef[i] = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(3);
				for(int index44 = 0; index44<3; index44++) {
					// Create array for replicates of 'scorePlusNoise_k_cond_y_i__index44_rep_B_toDef'
					this.scorePlusNoise_k_cond_y_i__index44_rep_B_toDef[i][index44] = new DistributionStructArray<Gaussian,double>(3);
				}
			}
			// Create array for replicates of '_hoist6'
			this._hoist6 = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for replicates of '_hoist6'
				this._hoist6[i] = new DistributionStructArray<Gaussian,double>(3);
				for(int _gi = 0; _gi<3; _gi++) {
					this._hoist6[i][_gi] = ReplicateOp_Divide.ToDefInit<Gaussian>(this.scorePlusNoise_F[i][_gi]);
				}
			}
			for(int k = 0; k<3; k++) {
				// Create array for 'wModel_indices' Backwards messages.
				this.wModel_indices_B[k] = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumItems);
			}
			this.Changed_numItems_iterationsDone = 1;
			this.Changed_numItems_numFeaturesPerItem_iterationsDone = 0;
			this.Changed_numberOfIterationsDecreased_wPrior_indices_numItems_numFeaturesPerItem_values_noisePrecision_iterationsDone = 0;
			this.Changed_numItems_Init_numberOfIterationsDecreased_wPrior_indices_numFeaturesPerItem_values_noisePrec7_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numItems and must reset on changes to numberOfIterationsDecreased and wPrior and indices and numFeaturesPerItem and values and noisePrecision</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_numItems_Init_numberOfIterationsDecreased_wPrior_indices_numFeaturesPerItem_values_noisePrec7(bool initialise)
		{
			if ((this.Changed_numItems_Init_numberOfIterationsDecreased_wPrior_indices_numFeaturesPerItem_values_noisePrec7_iterationsDone==1)&&((!initialise)||this.Changed_numItems_Init_numberOfIterationsDecreased_wPrior_indices_numFeaturesPerItem_values_noisePrec7_isInitialised)) {
				return ;
			}
			for(int i = 0; i<this.NumItems; i++) {
				for(int index44 = 0; index44<3; index44++) {
					for(int k = 0; k<3; k++) {
						if (!(k==index44)) {
							for(int _gi = 0; _gi<3; _gi++) {
								for(int _ind = 0; _ind<2; _ind++) {
									this.scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B[i][index44][k][_gi][_ind] = Gaussian.Uniform();
								}
								// Message to 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses' from Replicate factor
								this.scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B__gi__toDef[i][index44][k][_gi] = ReplicateOp_Divide.ToDefInit<Gaussian>(this.scorePlusNoise_k_cond_y_i__index44_rep_F[i][index44][_gi][k]);
							}
						}
					}
					for(int _gi = 0; _gi<3; _gi++) {
						for(int _a = 0; _a<3; _a++) {
							this.scorePlusNoise_k_cond_y_i__index44_rep_B[i][index44][_gi][_a] = Gaussian.Uniform();
						}
						this.scorePlusNoise_k_cond_y_i__index44_rep_B_toDef[i][index44][_gi] = ArrayHelper.CopyStorage<Gaussian>(this._hoist6[i][_gi]);
					}
				}
			}
			this.Changed_numItems_Init_numberOfIterationsDecreased_wPrior_indices_numFeaturesPerItem_values_noisePrec7_iterationsDone = 1;
			this.Changed_numItems_Init_numberOfIterationsDecreased_wPrior_indices_numFeaturesPerItem_values_noisePrec7_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_wPrior_indices_numItems_numFeaturesPerItem_values_noisePrecision_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numItems and numFeaturesPerItem</summary>
		public void Changed_numItems_numFeaturesPerItem()
		{
			if (this.Changed_numItems_numFeaturesPerItem_iterationsDone==1) {
				return ;
			}
			for(int i = 0; i<this.NumItems; i++) {
				for(int k = 0; k<3; k++) {
					// Create array for 'wSparse' Backwards messages.
					this.wSparse_B[i][k] = new DistributionStructArray<Gaussian,double>(this.NumFeaturesPerItem[i]);
					// Create array for 'wModel_indices' Backwards messages.
					this.wModel_indices_B[k][i] = new DistributionStructArray<Gaussian,double>(this.NumFeaturesPerItem[i]);
				}
			}
			this.Changed_numItems_numFeaturesPerItem_iterationsDone = 1;
			this.Changed_numItems_numFeaturesPerItem_Init_numberOfIterationsDecreased_wPrior_indices_values_noisePrec5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numItems and numFeaturesPerItem and must reset on changes to numberOfIterationsDecreased and wPrior and indices and values and noisePrecision</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_numItems_numFeaturesPerItem_Init_numberOfIterationsDecreased_wPrior_indices_values_noisePrec5(bool initialise)
		{
			if ((this.Changed_numItems_numFeaturesPerItem_Init_numberOfIterationsDecreased_wPrior_indices_values_noisePrec5_iterationsDone==1)&&((!initialise)||this.Changed_numItems_numFeaturesPerItem_Init_numberOfIterationsDecreased_wPrior_indices_values_noisePrec5_isInitialised)) {
				return ;
			}
			for(int i = 0; i<this.NumItems; i++) {
				for(int k = 0; k<3; k++) {
					for(int fItem = 0; fItem<this.NumFeaturesPerItem[i]; fItem++) {
						this.wSparse_B[i][k][fItem] = Gaussian.Uniform();
						this.wModel_indices_B[k][i][fItem] = Gaussian.Uniform();
					}
				}
			}
			this.Changed_numItems_numFeaturesPerItem_Init_numberOfIterationsDecreased_wPrior_indices_values_noisePrec5_iterationsDone = 1;
			this.Changed_numItems_numFeaturesPerItem_Init_numberOfIterationsDecreased_wPrior_indices_values_noisePrec5_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_wPrior_indices_numItems_numFeaturesPerItem_values_noisePrecision_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of wPrior and must reset on changes to numberOfIterationsDecreased and indices and numItems and numFeaturesPerItem and values and noisePrecision</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_wPrior_Init_numberOfIterationsDecreased_indices_numItems_numFeaturesPerItem_values_noisePrec2(bool initialise)
		{
			if ((this.Changed_wPrior_Init_numberOfIterationsDecreased_indices_numItems_numFeaturesPerItem_values_noisePrec2_iterationsDone==1)&&((!initialise)||this.Changed_wPrior_Init_numberOfIterationsDecreased_indices_numItems_numFeaturesPerItem_values_noisePrec2_isInitialised)) {
				return ;
			}
			for(int k = 0; k<3; k++) {
				// Message to 'wModel_indices' from JaggedSubarray factor
				this.wModel_use_F_k__marginal[k] = JaggedSubarrayOp<double>.MarginalInit<DistributionStructArray<Gaussian,double>>(this.WPrior[k]);
			}
			this.Changed_wPrior_Init_numberOfIterationsDecreased_indices_numItems_numFeaturesPerItem_values_noisePrec2_iterationsDone = 1;
			this.Changed_wPrior_Init_numberOfIterationsDecreased_indices_numItems_numFeaturesPerItem_values_noisePrec2_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_wPrior_indices_numItems_numFeaturesPerItem_values_noisePrecision_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numberOfIterationsDecreased and wPrior and indices and numItems and numFeaturesPerItem and values and noisePrecision</summary>
		/// <param name="numberOfIterations">The number of times to iterate each loop</param>
		public void Changed_numberOfIterationsDecreased_wPrior_indices_numItems_numFeaturesPerItem_values_noisePrecision(int numberOfIterations)
		{
			if (this.Changed_numberOfIterationsDecreased_wPrior_indices_numItems_numFeaturesPerItem_values_noisePrecision_iterationsDone==numberOfIterations) {
				return ;
			}
			// Create array for replicates of 'wModel_indices_F'
			DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]> wModel_indices_F = new DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]>(3);
			for(int k = 0; k<3; k++) {
				// Create array for 'wModel_indices' Forwards messages.
				wModel_indices_F[k] = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumItems);
			}
			for(int i = 0; i<this.NumItems; i++) {
				for(int k = 0; k<3; k++) {
					// Create array for 'wModel_indices' Forwards messages.
					wModel_indices_F[k][i] = new DistributionStructArray<Gaussian,double>(this.NumFeaturesPerItem[i]);
					for(int fItem = 0; fItem<this.NumFeaturesPerItem[i]; fItem++) {
						wModel_indices_F[k][i][fItem] = Gaussian.Uniform();
					}
				}
			}
			// Create array for replicates of 'product_F'
			DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]> product_F = new DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for 'product' Forwards messages.
				product_F[i] = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(3);
				for(int k = 0; k<3; k++) {
					// Create array for 'product' Forwards messages.
					product_F[i][k] = new DistributionStructArray<Gaussian,double>(this.NumFeaturesPerItem[i]);
					for(int fItem = 0; fItem<this.NumFeaturesPerItem[i]; fItem++) {
						product_F[i][k][fItem] = Gaussian.Uniform();
					}
				}
			}
			// Create array for replicates of 'score_F'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> score_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for 'score' Forwards messages.
				score_F[i] = new DistributionStructArray<Gaussian,double>(3);
				for(int k = 0; k<3; k++) {
					score_F[i][k] = Gaussian.Uniform();
				}
			}
			DistributionRefArray<Discrete,int> y_F = default(DistributionRefArray<Discrete,int>);
			// Create array for 'y' Forwards messages.
			y_F = new DistributionRefArray<Discrete,int>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				y_F[i] = ArrayHelper.MakeUniform<Discrete>(Discrete.Uniform(3));
			}
			Discrete _hoist = default(Discrete);
			for(int i = 0; i<this.NumItems; i++) {
				_hoist = ArrayHelper.CopyStorage<Discrete>(y_F[i]);
				i = this.NumItems-1;
			}
			for(int i = 0; i<this.NumItems; i++) {
				_hoist = DiscreteUniform.SampleAverageConditional(3, _hoist);
				i = this.NumItems-1;
			}
			// Messages from use of 'y'
			DistributionRefArray<Discrete,int>[] y_uses_B = default(DistributionRefArray<Discrete,int>[]);
			// Create array for 'y_uses' Backwards messages.
			y_uses_B = new DistributionRefArray<Discrete,int>[this.NumItems];
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for 'y_uses' Backwards messages.
				y_uses_B[i] = new DistributionRefArray<Discrete,int>(2);
				for(int _ind = 0; _ind<2; _ind++) {
					y_uses_B[i][_ind] = ArrayHelper.MakeUniform<Discrete>(Discrete.Uniform(3));
				}
			}
			// Create array for replicates of 'y_i__selector_uses_B'
			Discrete[][] y_i__selector_uses_B = new Discrete[this.NumItems][];
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for 'y_i__selector_uses' Backwards messages.
				y_i__selector_uses_B[i] = new Discrete[2];
				for(int _ind = 0; _ind<2; _ind++) {
					y_i__selector_uses_B[i][_ind] = ArrayHelper.MakeUniform<Discrete>(Discrete.Uniform(3));
				}
			}
			// Create array for replicates of 'y_i__selector_cases_uses_B'
			DistributionStructArray<Bernoulli,bool>[][] y_i__selector_cases_uses_B = new DistributionStructArray<Bernoulli,bool>[this.NumItems][];
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for 'y_i__selector_cases_uses' Backwards messages.
				y_i__selector_cases_uses_B[i] = new DistributionStructArray<Bernoulli,bool>[3];
				for(int _iv2 = 0; _iv2<3; _iv2++) {
					// Create array for 'y_i__selector_cases_uses' Backwards messages.
					y_i__selector_cases_uses_B[i][_iv2] = new DistributionStructArray<Bernoulli,bool>(10);
					for(int _ind = 0; _ind<10; _ind++) {
						y_i__selector_cases_uses_B[i][_iv2][_ind] = Bernoulli.Uniform();
					}
				}
			}
			// Create array for replicates of 'y_i__selector_cases_rep4_rep_uses_B'
			DistributionStructArray<Bernoulli,bool>[][][][] y_i__selector_cases_rep4_rep_uses_B = new DistributionStructArray<Bernoulli,bool>[this.NumItems][][][];
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for replicates of 'y_i__selector_cases_rep4_rep_uses_B'
				y_i__selector_cases_rep4_rep_uses_B[i] = new DistributionStructArray<Bernoulli,bool>[3][][];
				for(int index44 = 0; index44<3; index44++) {
					// Create array for replicates of 'y_i__selector_cases_rep4_rep_uses_B'
					y_i__selector_cases_rep4_rep_uses_B[i][index44] = new DistributionStructArray<Bernoulli,bool>[3][];
					for(int k = 0; k<3; k++) {
						if (!(k==index44)) {
							// Create array for 'y_i__selector_cases_rep4_rep_uses' Backwards messages.
							y_i__selector_cases_rep4_rep_uses_B[i][index44][k] = new DistributionStructArray<Bernoulli,bool>[3];
							for(int _gi = 0; _gi<3; _gi++) {
								// Create array for 'y_i__selector_cases_rep4_rep_uses' Backwards messages.
								y_i__selector_cases_rep4_rep_uses_B[i][index44][k][_gi] = new DistributionStructArray<Bernoulli,bool>(2);
								for(int _ind = 0; _ind<2; _ind++) {
									y_i__selector_cases_rep4_rep_uses_B[i][index44][k][_gi][_ind] = Bernoulli.Uniform();
								}
							}
						}
					}
				}
			}
			// Buffer for ReplicateOp_Divide.UsesAverageConditional<Gaussian>
			// Create array for replicates of 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F__gi__marginal'
			DistributionRefArray<DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]>,double[][][]> scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F__gi__marginal = new DistributionRefArray<DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]>,double[][][]>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for replicates of 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F__gi__marginal'
				scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F__gi__marginal[i] = new DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]>(3);
				for(int index44 = 0; index44<3; index44++) {
					// Create array for replicates of 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F__gi__marginal'
					scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F__gi__marginal[i][index44] = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(3);
					for(int k = 0; k<3; k++) {
						if (!(k==index44)) {
							// Create array for replicates of 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F__gi__marginal'
							scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F__gi__marginal[i][index44][k] = new DistributionStructArray<Gaussian,double>(3);
							for(int _gi = 0; _gi<3; _gi++) {
								// Message to 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses' from Replicate factor
								scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F__gi__marginal[i][index44][k][_gi] = ReplicateOp_Divide.MarginalInit<Gaussian>(this.scorePlusNoise_k_cond_y_i__index44_rep_F[i][index44][_gi][k]);
							}
						}
					}
				}
			}
			// Create array for replicates of 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F'
			DistributionStructArray<Gaussian,double>[][][][] scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F = new DistributionStructArray<Gaussian,double>[this.NumItems][][][];
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for replicates of 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F'
				scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F[i] = new DistributionStructArray<Gaussian,double>[3][][];
				for(int index44 = 0; index44<3; index44++) {
					// Create array for replicates of 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F'
					scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F[i][index44] = new DistributionStructArray<Gaussian,double>[3][];
					for(int k = 0; k<3; k++) {
						if (!(k==index44)) {
							// Create array for 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses' Forwards messages.
							scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F[i][index44][k] = new DistributionStructArray<Gaussian,double>[3];
							for(int _gi = 0; _gi<3; _gi++) {
								// Create array for 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses' Forwards messages.
								scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F[i][index44][k][_gi] = new DistributionStructArray<Gaussian,double>(2);
								for(int _ind = 0; _ind<2; _ind++) {
									scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F[i][index44][k][_gi][_ind] = Gaussian.Uniform();
								}
							}
						}
					}
				}
			}
			// Create array for replicates of 'scoreDiff_F'
			DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]> scoreDiff_F = new DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for replicates of 'scoreDiff_F'
				scoreDiff_F[i] = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(3);
				for(int index44 = 0; index44<3; index44++) {
					// Create array for replicates of 'scoreDiff_F'
					scoreDiff_F[i][index44] = new DistributionStructArray<Gaussian,double>(3);
					for(int k = 0; k<3; k++) {
						if (!(k==index44)) {
							scoreDiff_F[i][index44][k] = Gaussian.Uniform();
						}
					}
				}
			}
			// Create array for replicates of 'scoreDiff_B'
			DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]> scoreDiff_B = new DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for replicates of 'scoreDiff_B'
				scoreDiff_B[i] = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(3);
				for(int index44 = 0; index44<3; index44++) {
					// Create array for replicates of 'scoreDiff_B'
					scoreDiff_B[i][index44] = new DistributionStructArray<Gaussian,double>(3);
					for(int k = 0; k<3; k++) {
						if (!(k==index44)) {
							scoreDiff_B[i][index44][k] = Gaussian.Uniform();
						}
					}
				}
			}
			// Buffer for ReplicateOp_Divide.UsesAverageConditional<Gaussian>
			// Create array for replicates of 'scorePlusNoise_k_cond_y_i__index44_rep_F_marginal'
			DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]> scorePlusNoise_k_cond_y_i__index44_rep_F_marginal = new DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for replicates of 'scorePlusNoise_k_cond_y_i__index44_rep_F_marginal'
				scorePlusNoise_k_cond_y_i__index44_rep_F_marginal[i] = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(3);
				for(int index44 = 0; index44<3; index44++) {
					// Create array for replicates of 'scorePlusNoise_k_cond_y_i__index44_rep_F_marginal'
					scorePlusNoise_k_cond_y_i__index44_rep_F_marginal[i][index44] = new DistributionStructArray<Gaussian,double>(3);
				}
			}
			// Create array for replicates of '_hoist5'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> _hoist5 = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for replicates of '_hoist5'
				_hoist5[i] = new DistributionStructArray<Gaussian,double>(3);
				for(int _gi = 0; _gi<3; _gi++) {
					_hoist5[i][_gi] = ReplicateOp_Divide.MarginalInit<Gaussian>(this.scorePlusNoise_F[i][_gi]);
					for(int index44 = 0; index44<3; index44++) {
						scorePlusNoise_k_cond_y_i__index44_rep_F_marginal[i][index44][_gi] = ArrayHelper.CopyStorage<Gaussian>(_hoist5[i][_gi]);
					}
				}
			}
			// Create array for replicates of 'y_i__selector_cases_rep4_rep_B'
			DistributionRefArray<DistributionRefArray<DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]>,bool[][]>,bool[][][]> y_i__selector_cases_rep4_rep_B = new DistributionRefArray<DistributionRefArray<DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]>,bool[][]>,bool[][][]>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for replicates of 'y_i__selector_cases_rep4_rep_B'
				y_i__selector_cases_rep4_rep_B[i] = new DistributionRefArray<DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]>,bool[][]>(3);
				for(int index44 = 0; index44<3; index44++) {
					// Create array for replicates of 'y_i__selector_cases_rep4_rep_B'
					y_i__selector_cases_rep4_rep_B[i][index44] = new DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]>(3);
					for(int k = 0; k<3; k++) {
						if (!(k==index44)) {
							// Create array for 'y_i__selector_cases_rep4_rep' Backwards messages.
							y_i__selector_cases_rep4_rep_B[i][index44][k] = new DistributionStructArray<Bernoulli,bool>(3);
							for(int _gi = 0; _gi<3; _gi++) {
								y_i__selector_cases_rep4_rep_B[i][index44][k][_gi] = Bernoulli.Uniform();
							}
						}
					}
				}
			}
			// Create array for replicates of 'y_i__selector_cases_rep4_B'
			DistributionRefArray<DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]>,bool[][]> y_i__selector_cases_rep4_B = new DistributionRefArray<DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]>,bool[][]>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for replicates of 'y_i__selector_cases_rep4_B'
				y_i__selector_cases_rep4_B[i] = new DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]>(3);
				for(int index44 = 0; index44<3; index44++) {
					// Create array for 'y_i__selector_cases_rep4' Backwards messages.
					y_i__selector_cases_rep4_B[i][index44] = new DistributionStructArray<Bernoulli,bool>(3);
					for(int k = 0; k<3; k++) {
						y_i__selector_cases_rep4_B[i][index44][k] = Bernoulli.Uniform();
					}
				}
			}
			// Create array for replicates of 'y_i__selector_cases_rep6_uses_B'
			DistributionStructArray<Bernoulli,bool>[][][] y_i__selector_cases_rep6_uses_B = new DistributionStructArray<Bernoulli,bool>[this.NumItems][][];
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for replicates of 'y_i__selector_cases_rep6_uses_B'
				y_i__selector_cases_rep6_uses_B[i] = new DistributionStructArray<Bernoulli,bool>[3][];
				for(int index44 = 0; index44<3; index44++) {
					// Create array for 'y_i__selector_cases_rep6_uses' Backwards messages.
					y_i__selector_cases_rep6_uses_B[i][index44] = new DistributionStructArray<Bernoulli,bool>[3];
					for(int _gi = 0; _gi<3; _gi++) {
						// Create array for 'y_i__selector_cases_rep6_uses' Backwards messages.
						y_i__selector_cases_rep6_uses_B[i][index44][_gi] = new DistributionStructArray<Bernoulli,bool>(2);
						for(int _ind = 0; _ind<2; _ind++) {
							y_i__selector_cases_rep6_uses_B[i][index44][_gi][_ind] = Bernoulli.Uniform();
						}
					}
				}
			}
			// Create array for replicates of 'y_i__selector_cases_rep6_B'
			DistributionRefArray<DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]>,bool[][]> y_i__selector_cases_rep6_B = new DistributionRefArray<DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]>,bool[][]>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for replicates of 'y_i__selector_cases_rep6_B'
				y_i__selector_cases_rep6_B[i] = new DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]>(3);
				for(int index44 = 0; index44<3; index44++) {
					// Create array for 'y_i__selector_cases_rep6' Backwards messages.
					y_i__selector_cases_rep6_B[i][index44] = new DistributionStructArray<Bernoulli,bool>(3);
					for(int _gi = 0; _gi<3; _gi++) {
						y_i__selector_cases_rep6_B[i][index44][_gi] = Bernoulli.Uniform();
					}
				}
			}
			// Create array for replicates of 'y_i__selector_cases_rep8_B'
			DistributionRefArray<DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]>,bool[][]> y_i__selector_cases_rep8_B = new DistributionRefArray<DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]>,bool[][]>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for replicates of 'y_i__selector_cases_rep8_B'
				y_i__selector_cases_rep8_B[i] = new DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]>(3);
				for(int index44 = 0; index44<3; index44++) {
					// Create array for 'y_i__selector_cases_rep8' Backwards messages.
					y_i__selector_cases_rep8_B[i][index44] = new DistributionStructArray<Bernoulli,bool>(3);
					for(int k = 0; k<3; k++) {
						y_i__selector_cases_rep8_B[i][index44][k] = Bernoulli.Uniform();
					}
				}
			}
			// The constant 'vbool38'
			// Create array for replicates of 'vbool38'
			bool[][][] vbool38 = new bool[this.NumItems][][];
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for replicates of 'vbool38'
				vbool38[i] = new bool[3][];
				for(int index44 = 0; index44<3; index44++) {
					// Create array for replicates of 'vbool38'
					vbool38[i][index44] = new bool[3];
					for(int k = 0; k<3; k++) {
						if (!(k==index44)) {
							vbool38[i][index44][k] = true;
						}
					}
				}
			}
			// Create array for replicates of 'y_i__selector_cases_rep9_B'
			DistributionRefArray<DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]>,bool[][]> y_i__selector_cases_rep9_B = new DistributionRefArray<DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]>,bool[][]>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for replicates of 'y_i__selector_cases_rep9_B'
				y_i__selector_cases_rep9_B[i] = new DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]>(3);
				for(int index44 = 0; index44<3; index44++) {
					// Create array for 'y_i__selector_cases_rep9' Backwards messages.
					y_i__selector_cases_rep9_B[i][index44] = new DistributionStructArray<Bernoulli,bool>(3);
					for(int k = 0; k<3; k++) {
						y_i__selector_cases_rep9_B[i][index44][k] = Bernoulli.Uniform();
						if (!(k==index44)) {
							// Message to 'y_i__selector_cases_rep9' from Equal factor
							y_i__selector_cases_rep9_B[i][index44][k] = Bernoulli.FromLogOdds(ConstrainEqualOp<bool>.LogEvidenceRatio(true, vbool38[i][index44][k]));
						}
					}
					// Message to 'y_i__selector_cases_uses' from Replicate factor
					y_i__selector_cases_uses_B[i][index44][9] = ReplicateOp_NoDivide.DefAverageConditional<Bernoulli>(y_i__selector_cases_rep9_B[i][index44], y_i__selector_cases_uses_B[i][index44][9]);
				}
			}
			// Create array for replicates of 'y_i__selector_cases_B'
			DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]> y_i__selector_cases_B = new DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for 'y_i__selector_cases' Backwards messages.
				y_i__selector_cases_B[i] = new DistributionStructArray<Bernoulli,bool>(3);
				for(int _iv2 = 0; _iv2<3; _iv2++) {
					y_i__selector_cases_B[i][_iv2] = Bernoulli.Uniform();
				}
			}
			// Messages to use of 'y'
			DistributionRefArray<Discrete,int>[] y_uses_F = default(DistributionRefArray<Discrete,int>[]);
			// Create array for 'y_uses' Forwards messages.
			y_uses_F = new DistributionRefArray<Discrete,int>[this.NumItems];
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for 'y_uses' Forwards messages.
				y_uses_F[i] = new DistributionRefArray<Discrete,int>(2);
				for(int _ind = 0; _ind<2; _ind++) {
					y_uses_F[i][_ind] = ArrayHelper.MakeUniform<Discrete>(Discrete.Uniform(3));
				}
			}
			// Buffer for ReplicateOp_Divide.Marginal<Discrete>
			// Create array for replicates of 'y_i__selector_uses_B_toDef'
			DistributionRefArray<Discrete,int> y_i__selector_uses_B_toDef = new DistributionRefArray<Discrete,int>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Message to 'y_i__selector_uses' from Replicate factor
				y_i__selector_uses_B_toDef[i] = ReplicateOp_Divide.ToDefInit<Discrete>(y_uses_F[i][1]);
			}
			// Buffer for ReplicateOp_Divide.Marginal<Discrete>
			// Create array for replicates of 'y_uses_B_i__toDef'
			DistributionRefArray<Discrete,int> y_uses_B_i__toDef = new DistributionRefArray<Discrete,int>(this.NumItems);
			Discrete _hoist4 = default(Discrete);
			_hoist4 = ReplicateOp_Divide.ToDefInit<Discrete>(_hoist);
			for(int i = 0; i<this.NumItems; i++) {
				y_uses_B_i__toDef[i] = ArrayHelper.CopyStorage<Discrete>(_hoist4);
			}
			// Buffer for ReplicateOp_Divide.UsesAverageConditional<Discrete>
			// Create array for replicates of 'y_uses_F_i__marginal'
			DistributionRefArray<Discrete,int> y_uses_F_i__marginal = new DistributionRefArray<Discrete,int>(this.NumItems);
			Discrete _hoist3 = default(Discrete);
			_hoist3 = ReplicateOp_Divide.MarginalInit<Discrete>(_hoist);
			for(int i = 0; i<this.NumItems; i++) {
				y_uses_F_i__marginal[i] = ArrayHelper.CopyStorage<Discrete>(_hoist3);
			}
			// Buffer for ReplicateOp_Divide.UsesAverageConditional<Discrete>
			// Create array for replicates of 'y_i__selector_uses_F_marginal'
			DistributionRefArray<Discrete,int> y_i__selector_uses_F_marginal = new DistributionRefArray<Discrete,int>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Message to 'y_i__selector_uses' from Replicate factor
				y_i__selector_uses_F_marginal[i] = ReplicateOp_Divide.MarginalInit<Discrete>(y_uses_F[i][1]);
			}
			// Create array for replicates of 'y_i__selector_uses_F'
			Discrete[][] y_i__selector_uses_F = new Discrete[this.NumItems][];
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for 'y_i__selector_uses' Forwards messages.
				y_i__selector_uses_F[i] = new Discrete[2];
				for(int _ind = 0; _ind<2; _ind++) {
					y_i__selector_uses_F[i][_ind] = ArrayHelper.MakeUniform<Discrete>(Discrete.Uniform(3));
				}
			}
			// Buffer for ReplicateOp_Divide.Marginal<Discrete>
			// Create array for replicates of 'y_i__selector_rep_B_toDef'
			DistributionRefArray<Discrete,int> y_i__selector_rep_B_toDef = new DistributionRefArray<Discrete,int>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Message to 'y_i__selector_rep' from Replicate factor
				y_i__selector_rep_B_toDef[i] = ReplicateOp_Divide.ToDefInit<Discrete>(y_i__selector_uses_F[i][1]);
			}
			// Buffer for ReplicateOp_Divide.UsesAverageConditional<Discrete>
			// Create array for replicates of 'y_i__selector_rep_F_marginal'
			DistributionRefArray<Discrete,int> y_i__selector_rep_F_marginal = new DistributionRefArray<Discrete,int>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Message to 'y_i__selector_rep' from Replicate factor
				y_i__selector_rep_F_marginal[i] = ReplicateOp_Divide.MarginalInit<Discrete>(y_i__selector_uses_F[i][1]);
			}
			// Create array for replicates of 'y_i__selector_rep_F'
			DistributionRefArray<DistributionRefArray<Discrete,int>,int[]> y_i__selector_rep_F = new DistributionRefArray<DistributionRefArray<Discrete,int>,int[]>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for 'y_i__selector_rep' Forwards messages.
				y_i__selector_rep_F[i] = new DistributionRefArray<Discrete,int>(3);
				for(int k = 0; k<3; k++) {
					y_i__selector_rep_F[i][k] = ArrayHelper.MakeUniform<Discrete>(Discrete.Uniform(3));
				}
			}
			// Create array for replicates of 'y_i__selector_rep_B'
			DistributionRefArray<DistributionRefArray<Discrete,int>,int[]> y_i__selector_rep_B = new DistributionRefArray<DistributionRefArray<Discrete,int>,int[]>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for 'y_i__selector_rep' Backwards messages.
				y_i__selector_rep_B[i] = new DistributionRefArray<Discrete,int>(3);
				for(int k = 0; k<3; k++) {
					y_i__selector_rep_B[i][k] = ArrayHelper.MakeUniform<Discrete>(Discrete.Uniform(3));
				}
			}
			Discrete _hoist2 = default(Discrete);
			for(int i = 0; i<this.NumItems; i++) {
				for(int k = 0; k<3; k++) {
					_hoist2 = ArrayHelper.CopyStorage<Discrete>(y_i__selector_rep_B[i][k]);
					i = this.NumItems-1;
					k = 3-1;
				}
			}
			// Create array for replicates of 'scorePlusNoise_k_cond_y_i__B'
			DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]> scorePlusNoise_k_cond_y_i__B = new DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for 'scorePlusNoise_k_cond_y_i_' Backwards messages.
				scorePlusNoise_k_cond_y_i__B[i] = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(3);
				for(int k = 0; k<3; k++) {
					// Create array for 'scorePlusNoise_k_cond_y_i_' Backwards messages.
					scorePlusNoise_k_cond_y_i__B[i][k] = new DistributionStructArray<Gaussian,double>(3);
					for(int index44 = 0; index44<3; index44++) {
						scorePlusNoise_k_cond_y_i__B[i][k][index44] = Gaussian.Uniform();
					}
				}
			}
			// Message from use of 'scorePlusNoise'
			// Create array for replicates of 'scorePlusNoise_use_B'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> scorePlusNoise_use_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for 'scorePlusNoise_use' Backwards messages.
				scorePlusNoise_use_B[i] = new DistributionStructArray<Gaussian,double>(3);
				for(int k = 0; k<3; k++) {
					scorePlusNoise_use_B[i][k] = Gaussian.Uniform();
				}
			}
			// Create array for replicates of 'score_B'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> score_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for 'score' Backwards messages.
				score_B[i] = new DistributionStructArray<Gaussian,double>(3);
				for(int k = 0; k<3; k++) {
					score_B[i][k] = Gaussian.Uniform();
				}
			}
			// Create array for replicates of 'product_B'
			DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]> product_B = new DistributionRefArray<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				// Create array for 'product' Backwards messages.
				product_B[i] = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(3);
				for(int k = 0; k<3; k++) {
					// Create array for 'product' Backwards messages.
					product_B[i][k] = new DistributionStructArray<Gaussian,double>(this.NumFeaturesPerItem[i]);
					for(int fItem = 0; fItem<this.NumFeaturesPerItem[i]; fItem++) {
						product_B[i][k][fItem] = Gaussian.Uniform();
					}
				}
			}
			for(int k = 0; k<3; k++) {
				// Message to 'wModel_indices' from JaggedSubarray factor
				this.wModel_use_F_k__marginal[k] = JaggedSubarrayOp<double>.Marginal<DistributionStructArray<Gaussian,double>,Gaussian,object,DistributionStructArray<Gaussian,double>>(this.WPrior[k], this.wModel_indices_B[k], this.Indices, this.wModel_use_F_k__marginal[k]);
			}
			for(int i = 0; i<this.NumItems; i++) {
				for(int k = 0; k<3; k++) {
					// Message to 'wModel_indices' from JaggedSubarray factor
					wModel_indices_F[k][i] = JaggedSubarrayOp<double>.ItemsAverageConditional<DistributionStructArray<Gaussian,double>,Gaussian,DistributionStructArray<Gaussian,double>>(this.wSparse_B[i][k], this.WPrior[k], this.wModel_use_F_k__marginal[k], this.Indices, i, wModel_indices_F[k][i]);
					for(int fItem = 0; fItem<this.NumFeaturesPerItem[i]; fItem++) {
						// Message to 'product' from Product factor
						product_F[i][k][fItem] = GaussianProductOp.ProductAverageConditional(this.Values[i][fItem], wModel_indices_F[k][i][fItem]);
					}
					// Message to 'score' from Sum factor
					score_F[i][k] = FastSumOp.SumAverageConditional(product_F[i][k]);
					// Message to 'scorePlusNoise' from Gaussian factor
					this.scorePlusNoise_F[i][k] = GaussianOpBase.SampleAverageConditional(score_F[i][k], this.NoisePrecision);
				}
				for(int index44 = 0; index44<3; index44++) {
					for(int _gi = 0; _gi<3; _gi++) {
						// Message to 'scorePlusNoise_k_cond_y_i__index44_rep' from Replicate factor
						scorePlusNoise_k_cond_y_i__index44_rep_F_marginal[i][index44][_gi] = ReplicateOp_Divide.Marginal<Gaussian>(this.scorePlusNoise_k_cond_y_i__index44_rep_B_toDef[i][index44][_gi], this.scorePlusNoise_F[i][_gi], scorePlusNoise_k_cond_y_i__index44_rep_F_marginal[i][index44][_gi]);
						for(int _a = 0; _a<3; _a++) {
							// Message to 'scorePlusNoise_k_cond_y_i__index44_rep' from Replicate factor
							this.scorePlusNoise_k_cond_y_i__index44_rep_F[i][index44][_gi][_a] = ReplicateOp_Divide.UsesAverageConditional<Gaussian>(this.scorePlusNoise_k_cond_y_i__index44_rep_B[i][index44][_gi][_a], scorePlusNoise_k_cond_y_i__index44_rep_F_marginal[i][index44][_gi], _a, this.scorePlusNoise_k_cond_y_i__index44_rep_F[i][index44][_gi][_a]);
						}
						for(int k = 0; k<3; k++) {
							if (!(k==index44)) {
								// Message to 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses' from Replicate factor
								scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F__gi__marginal[i][index44][k][_gi] = ReplicateOp_Divide.Marginal<Gaussian>(this.scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B__gi__toDef[i][index44][k][_gi], this.scorePlusNoise_k_cond_y_i__index44_rep_F[i][index44][_gi][k], scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F__gi__marginal[i][index44][k][_gi]);
								// Message to 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses' from Replicate factor
								scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F[i][index44][k][_gi][1] = ReplicateOp_Divide.UsesAverageConditional<Gaussian>(this.scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B[i][index44][k][_gi][1], scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F__gi__marginal[i][index44][k][_gi], 1, scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F[i][index44][k][_gi][1]);
								// Message to 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses' from Replicate factor
								scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F[i][index44][k][_gi][0] = ReplicateOp_Divide.UsesAverageConditional<Gaussian>(this.scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B[i][index44][k][_gi][0], scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F__gi__marginal[i][index44][k][_gi], 0, scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F[i][index44][k][_gi][0]);
							}
						}
					}
					for(int k = 0; k<3; k++) {
						if (!(k==index44)) {
							// Message to 'scoreDiff' from Difference factor
							scoreDiff_F[i][index44][k] = DoublePlusOp.AAverageConditional(scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F[i][index44][k][index44][0], scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F[i][index44][k][k][1]);
							// Message to 'scoreDiff' from IsPositive factor
							scoreDiff_B[i][index44][k] = IsPositiveOp_Proper.XAverageConditional(Bernoulli.PointMass(true), scoreDiff_F[i][index44][k]);
							// Message to 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses' from Difference factor
							this.scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B[i][index44][k][index44][0] = DoublePlusOp.SumAverageConditional(scoreDiff_B[i][index44][k], scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F[i][index44][k][k][1]);
							// Message to 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses' from Difference factor
							this.scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B[i][index44][k][k][1] = DoublePlusOp.BAverageConditional(scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F[i][index44][k][index44][0], scoreDiff_B[i][index44][k]);
						}
					}
				}
			}
			for(int iteration = this.Changed_numberOfIterationsDecreased_wPrior_indices_numItems_numFeaturesPerItem_values_noisePrecision_iterationsDone; iteration<numberOfIterations; iteration++) {
				for(int k = 0; k<3; k++) {
					// Message to 'wModel_indices' from JaggedSubarray factor
					this.wModel_use_F_k__marginal[k] = JaggedSubarrayOp<double>.Marginal<DistributionStructArray<Gaussian,double>,Gaussian,object,DistributionStructArray<Gaussian,double>>(this.WPrior[k], this.wModel_indices_B[k], this.Indices, this.wModel_use_F_k__marginal[k]);
				}
				for(int i = 0; i<this.NumItems; i++) {
					for(int k = 0; k<3; k++) {
						// Message to 'wModel_indices' from JaggedSubarray factor
						wModel_indices_F[k][i] = JaggedSubarrayOp<double>.ItemsAverageConditional<DistributionStructArray<Gaussian,double>,Gaussian,DistributionStructArray<Gaussian,double>>(this.wSparse_B[i][k], this.WPrior[k], this.wModel_use_F_k__marginal[k], this.Indices, i, wModel_indices_F[k][i]);
						for(int fItem = 0; fItem<this.NumFeaturesPerItem[i]; fItem++) {
							// Message to 'product' from Product factor
							product_F[i][k][fItem] = GaussianProductOp.ProductAverageConditional(this.Values[i][fItem], wModel_indices_F[k][i][fItem]);
						}
						// Message to 'score' from Sum factor
						score_F[i][k] = FastSumOp.SumAverageConditional(product_F[i][k]);
						// Message to 'scorePlusNoise' from Gaussian factor
						this.scorePlusNoise_F[i][k] = GaussianOpBase.SampleAverageConditional(score_F[i][k], this.NoisePrecision);
						for(int index44 = 0; index44<3; index44++) {
							if (!(k==index44)) {
								for(int _gi = 0; _gi<3; _gi++) {
									// Message to 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses' from Replicate factor
									this.scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B__gi__toDef[i][index44][k][_gi] = ReplicateOp_Divide.ToDef<Gaussian>(this.scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B[i][index44][k][_gi], this.scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B__gi__toDef[i][index44][k][_gi]);
									// Message to 'scorePlusNoise_k_cond_y_i__index44_rep' from Copy factor
									this.scorePlusNoise_k_cond_y_i__index44_rep_B[i][index44][_gi][k] = ArrayHelper.SetTo<Gaussian>(this.scorePlusNoise_k_cond_y_i__index44_rep_B[i][index44][_gi][k], this.scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B__gi__toDef[i][index44][k][_gi]);
								}
							}
						}
					}
					for(int index44 = 0; index44<3; index44++) {
						for(int _gi = 0; _gi<3; _gi++) {
							// Message to 'scorePlusNoise_k_cond_y_i__index44_rep' from Replicate factor
							this.scorePlusNoise_k_cond_y_i__index44_rep_B_toDef[i][index44][_gi] = ReplicateOp_Divide.ToDef<Gaussian>(this.scorePlusNoise_k_cond_y_i__index44_rep_B[i][index44][_gi], this.scorePlusNoise_k_cond_y_i__index44_rep_B_toDef[i][index44][_gi]);
							// Message to 'scorePlusNoise_k_cond_y_i__index44_rep' from Replicate factor
							scorePlusNoise_k_cond_y_i__index44_rep_F_marginal[i][index44][_gi] = ReplicateOp_Divide.Marginal<Gaussian>(this.scorePlusNoise_k_cond_y_i__index44_rep_B_toDef[i][index44][_gi], this.scorePlusNoise_F[i][_gi], scorePlusNoise_k_cond_y_i__index44_rep_F_marginal[i][index44][_gi]);
							for(int _a = 0; _a<3; _a++) {
								// Message to 'scorePlusNoise_k_cond_y_i__index44_rep' from Replicate factor
								this.scorePlusNoise_k_cond_y_i__index44_rep_F[i][index44][_gi][_a] = ReplicateOp_Divide.UsesAverageConditional<Gaussian>(this.scorePlusNoise_k_cond_y_i__index44_rep_B[i][index44][_gi][_a], scorePlusNoise_k_cond_y_i__index44_rep_F_marginal[i][index44][_gi], _a, this.scorePlusNoise_k_cond_y_i__index44_rep_F[i][index44][_gi][_a]);
							}
							for(int k = 0; k<3; k++) {
								if (!(k==index44)) {
									// Message to 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses' from Replicate factor
									scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F__gi__marginal[i][index44][k][_gi] = ReplicateOp_Divide.Marginal<Gaussian>(this.scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B__gi__toDef[i][index44][k][_gi], this.scorePlusNoise_k_cond_y_i__index44_rep_F[i][index44][_gi][k], scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F__gi__marginal[i][index44][k][_gi]);
									// Message to 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses' from Replicate factor
									scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F[i][index44][k][_gi][1] = ReplicateOp_Divide.UsesAverageConditional<Gaussian>(this.scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B[i][index44][k][_gi][1], scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F__gi__marginal[i][index44][k][_gi], 1, scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F[i][index44][k][_gi][1]);
									// Message to 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses' from Replicate factor
									scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F[i][index44][k][_gi][0] = ReplicateOp_Divide.UsesAverageConditional<Gaussian>(this.scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B[i][index44][k][_gi][0], scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F__gi__marginal[i][index44][k][_gi], 0, scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F[i][index44][k][_gi][0]);
								}
							}
						}
						for(int k = 0; k<3; k++) {
							if (!(k==index44)) {
								// Message to 'scoreDiff' from Difference factor
								scoreDiff_F[i][index44][k] = DoublePlusOp.AAverageConditional(scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F[i][index44][k][index44][0], scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F[i][index44][k][k][1]);
								// Message to 'scoreDiff' from IsPositive factor
								scoreDiff_B[i][index44][k] = IsPositiveOp_Proper.XAverageConditional(Bernoulli.PointMass(true), scoreDiff_F[i][index44][k]);
								// Message to 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses' from Difference factor
								this.scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B[i][index44][k][index44][0] = DoublePlusOp.SumAverageConditional(scoreDiff_B[i][index44][k], scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F[i][index44][k][k][1]);
								// Message to 'scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses' from Difference factor
								this.scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B[i][index44][k][k][1] = DoublePlusOp.BAverageConditional(scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F[i][index44][k][index44][0], scoreDiff_B[i][index44][k]);
								for(int _gi = 0; _gi<3; _gi++) {
									// Message to 'y_i__selector_cases_rep4_rep_uses' from Replicate factor
									y_i__selector_cases_rep4_rep_uses_B[i][index44][k][_gi][1] = Bernoulli.FromLogOdds(ReplicateOp.LogEvidenceRatio<Gaussian>(this.scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_B[i][index44][k][_gi], this.scorePlusNoise_k_cond_y_i__index44_rep_F[i][index44][_gi][k], scorePlusNoise_k_cond_y_i__index44__gi_cond_kEqEqindex44_1_uses_F[i][index44][k][_gi]));
									// Message to 'y_i__selector_cases_rep4_rep' from Replicate factor
									y_i__selector_cases_rep4_rep_B[i][index44][k][_gi] = ReplicateOp_NoDivide.DefAverageConditional<Bernoulli>(y_i__selector_cases_rep4_rep_uses_B[i][index44][k][_gi], y_i__selector_cases_rep4_rep_B[i][index44][k][_gi]);
								}
								// Message to 'y_i__selector_cases_rep4' from Replicate factor
								y_i__selector_cases_rep4_B[i][index44][k] = ReplicateOp_NoDivide.DefAverageConditional<Bernoulli>(y_i__selector_cases_rep4_rep_B[i][index44][k], y_i__selector_cases_rep4_B[i][index44][k]);
							}
						}
						// Message to 'y_i__selector_cases_uses' from Replicate factor
						y_i__selector_cases_uses_B[i][index44][4] = ReplicateOp_NoDivide.DefAverageConditional<Bernoulli>(y_i__selector_cases_rep4_B[i][index44], y_i__selector_cases_uses_B[i][index44][4]);
						for(int _gi = 0; _gi<3; _gi++) {
							// Message to 'y_i__selector_cases_rep6_uses' from Replicate factor
							y_i__selector_cases_rep6_uses_B[i][index44][_gi][1] = Bernoulli.FromLogOdds(ReplicateOp.LogEvidenceRatio<Gaussian>(this.scorePlusNoise_k_cond_y_i__index44_rep_B[i][index44][_gi], this.scorePlusNoise_F[i][_gi], this.scorePlusNoise_k_cond_y_i__index44_rep_F[i][index44][_gi]));
							// Message to 'y_i__selector_cases_rep6' from Replicate factor
							y_i__selector_cases_rep6_B[i][index44][_gi] = ReplicateOp_NoDivide.DefAverageConditional<Bernoulli>(y_i__selector_cases_rep6_uses_B[i][index44][_gi], y_i__selector_cases_rep6_B[i][index44][_gi]);
						}
						// Message to 'y_i__selector_cases_uses' from Replicate factor
						y_i__selector_cases_uses_B[i][index44][5] = ReplicateOp_NoDivide.DefAverageConditional<Bernoulli>(y_i__selector_cases_rep6_B[i][index44], y_i__selector_cases_uses_B[i][index44][5]);
						for(int k = 0; k<3; k++) {
							if (!(k==index44)) {
								// Message to 'y_i__selector_cases_rep8' from IsPositive factor
								y_i__selector_cases_rep8_B[i][index44][k] = Bernoulli.FromLogOdds(IsPositiveOp.LogEvidenceRatio(true, scoreDiff_F[i][index44][k]));
							}
						}
						// Message to 'y_i__selector_cases_uses' from Replicate factor
						y_i__selector_cases_uses_B[i][index44][8] = ReplicateOp_NoDivide.DefAverageConditional<Bernoulli>(y_i__selector_cases_rep8_B[i][index44], y_i__selector_cases_uses_B[i][index44][8]);
					}
					for(int _iv2 = 0; _iv2<3; _iv2++) {
						// Message to 'y_i__selector_cases' from Replicate factor
						y_i__selector_cases_B[i][_iv2] = ReplicateOp_NoDivide.DefAverageConditional<Bernoulli>(y_i__selector_cases_uses_B[i][_iv2], y_i__selector_cases_B[i][_iv2]);
					}
					// Message to 'y_i__selector_uses' from CasesInt factor
					y_i__selector_uses_B[i][0] = IntCasesOp.IAverageConditional(y_i__selector_cases_B[i], y_i__selector_uses_B[i][0]);
					// Message to 'y_i__selector_uses' from Replicate factor
					y_i__selector_uses_B_toDef[i] = ReplicateOp_Divide.ToDef<Discrete>(y_i__selector_uses_B[i], y_i__selector_uses_B_toDef[i]);
					// Message to 'y_uses' from Copy factor
					y_uses_B[i][1] = ArrayHelper.SetTo<Discrete>(y_uses_B[i][1], y_i__selector_uses_B_toDef[i]);
					// Message to 'y_uses' from Replicate factor
					y_uses_B_i__toDef[i] = ReplicateOp_Divide.ToDef<Discrete>(y_uses_B[i], y_uses_B_i__toDef[i]);
					// Message to 'y_uses' from Replicate factor
					y_uses_F_i__marginal[i] = ReplicateOp_Divide.Marginal<Discrete>(y_uses_B_i__toDef[i], _hoist, y_uses_F_i__marginal[i]);
					// Message to 'y_uses' from Replicate factor
					y_uses_F[i][1] = ReplicateOp_Divide.UsesAverageConditional<Discrete>(y_i__selector_uses_B_toDef[i], y_uses_F_i__marginal[i], 1, y_uses_F[i][1]);
					// Message to 'y_i__selector_uses' from Replicate factor
					y_i__selector_uses_F_marginal[i] = ReplicateOp_Divide.Marginal<Discrete>(y_i__selector_uses_B_toDef[i], y_uses_F[i][1], y_i__selector_uses_F_marginal[i]);
					// Message to 'y_i__selector_uses' from Replicate factor
					y_i__selector_uses_F[i][1] = ReplicateOp_Divide.UsesAverageConditional<Discrete>(y_i__selector_rep_B_toDef[i], y_i__selector_uses_F_marginal[i], 1, y_i__selector_uses_F[i][1]);
					// Message to 'y_i__selector_rep' from Replicate factor
					y_i__selector_rep_F_marginal[i] = ReplicateOp_Divide.Marginal<Discrete>(y_i__selector_rep_B_toDef[i], y_i__selector_uses_F[i][1], y_i__selector_rep_F_marginal[i]);
					for(int k = 0; k<3; k++) {
						// Message to 'y_i__selector_rep' from Replicate factor
						y_i__selector_rep_F[i][k] = ReplicateOp_Divide.UsesAverageConditional<Discrete>(_hoist2, y_i__selector_rep_F_marginal[i], k, y_i__selector_rep_F[i][k]);
						for(int index44 = 0; index44<3; index44++) {
							// Message to 'scorePlusNoise_k_cond_y_i_' from Copy factor
							scorePlusNoise_k_cond_y_i__B[i][k][index44] = ArrayHelper.SetTo<Gaussian>(scorePlusNoise_k_cond_y_i__B[i][k][index44], this.scorePlusNoise_k_cond_y_i__index44_rep_B_toDef[i][index44][k]);
						}
						// Message to 'scorePlusNoise_use' from Enter factor
						scorePlusNoise_use_B[i][k] = GateEnterOp<double>.ValueAverageConditional<Gaussian>(scorePlusNoise_k_cond_y_i__B[i][k], y_i__selector_rep_F[i][k], this.scorePlusNoise_F[i][k], scorePlusNoise_use_B[i][k]);
						// Message to 'score' from Gaussian factor
						score_B[i][k] = GaussianOpBase.MeanAverageConditional(scorePlusNoise_use_B[i][k], this.NoisePrecision);
						// Message to 'product' from Sum factor
						product_B[i][k] = FastSumOp.ArrayAverageConditional<DistributionStructArray<Gaussian,double>>(score_B[i][k], score_F[i][k], product_F[i][k], product_B[i][k]);
						for(int fItem = 0; fItem<this.NumFeaturesPerItem[i]; fItem++) {
							// Message to 'wSparse' from Product factor
							this.wSparse_B[i][k][fItem] = GaussianProductOp.BAverageConditional(product_B[i][k][fItem], this.Values[i][fItem]);
						}
						this.wModel_use_F_k__marginal[k] = JaggedSubarrayOp<double>.MarginalIncrement<DistributionStructArray<Gaussian,double>,Gaussian,DistributionStructArray<Gaussian,double>>(this.wModel_use_F_k__marginal[k], wModel_indices_F[k][i], this.wSparse_B[i][k], this.Indices, i);
						// Message to 'wModel_indices' from Copy factor
						this.wModel_indices_B[k][i] = ArrayHelper.SetTo<DistributionStructArray<Gaussian,double>>(this.wModel_indices_B[k][i], this.wSparse_B[i][k]);
					}
				}
				this.OnProgressChanged(new ProgressChangedEventArgs(iteration));
			}
			this.wModel_marginal_F = ArrayHelper.MakeUniform<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>>(this.WPrior);
			// Create array for 'wModel_marginal' Forwards messages.
			this.wModel_marginal_F = ArrayHelper.MakeUniform<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>>(this.WPrior);
			this.wModel_use_B = ArrayHelper.MakeUniform<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>>(this.WPrior);
			// Create array for 'wModel_use' Backwards messages.
			this.wModel_use_B = ArrayHelper.MakeUniform<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>>(this.WPrior);
			for(int k = 0; k<3; k++) {
				// Message to 'wModel_use' from JaggedSubarray factor
				this.wModel_use_B[k] = JaggedSubarrayOp<double>.ArrayAverageConditional<Gaussian,DistributionStructArray<Gaussian,double>,DistributionStructArray<Gaussian,double>>(this.wModel_indices_B[k], this.Indices, this.wModel_use_B[k]);
			}
			// Message to 'wModel_marginal' from Variable factor
			this.wModel_marginal_F = VariableOp.MarginalAverageConditional<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>>(this.wModel_use_B, this.WPrior, this.wModel_marginal_F);
			// Create array for 'y_marginal' Forwards messages.
			this.y_marginal_F = new DistributionRefArray<Discrete,int>(this.NumItems);
			for(int i = 0; i<this.NumItems; i++) {
				this.y_marginal_F[i] = ArrayHelper.MakeUniform<Discrete>(Discrete.Uniform(3));
				// Message to 'y_marginal' from Variable factor
				this.y_marginal_F[i] = VariableOp.MarginalAverageConditional<Discrete>(y_uses_B_i__toDef[i], _hoist, this.y_marginal_F[i]);
			}
			this.Changed_numberOfIterationsDecreased_wPrior_indices_numItems_numFeaturesPerItem_values_noisePrecision_iterationsDone = numberOfIterations;
		}

		/// <summary>
		/// Returns the output message (the posterior divided by the prior) for 'wModel' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The output message (the posterior divided by the prior)</returns>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> WModelMarginalDividedByPrior()
		{
			return this.wModel_use_B;
		}

		/// <summary>
		/// Returns the marginal distribution for 'wModel' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> WModelMarginal()
		{
			return this.wModel_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'y' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionRefArray<Discrete,int> YMarginal()
		{
			return this.y_marginal_F;
		}

		/// <summary>Computations that depend on the observed value of numItems and numFeaturesPerItem and wPrior and noisePrecision and values and indices</summary>
		public void Changed_numItems_numFeaturesPerItem_wPrior_noisePrecision_values_indices()
		{
			if (this.Changed_numItems_numFeaturesPerItem_wPrior_noisePrecision_values_indices_iterationsDone==1) {
				return ;
			}
			this.numItems_marginal = new PointMass<int>(this.NumItems);
			this.numFeaturesPerItem_marginal = new PointMass<int[]>(this.NumFeaturesPerItem);
			this.wPrior_marginal = new PointMass<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>>(this.WPrior);
			this.noisePrecision_marginal = Gaussian.Uniform();
			this.noisePrecision_marginal = Distribution.SetPoint<Gaussian,double>(this.noisePrecision_marginal, this.NoisePrecision);
			this.values_marginal = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumItems, delegate(int i) {
				return new DistributionStructArray<Gaussian,double>(this.NumFeaturesPerItem[i], delegate(int fItem) {
					return Gaussian.Uniform();
				});
			});
			this.values_marginal = Distribution.SetPoint<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>,double[][]>(this.values_marginal, this.Values);
			this.indices_marginal = new PointMass<int[][]>(this.Indices);
			this.Changed_numItems_numFeaturesPerItem_wPrior_noisePrecision_values_indices_iterationsDone = 1;
		}

		/// <summary>
		/// Returns the marginal distribution for 'numItems' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<int> NumItemsMarginal()
		{
			return this.numItems_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'numFeaturesPerItem' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<int[]> NumFeaturesPerItemMarginal()
		{
			return this.numFeaturesPerItem_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'wPrior' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>> WPriorMarginal()
		{
			return this.wPrior_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'noisePrecision' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public Gaussian NoisePrecisionMarginal()
		{
			return this.noisePrecision_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'values' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> ValuesMarginal()
		{
			return this.values_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'indices' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<int[][]> IndicesMarginal()
		{
			return this.indices_marginal;
		}

		#endregion

		#region Events
		/// <summary>Event that is fired when the progress of inference changes, typically at the end of one iteration of the inference algorithm.</summary>
		public event EventHandler<ProgressChangedEventArgs> ProgressChanged;
		#endregion

	}

}
