using System;
using MicrosoftResearch.Infer;
using MicrosoftResearch.Infer.Distributions;
using MicrosoftResearch.Infer.Maths;
using MicrosoftResearch.Infer.Factors;
using MicrosoftResearch.Infer.Collections;

namespace MicrosoftResearch.Infer.Models.User
{
	/// <summary>
	/// Generated algorithm for performing inference
	/// </summary>
	/// <remarks>
	/// The easiest way to use this class is to wrap an instance in a CompiledAlgorithm object and use
	/// the methods on CompiledAlgorithm to set parameters and execute inference.
	/// 
	/// If you instead wish to use this class directly, you must perform the following steps:
	/// 1) Create an instance of the class
	/// 2) Set the value of any externally-set fields e.g. data, priors
	/// 3) Call the Execute(numberOfIterations) method
	/// 4) Use the XXXMarginal() methods to retrieve posterior marginals for different variables.
	/// 
	/// Generated by Infer.NET 2.5 at 00:01 on sexta-feira, 6 de Setembro de 2013.
	/// </remarks>
	public partial class Model3_EP : IGeneratedAlgorithm
	{
		#region Fields
		/// <summary>Field backing the NumberOfIterationsDone property</summary>
		private int numberOfIterationsDone;
		/// <summary>Field backing the numTesting property</summary>
		private int NumTesting;
		/// <summary>Field backing the routineWeightsPosterior property</summary>
		private VectorGaussian RoutineWeightsPosterior;
		/// <summary>Field backing the routineFeaturesTest property</summary>
		private Vector[] RoutineFeaturesTest;
		/// <summary>Field backing the numEventsTest property</summary>
		private int[] NumEventsTest;
		/// <summary>Field backing the eventsWeightsPosterior property</summary>
		private VectorGaussian EventsWeightsPosterior;
		/// <summary>Field backing the eventsStartTimeWeightsPosterior property</summary>
		private VectorGaussian EventsStartTimeWeightsPosterior;
		/// <summary>Field backing the eventsEndTimeWeightsPosterior property</summary>
		private VectorGaussian EventsEndTimeWeightsPosterior;
		/// <summary>Field backing the eventsFeaturesTest property</summary>
		private Vector[][] EventsFeaturesTest;
		/// <summary>Field backing the eventsStartTimeFeaturesTest property</summary>
		private Vector[][] EventsStartTimeFeaturesTest;
		/// <summary>Field backing the eventsMissingStartTimesTest property</summary>
		private bool[][] EventsMissingStartTimesTest;
		/// <summary>Field backing the eventsEndTimeFeaturesTest property</summary>
		private Vector[][] EventsEndTimeFeaturesTest;
		/// <summary>Field backing the eventsMissingEndTimesTest property</summary>
		private bool[][] EventsMissingEndTimesTest;
		/// <summary>The number of iterations last computed by Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0. Set this to zero to force re-execution of Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0</summary>
		public int Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone;
		/// <summary>The number of iterations last computed by Constant. Set this to zero to force re-execution of Constant</summary>
		public int Constant_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_numTesting. Set this to zero to force re-execution of Changed_numTesting</summary>
		public int Changed_numTesting_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_numTesting_Init_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPoste3. Set this to zero to force re-execution of Changed_numTesting_Init_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPoste3</summary>
		public int Changed_numTesting_Init_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPoste3_iterationsDone;
		/// <summary>True if Changed_numTesting_Init_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPoste3 has performed initialisation. Set this to false to force re-execution of Changed_numTesting_Init_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPoste3</summary>
		public bool Changed_numTesting_Init_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPoste3_isInitialised;
		/// <summary>The number of iterations last computed by Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4. Set this to zero to force re-execution of Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4</summary>
		public int Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_numTesting_routineWeightsPosterior_Init_routineFeaturesTest_numEventsTest_eventsWeightsPoste5. Set this to zero to force re-execution of Changed_numTesting_routineWeightsPosterior_Init_routineFeaturesTest_numEventsTest_eventsWeightsPoste5</summary>
		public int Changed_numTesting_routineWeightsPosterior_Init_routineFeaturesTest_numEventsTest_eventsWeightsPoste5_iterationsDone;
		/// <summary>True if Changed_numTesting_routineWeightsPosterior_Init_routineFeaturesTest_numEventsTest_eventsWeightsPoste5 has performed initialisation. Set this to false to force re-execution of Changed_numTesting_routineWeightsPosterior_Init_routineFeaturesTest_numEventsTest_eventsWeightsPoste5</summary>
		public bool Changed_numTesting_routineWeightsPosterior_Init_routineFeaturesTest_numEventsTest_eventsWeightsPoste5_isInitialised;
		/// <summary>The number of iterations last computed by Changed_routineWeightsPosterior_Init_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPoste6. Set this to zero to force re-execution of Changed_routineWeightsPosterior_Init_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPoste6</summary>
		public int Changed_routineWeightsPosterior_Init_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPoste6_iterationsDone;
		/// <summary>True if Changed_routineWeightsPosterior_Init_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPoste6 has performed initialisation. Set this to false to force re-execution of Changed_routineWeightsPosterior_Init_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPoste6</summary>
		public bool Changed_routineWeightsPosterior_Init_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPoste6_isInitialised;
		/// <summary>The number of iterations last computed by Changed_numTesting_eventsWeightsPosterior. Set this to zero to force re-execution of Changed_numTesting_eventsWeightsPosterior</summary>
		public int Changed_numTesting_eventsWeightsPosterior_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_numTesting_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeaturesTest_numEvents8. Set this to zero to force re-execution of Changed_numTesting_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeaturesTest_numEvents8</summary>
		public int Changed_numTesting_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeaturesTest_numEvents8_iterationsDone;
		/// <summary>True if Changed_numTesting_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeaturesTest_numEvents8 has performed initialisation. Set this to false to force re-execution of Changed_numTesting_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeaturesTest_numEvents8</summary>
		public bool Changed_numTesting_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeaturesTest_numEvents8_isInitialised;
		/// <summary>The number of iterations last computed by Changed_numTesting_numEventsTest. Set this to zero to force re-execution of Changed_numTesting_numEventsTest</summary>
		public int Changed_numTesting_numEventsTest_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeatures10. Set this to zero to force re-execution of Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeatures10</summary>
		public int Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeatures10_iterationsDone;
		/// <summary>True if Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeatures10 has performed initialisation. Set this to false to force re-execution of Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeatures10</summary>
		public bool Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeatures10_isInitialised;
		/// <summary>The number of iterations last computed by Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_ev11. Set this to zero to force re-execution of Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_ev11</summary>
		public int Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_ev11_iterationsDone;
		/// <summary>True if Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_ev11 has performed initialisation. Set this to false to force re-execution of Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_ev11</summary>
		public bool Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_ev11_isInitialised;
		/// <summary>The number of iterations last computed by Changed_numTesting_eventsStartTimeWeightsPosterior. Set this to zero to force re-execution of Changed_numTesting_eventsStartTimeWeightsPosterior</summary>
		public int Changed_numTesting_eventsStartTimeWeightsPosterior_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_numTesting_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosteri13. Set this to zero to force re-execution of Changed_numTesting_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosteri13</summary>
		public int Changed_numTesting_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosteri13_iterationsDone;
		/// <summary>True if Changed_numTesting_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosteri13 has performed initialisation. Set this to false to force re-execution of Changed_numTesting_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosteri13</summary>
		public bool Changed_numTesting_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosteri13_isInitialised;
		/// <summary>The number of iterations last computed by Changed_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosteri14. Set this to zero to force re-execution of Changed_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosteri14</summary>
		public int Changed_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosteri14_iterationsDone;
		/// <summary>True if Changed_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosteri14 has performed initialisation. Set this to false to force re-execution of Changed_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosteri14</summary>
		public bool Changed_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosteri14_isInitialised;
		/// <summary>The number of iterations last computed by Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_events15. Set this to zero to force re-execution of Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_events15</summary>
		public int Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_events15_iterationsDone;
		/// <summary>True if Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_events15 has performed initialisation. Set this to false to force re-execution of Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_events15</summary>
		public bool Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_events15_isInitialised;
		/// <summary>The number of iterations last computed by Changed_numTesting_eventsEndTimeWeightsPosterior. Set this to zero to force re-execution of Changed_numTesting_eventsEndTimeWeightsPosterior</summary>
		public int Changed_numTesting_eventsEndTimeWeightsPosterior_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_numTesting_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosterior17. Set this to zero to force re-execution of Changed_numTesting_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosterior17</summary>
		public int Changed_numTesting_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosterior17_iterationsDone;
		/// <summary>True if Changed_numTesting_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosterior17 has performed initialisation. Set this to false to force re-execution of Changed_numTesting_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosterior17</summary>
		public bool Changed_numTesting_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosterior17_isInitialised;
		/// <summary>The number of iterations last computed by Changed_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosterior18. Set this to zero to force re-execution of Changed_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosterior18</summary>
		public int Changed_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosterior18_iterationsDone;
		/// <summary>True if Changed_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosterior18 has performed initialisation. Set this to false to force re-execution of Changed_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosterior18</summary>
		public bool Changed_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosterior18_isInitialised;
		/// <summary>The number of iterations last computed by Changed_numTesting_numEventsTest_Init_eventsWeightsPosterior_routineWeightsPosterior_routineFeatures19. Set this to zero to force re-execution of Changed_numTesting_numEventsTest_Init_eventsWeightsPosterior_routineWeightsPosterior_routineFeatures19</summary>
		public int Changed_numTesting_numEventsTest_Init_eventsWeightsPosterior_routineWeightsPosterior_routineFeatures19_iterationsDone;
		/// <summary>True if Changed_numTesting_numEventsTest_Init_eventsWeightsPosterior_routineWeightsPosterior_routineFeatures19 has performed initialisation. Set this to false to force re-execution of Changed_numTesting_numEventsTest_Init_eventsWeightsPosterior_routineWeightsPosterior_routineFeatures19</summary>
		public bool Changed_numTesting_numEventsTest_Init_eventsWeightsPosterior_routineWeightsPosterior_routineFeatures19_isInitialised;
		/// <summary>The number of iterations last computed by Changed_eventsWeightsPosterior_Init_numTesting_routineWeightsPosterior_routineFeaturesTest_numEvents20. Set this to zero to force re-execution of Changed_eventsWeightsPosterior_Init_numTesting_routineWeightsPosterior_routineFeaturesTest_numEvents20</summary>
		public int Changed_eventsWeightsPosterior_Init_numTesting_routineWeightsPosterior_routineFeaturesTest_numEvents20_iterationsDone;
		/// <summary>True if Changed_eventsWeightsPosterior_Init_numTesting_routineWeightsPosterior_routineFeaturesTest_numEvents20 has performed initialisation. Set this to false to force re-execution of Changed_eventsWeightsPosterior_Init_numTesting_routineWeightsPosterior_routineFeaturesTest_numEvents20</summary>
		public bool Changed_eventsWeightsPosterior_Init_numTesting_routineWeightsPosterior_routineFeaturesTest_numEvents20_isInitialised;
		/// <summary>Messages from use of 'routineContributionsTest'</summary>
		public DistributionStructArray<Gaussian,double>[] routineContributionsTest_uses_B;
		public DistributionRefArray<VectorGaussian,Vector> vVector34_rep_B;
		public DistributionStructArray<Gaussian,double> routineContributionsTest_F;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<VectorGaussian></summary>
		public VectorGaussian vVector34_rep_B_toDef;
		public DistributionRefArray<VectorGaussian,Vector> vVector36_rep_F;
		public DistributionRefArray<VectorGaussian,Vector> vVector37_rep_F;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<VectorGaussian></summary>
		public VectorGaussian vVector37_rep_B_toDef;
		public DistributionRefArray<VectorGaussian,Vector> vVector38_rep_F;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<VectorGaussian></summary>
		public VectorGaussian vVector38_rep_B_toDef;
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTest_F;
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTest_depth2_B;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<VectorGaussian></summary>
		public VectorGaussian vVector36_rep_B_toDef;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<Gaussian></summary>
		public DistributionStructArray<Gaussian,double> routineContributionsTest_uses_B_Ntest__toDef;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<VectorGaussian></summary>
		public DistributionRefArray<VectorGaussian,Vector> vVector36_rep_rep_B_toDef;
		public DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]> vVector36_rep_rep_B;
		public DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]> vVector37_rep_rep_B;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<VectorGaussian></summary>
		public DistributionRefArray<VectorGaussian,Vector> vVector37_rep_rep_B_toDef;
		public DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]> vVector38_rep_rep_B;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<VectorGaussian></summary>
		public DistributionRefArray<VectorGaussian,Vector> vVector38_rep_rep_B_toDef;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<DistributionStructArray<Gaussian,double>></summary>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTest_uses_B_Ntest__toDef;
		/// <summary>Message to marginal of 'vVector34'</summary>
		public VectorGaussian vVector34_marginal_F;
		/// <summary>Message to marginal of 'routineContributionsTest'</summary>
		public DistributionStructArray<Gaussian,double> routineContributionsTest_marginal_F;
		/// <summary>Message to marginal of 'vVector36'</summary>
		public VectorGaussian vVector36_marginal_F;
		/// <summary>Message to marginal of 'vVector37'</summary>
		public VectorGaussian vVector37_marginal_F;
		/// <summary>Message to marginal of 'vVector38'</summary>
		public VectorGaussian vVector38_marginal_F;
		/// <summary>Message to marginal of 'eventsContributionsTest'</summary>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTest_marginal_F;
		/// <summary>Message to marginal of 'observedCountsTest'</summary>
		public DistributionStructArray<Gaussian,double> observedCountsTest_marginal_F;
		public PointMass<int> numTesting_marginal;
		public PointMass<VectorGaussian> routineWeightsPosterior_marginal;
		public PointMass<Vector[]> routineFeaturesTest_marginal;
		public PointMass<int[]> numEventsTest_marginal;
		public PointMass<VectorGaussian> eventsWeightsPosterior_marginal;
		public PointMass<VectorGaussian> eventsStartTimeWeightsPosterior_marginal;
		public PointMass<VectorGaussian> eventsEndTimeWeightsPosterior_marginal;
		public PointMass<Vector[][]> eventsFeaturesTest_marginal;
		public PointMass<Vector[][]> eventsStartTimeFeaturesTest_marginal;
		public DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]> eventsMissingStartTimesTest_marginal;
		public PointMass<Vector[][]> eventsEndTimeFeaturesTest_marginal;
		public DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]> eventsMissingEndTimesTest_marginal;
		#endregion

		#region Properties
		/// <summary>The number of iterations done from the initial state</summary>
		public int NumberOfIterationsDone
		{			get {
				return this.numberOfIterationsDone;
			}
		}

		/// <summary>The externally-specified value of 'numTesting'</summary>
		public int numTesting
		{			get {
				return this.NumTesting;
			}
			set {
				if (this.NumTesting!=value) {
					this.NumTesting = value;
					this.numberOfIterationsDone = 0;
					this.Changed_eventsWeightsPosterior_Init_numTesting_routineWeightsPosterior_routineFeaturesTest_numEvents20_isInitialised = false;
					this.Changed_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosterior18_isInitialised = false;
					this.Changed_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosteri14_isInitialised = false;
					this.Changed_routineWeightsPosterior_Init_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPoste6_isInitialised = false;
					this.Changed_numTesting_iterationsDone = 0;
					this.Changed_numTesting_eventsEndTimeWeightsPosterior_iterationsDone = 0;
					this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosterior17_iterationsDone = 0;
					this.Changed_numTesting_eventsStartTimeWeightsPosterior_iterationsDone = 0;
					this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosteri13_iterationsDone = 0;
					this.Changed_numTesting_numEventsTest_iterationsDone = 0;
					this.Changed_numTesting_numEventsTest_Init_eventsWeightsPosterior_routineWeightsPosterior_routineFeatures19_iterationsDone = 0;
					this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_events15_iterationsDone = 0;
					this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_ev11_iterationsDone = 0;
					this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeatures10_iterationsDone = 0;
					this.Changed_numTesting_eventsWeightsPosterior_iterationsDone = 0;
					this.Changed_numTesting_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeaturesTest_numEvents8_iterationsDone = 0;
					this.Changed_numTesting_routineWeightsPosterior_Init_routineFeaturesTest_numEventsTest_eventsWeightsPoste5_iterationsDone = 0;
					this.Changed_numTesting_Init_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPoste3_iterationsDone = 0;
					this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
					this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone = 0;
				}
			}
		}

		/// <summary>The externally-specified value of 'routineWeightsPosterior'</summary>
		public VectorGaussian routineWeightsPosterior
		{			get {
				return this.RoutineWeightsPosterior;
			}
			set {
				this.RoutineWeightsPosterior = value;
				this.numberOfIterationsDone = 0;
				this.Changed_eventsWeightsPosterior_Init_numTesting_routineWeightsPosterior_routineFeaturesTest_numEvents20_isInitialised = false;
				this.Changed_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosterior18_isInitialised = false;
				this.Changed_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosteri14_isInitialised = false;
				this.Changed_routineWeightsPosterior_Init_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPoste6_iterationsDone = 0;
				this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosterior17_isInitialised = false;
				this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosteri13_isInitialised = false;
				this.Changed_numTesting_numEventsTest_Init_eventsWeightsPosterior_routineWeightsPosterior_routineFeatures19_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_events15_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_ev11_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeatures10_isInitialised = false;
				this.Changed_numTesting_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeaturesTest_numEvents8_isInitialised = false;
				this.Changed_numTesting_routineWeightsPosterior_Init_routineFeaturesTest_numEventsTest_eventsWeightsPoste5_iterationsDone = 0;
				this.Changed_numTesting_Init_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPoste3_isInitialised = false;
				this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
				this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'routineFeaturesTest'</summary>
		public Vector[] routineFeaturesTest
		{			get {
				return this.RoutineFeaturesTest;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTesting)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTesting)+" was expected for variable \'routineFeaturesTest\'");
				}
				this.RoutineFeaturesTest = value;
				this.numberOfIterationsDone = 0;
				this.Changed_eventsWeightsPosterior_Init_numTesting_routineWeightsPosterior_routineFeaturesTest_numEvents20_isInitialised = false;
				this.Changed_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosterior18_isInitialised = false;
				this.Changed_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosteri14_isInitialised = false;
				this.Changed_routineWeightsPosterior_Init_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPoste6_isInitialised = false;
				this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosterior17_isInitialised = false;
				this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosteri13_isInitialised = false;
				this.Changed_numTesting_numEventsTest_Init_eventsWeightsPosterior_routineWeightsPosterior_routineFeatures19_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_events15_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_ev11_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeatures10_isInitialised = false;
				this.Changed_numTesting_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeaturesTest_numEvents8_isInitialised = false;
				this.Changed_numTesting_routineWeightsPosterior_Init_routineFeaturesTest_numEventsTest_eventsWeightsPoste5_isInitialised = false;
				this.Changed_numTesting_Init_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPoste3_isInitialised = false;
				this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
				this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'numEventsTest'</summary>
		public int[] numEventsTest
		{			get {
				return this.NumEventsTest;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTesting)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTesting)+" was expected for variable \'numEventsTest\'");
				}
				this.NumEventsTest = value;
				this.numberOfIterationsDone = 0;
				this.Changed_eventsWeightsPosterior_Init_numTesting_routineWeightsPosterior_routineFeaturesTest_numEvents20_isInitialised = false;
				this.Changed_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosterior18_isInitialised = false;
				this.Changed_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosteri14_isInitialised = false;
				this.Changed_routineWeightsPosterior_Init_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPoste6_isInitialised = false;
				this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosterior17_isInitialised = false;
				this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosteri13_isInitialised = false;
				this.Changed_numTesting_numEventsTest_iterationsDone = 0;
				this.Changed_numTesting_numEventsTest_Init_eventsWeightsPosterior_routineWeightsPosterior_routineFeatures19_iterationsDone = 0;
				this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_events15_iterationsDone = 0;
				this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_ev11_iterationsDone = 0;
				this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeatures10_iterationsDone = 0;
				this.Changed_numTesting_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeaturesTest_numEvents8_isInitialised = false;
				this.Changed_numTesting_routineWeightsPosterior_Init_routineFeaturesTest_numEventsTest_eventsWeightsPoste5_isInitialised = false;
				this.Changed_numTesting_Init_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPoste3_isInitialised = false;
				this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
				this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'eventsWeightsPosterior'</summary>
		public VectorGaussian eventsWeightsPosterior
		{			get {
				return this.EventsWeightsPosterior;
			}
			set {
				this.EventsWeightsPosterior = value;
				this.numberOfIterationsDone = 0;
				this.Changed_eventsWeightsPosterior_Init_numTesting_routineWeightsPosterior_routineFeaturesTest_numEvents20_iterationsDone = 0;
				this.Changed_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosterior18_isInitialised = false;
				this.Changed_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosteri14_isInitialised = false;
				this.Changed_routineWeightsPosterior_Init_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPoste6_isInitialised = false;
				this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosterior17_isInitialised = false;
				this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosteri13_isInitialised = false;
				this.Changed_numTesting_numEventsTest_Init_eventsWeightsPosterior_routineWeightsPosterior_routineFeatures19_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_events15_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_ev11_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeatures10_iterationsDone = 0;
				this.Changed_numTesting_eventsWeightsPosterior_iterationsDone = 0;
				this.Changed_numTesting_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeaturesTest_numEvents8_iterationsDone = 0;
				this.Changed_numTesting_routineWeightsPosterior_Init_routineFeaturesTest_numEventsTest_eventsWeightsPoste5_isInitialised = false;
				this.Changed_numTesting_Init_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPoste3_isInitialised = false;
				this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
				this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'eventsStartTimeWeightsPosterior'</summary>
		public VectorGaussian eventsStartTimeWeightsPosterior
		{			get {
				return this.EventsStartTimeWeightsPosterior;
			}
			set {
				this.EventsStartTimeWeightsPosterior = value;
				this.numberOfIterationsDone = 0;
				this.Changed_eventsWeightsPosterior_Init_numTesting_routineWeightsPosterior_routineFeaturesTest_numEvents20_isInitialised = false;
				this.Changed_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosterior18_isInitialised = false;
				this.Changed_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosteri14_iterationsDone = 0;
				this.Changed_routineWeightsPosterior_Init_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPoste6_isInitialised = false;
				this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosterior17_isInitialised = false;
				this.Changed_numTesting_eventsStartTimeWeightsPosterior_iterationsDone = 0;
				this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosteri13_iterationsDone = 0;
				this.Changed_numTesting_numEventsTest_Init_eventsWeightsPosterior_routineWeightsPosterior_routineFeatures19_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_events15_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_ev11_iterationsDone = 0;
				this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeatures10_isInitialised = false;
				this.Changed_numTesting_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeaturesTest_numEvents8_isInitialised = false;
				this.Changed_numTesting_routineWeightsPosterior_Init_routineFeaturesTest_numEventsTest_eventsWeightsPoste5_isInitialised = false;
				this.Changed_numTesting_Init_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPoste3_isInitialised = false;
				this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
				this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'eventsEndTimeWeightsPosterior'</summary>
		public VectorGaussian eventsEndTimeWeightsPosterior
		{			get {
				return this.EventsEndTimeWeightsPosterior;
			}
			set {
				this.EventsEndTimeWeightsPosterior = value;
				this.numberOfIterationsDone = 0;
				this.Changed_eventsWeightsPosterior_Init_numTesting_routineWeightsPosterior_routineFeaturesTest_numEvents20_isInitialised = false;
				this.Changed_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosterior18_iterationsDone = 0;
				this.Changed_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosteri14_isInitialised = false;
				this.Changed_routineWeightsPosterior_Init_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPoste6_isInitialised = false;
				this.Changed_numTesting_eventsEndTimeWeightsPosterior_iterationsDone = 0;
				this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosterior17_iterationsDone = 0;
				this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosteri13_isInitialised = false;
				this.Changed_numTesting_numEventsTest_Init_eventsWeightsPosterior_routineWeightsPosterior_routineFeatures19_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_events15_iterationsDone = 0;
				this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_ev11_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeatures10_isInitialised = false;
				this.Changed_numTesting_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeaturesTest_numEvents8_isInitialised = false;
				this.Changed_numTesting_routineWeightsPosterior_Init_routineFeaturesTest_numEventsTest_eventsWeightsPoste5_isInitialised = false;
				this.Changed_numTesting_Init_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPoste3_isInitialised = false;
				this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
				this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'eventsFeaturesTest'</summary>
		public Vector[][] eventsFeaturesTest
		{			get {
				return this.EventsFeaturesTest;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTesting)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTesting)+" was expected for variable \'eventsFeaturesTest\'");
				}
				this.EventsFeaturesTest = value;
				this.numberOfIterationsDone = 0;
				this.Changed_eventsWeightsPosterior_Init_numTesting_routineWeightsPosterior_routineFeaturesTest_numEvents20_isInitialised = false;
				this.Changed_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosterior18_isInitialised = false;
				this.Changed_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosteri14_isInitialised = false;
				this.Changed_routineWeightsPosterior_Init_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPoste6_isInitialised = false;
				this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosterior17_isInitialised = false;
				this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosteri13_isInitialised = false;
				this.Changed_numTesting_numEventsTest_Init_eventsWeightsPosterior_routineWeightsPosterior_routineFeatures19_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_events15_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_ev11_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeatures10_isInitialised = false;
				this.Changed_numTesting_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeaturesTest_numEvents8_isInitialised = false;
				this.Changed_numTesting_routineWeightsPosterior_Init_routineFeaturesTest_numEventsTest_eventsWeightsPoste5_isInitialised = false;
				this.Changed_numTesting_Init_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPoste3_isInitialised = false;
				this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
				this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'eventsStartTimeFeaturesTest'</summary>
		public Vector[][] eventsStartTimeFeaturesTest
		{			get {
				return this.EventsStartTimeFeaturesTest;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTesting)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTesting)+" was expected for variable \'eventsStartTimeFeaturesTest\'");
				}
				this.EventsStartTimeFeaturesTest = value;
				this.numberOfIterationsDone = 0;
				this.Changed_eventsWeightsPosterior_Init_numTesting_routineWeightsPosterior_routineFeaturesTest_numEvents20_isInitialised = false;
				this.Changed_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosterior18_isInitialised = false;
				this.Changed_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosteri14_isInitialised = false;
				this.Changed_routineWeightsPosterior_Init_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPoste6_isInitialised = false;
				this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosterior17_isInitialised = false;
				this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosteri13_isInitialised = false;
				this.Changed_numTesting_numEventsTest_Init_eventsWeightsPosterior_routineWeightsPosterior_routineFeatures19_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_events15_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_ev11_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeatures10_isInitialised = false;
				this.Changed_numTesting_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeaturesTest_numEvents8_isInitialised = false;
				this.Changed_numTesting_routineWeightsPosterior_Init_routineFeaturesTest_numEventsTest_eventsWeightsPoste5_isInitialised = false;
				this.Changed_numTesting_Init_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPoste3_isInitialised = false;
				this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
				this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'eventsMissingStartTimesTest'</summary>
		public bool[][] eventsMissingStartTimesTest
		{			get {
				return this.EventsMissingStartTimesTest;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTesting)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTesting)+" was expected for variable \'eventsMissingStartTimesTest\'");
				}
				this.EventsMissingStartTimesTest = value;
				this.numberOfIterationsDone = 0;
				this.Changed_eventsWeightsPosterior_Init_numTesting_routineWeightsPosterior_routineFeaturesTest_numEvents20_isInitialised = false;
				this.Changed_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosterior18_isInitialised = false;
				this.Changed_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosteri14_isInitialised = false;
				this.Changed_routineWeightsPosterior_Init_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPoste6_isInitialised = false;
				this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosterior17_isInitialised = false;
				this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosteri13_isInitialised = false;
				this.Changed_numTesting_numEventsTest_Init_eventsWeightsPosterior_routineWeightsPosterior_routineFeatures19_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_events15_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_ev11_iterationsDone = 0;
				this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeatures10_isInitialised = false;
				this.Changed_numTesting_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeaturesTest_numEvents8_isInitialised = false;
				this.Changed_numTesting_routineWeightsPosterior_Init_routineFeaturesTest_numEventsTest_eventsWeightsPoste5_isInitialised = false;
				this.Changed_numTesting_Init_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPoste3_isInitialised = false;
				this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
				this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'eventsEndTimeFeaturesTest'</summary>
		public Vector[][] eventsEndTimeFeaturesTest
		{			get {
				return this.EventsEndTimeFeaturesTest;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTesting)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTesting)+" was expected for variable \'eventsEndTimeFeaturesTest\'");
				}
				this.EventsEndTimeFeaturesTest = value;
				this.numberOfIterationsDone = 0;
				this.Changed_eventsWeightsPosterior_Init_numTesting_routineWeightsPosterior_routineFeaturesTest_numEvents20_isInitialised = false;
				this.Changed_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosterior18_isInitialised = false;
				this.Changed_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosteri14_isInitialised = false;
				this.Changed_routineWeightsPosterior_Init_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPoste6_isInitialised = false;
				this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosterior17_isInitialised = false;
				this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosteri13_isInitialised = false;
				this.Changed_numTesting_numEventsTest_Init_eventsWeightsPosterior_routineWeightsPosterior_routineFeatures19_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_events15_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_ev11_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeatures10_isInitialised = false;
				this.Changed_numTesting_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeaturesTest_numEvents8_isInitialised = false;
				this.Changed_numTesting_routineWeightsPosterior_Init_routineFeaturesTest_numEventsTest_eventsWeightsPoste5_isInitialised = false;
				this.Changed_numTesting_Init_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPoste3_isInitialised = false;
				this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
				this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'eventsMissingEndTimesTest'</summary>
		public bool[][] eventsMissingEndTimesTest
		{			get {
				return this.EventsMissingEndTimesTest;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTesting)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTesting)+" was expected for variable \'eventsMissingEndTimesTest\'");
				}
				this.EventsMissingEndTimesTest = value;
				this.numberOfIterationsDone = 0;
				this.Changed_eventsWeightsPosterior_Init_numTesting_routineWeightsPosterior_routineFeaturesTest_numEvents20_isInitialised = false;
				this.Changed_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosterior18_isInitialised = false;
				this.Changed_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosteri14_isInitialised = false;
				this.Changed_routineWeightsPosterior_Init_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPoste6_isInitialised = false;
				this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosterior17_isInitialised = false;
				this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosteri13_isInitialised = false;
				this.Changed_numTesting_numEventsTest_Init_eventsWeightsPosterior_routineWeightsPosterior_routineFeatures19_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_events15_iterationsDone = 0;
				this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_ev11_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeatures10_isInitialised = false;
				this.Changed_numTesting_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeaturesTest_numEvents8_isInitialised = false;
				this.Changed_numTesting_routineWeightsPosterior_Init_routineFeaturesTest_numEventsTest_eventsWeightsPoste5_isInitialised = false;
				this.Changed_numTesting_Init_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPoste3_isInitialised = false;
				this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
				this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone = 0;
			}
		}

		#endregion

		#region Methods
		/// <summary>Get the observed value of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		public object GetObservedValue(string variableName)
		{
			if (variableName=="numTesting") {
				return this.numTesting;
			}
			if (variableName=="routineWeightsPosterior") {
				return this.routineWeightsPosterior;
			}
			if (variableName=="routineFeaturesTest") {
				return this.routineFeaturesTest;
			}
			if (variableName=="numEventsTest") {
				return this.numEventsTest;
			}
			if (variableName=="eventsWeightsPosterior") {
				return this.eventsWeightsPosterior;
			}
			if (variableName=="eventsStartTimeWeightsPosterior") {
				return this.eventsStartTimeWeightsPosterior;
			}
			if (variableName=="eventsEndTimeWeightsPosterior") {
				return this.eventsEndTimeWeightsPosterior;
			}
			if (variableName=="eventsFeaturesTest") {
				return this.eventsFeaturesTest;
			}
			if (variableName=="eventsStartTimeFeaturesTest") {
				return this.eventsStartTimeFeaturesTest;
			}
			if (variableName=="eventsMissingStartTimesTest") {
				return this.eventsMissingStartTimesTest;
			}
			if (variableName=="eventsEndTimeFeaturesTest") {
				return this.eventsEndTimeFeaturesTest;
			}
			if (variableName=="eventsMissingEndTimesTest") {
				return this.eventsMissingEndTimesTest;
			}
			throw new ArgumentException("Not an observed variable name: "+variableName);
		}

		/// <summary>Set the observed value of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		/// <param name="value">Observed value</param>
		public void SetObservedValue(string variableName, object value)
		{
			if (variableName=="numTesting") {
				this.numTesting = (int)value;
				return ;
			}
			if (variableName=="routineWeightsPosterior") {
				this.routineWeightsPosterior = (VectorGaussian)value;
				return ;
			}
			if (variableName=="routineFeaturesTest") {
				this.routineFeaturesTest = (Vector[])value;
				return ;
			}
			if (variableName=="numEventsTest") {
				this.numEventsTest = (int[])value;
				return ;
			}
			if (variableName=="eventsWeightsPosterior") {
				this.eventsWeightsPosterior = (VectorGaussian)value;
				return ;
			}
			if (variableName=="eventsStartTimeWeightsPosterior") {
				this.eventsStartTimeWeightsPosterior = (VectorGaussian)value;
				return ;
			}
			if (variableName=="eventsEndTimeWeightsPosterior") {
				this.eventsEndTimeWeightsPosterior = (VectorGaussian)value;
				return ;
			}
			if (variableName=="eventsFeaturesTest") {
				this.eventsFeaturesTest = (Vector[][])value;
				return ;
			}
			if (variableName=="eventsStartTimeFeaturesTest") {
				this.eventsStartTimeFeaturesTest = (Vector[][])value;
				return ;
			}
			if (variableName=="eventsMissingStartTimesTest") {
				this.eventsMissingStartTimesTest = (bool[][])value;
				return ;
			}
			if (variableName=="eventsEndTimeFeaturesTest") {
				this.eventsEndTimeFeaturesTest = (Vector[][])value;
				return ;
			}
			if (variableName=="eventsMissingEndTimesTest") {
				this.eventsMissingEndTimesTest = (bool[][])value;
				return ;
			}
			throw new ArgumentException("Not an observed variable name: "+variableName);
		}

		/// <summary>The marginal distribution of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		public object Marginal(string variableName)
		{
			if (variableName=="vVector34") {
				return this.VVector34Marginal();
			}
			if (variableName=="routineContributionsTest") {
				return this.RoutineContributionsTestMarginal();
			}
			if (variableName=="vVector36") {
				return this.VVector36Marginal();
			}
			if (variableName=="vVector37") {
				return this.VVector37Marginal();
			}
			if (variableName=="vVector38") {
				return this.VVector38Marginal();
			}
			if (variableName=="eventsContributionsTest") {
				return this.EventsContributionsTestMarginal();
			}
			if (variableName=="observedCountsTest") {
				return this.ObservedCountsTestMarginal();
			}
			if (variableName=="numTesting") {
				return this.NumTestingMarginal();
			}
			if (variableName=="routineWeightsPosterior") {
				return this.RoutineWeightsPosteriorMarginal();
			}
			if (variableName=="routineFeaturesTest") {
				return this.RoutineFeaturesTestMarginal();
			}
			if (variableName=="numEventsTest") {
				return this.NumEventsTestMarginal();
			}
			if (variableName=="eventsWeightsPosterior") {
				return this.EventsWeightsPosteriorMarginal();
			}
			if (variableName=="eventsStartTimeWeightsPosterior") {
				return this.EventsStartTimeWeightsPosteriorMarginal();
			}
			if (variableName=="eventsEndTimeWeightsPosterior") {
				return this.EventsEndTimeWeightsPosteriorMarginal();
			}
			if (variableName=="eventsFeaturesTest") {
				return this.EventsFeaturesTestMarginal();
			}
			if (variableName=="eventsStartTimeFeaturesTest") {
				return this.EventsStartTimeFeaturesTestMarginal();
			}
			if (variableName=="eventsMissingStartTimesTest") {
				return this.EventsMissingStartTimesTestMarginal();
			}
			if (variableName=="eventsEndTimeFeaturesTest") {
				return this.EventsEndTimeFeaturesTestMarginal();
			}
			if (variableName=="eventsMissingEndTimesTest") {
				return this.EventsMissingEndTimesTestMarginal();
			}
			throw new ArgumentException("This class was not built to infer "+variableName);
		}

		public T Marginal<T>(string variableName)
		{
			return Distribution.ChangeType<T>(this.Marginal(variableName));
		}

		/// <summary>The query-specific marginal distribution of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		/// <param name="query">QueryType name. For example, GibbsSampling answers 'Marginal', 'Samples', and 'Conditionals' queries</param>
		public object Marginal(string variableName, string query)
		{
			if (query=="Marginal") {
				return this.Marginal(variableName);
			}
			throw new ArgumentException(((("This class was not built to infer \'"+variableName)+"\' with query \'")+query)+"\'");
		}

		public T Marginal<T>(string variableName, string query)
		{
			return Distribution.ChangeType<T>(this.Marginal(variableName, query));
		}

		/// <summary>Update all marginals, by iterating message passing the given number of times</summary>
		/// <param name="numberOfIterations">The number of times to iterate each loop</param>
		/// <param name="initialise">If true, messages that initialise loops are reset when observed values change</param>
		private void Execute(int numberOfIterations, bool initialise)
		{
			if (numberOfIterations<this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone) {
				this.Changed_eventsWeightsPosterior_Init_numTesting_routineWeightsPosterior_routineFeaturesTest_numEvents20_isInitialised = false;
				this.Changed_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosterior18_isInitialised = false;
				this.Changed_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosteri14_isInitialised = false;
				this.Changed_routineWeightsPosterior_Init_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPoste6_isInitialised = false;
				this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosterior17_isInitialised = false;
				this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosteri13_isInitialised = false;
				this.Changed_numTesting_numEventsTest_Init_eventsWeightsPosterior_routineWeightsPosterior_routineFeatures19_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_events15_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_ev11_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeatures10_isInitialised = false;
				this.Changed_numTesting_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeaturesTest_numEvents8_isInitialised = false;
				this.Changed_numTesting_routineWeightsPosterior_Init_routineFeaturesTest_numEventsTest_eventsWeightsPoste5_isInitialised = false;
				this.Changed_numTesting_Init_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPoste3_isInitialised = false;
				this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
			}
			this.Constant();
			this.Changed_eventsWeightsPosterior_Init_numTesting_routineWeightsPosterior_routineFeaturesTest_numEvents20(initialise);
			this.Changed_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosterior18(initialise);
			this.Changed_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosteri14(initialise);
			this.Changed_routineWeightsPosterior_Init_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPoste6(initialise);
			this.Changed_numTesting();
			this.Changed_numTesting_eventsEndTimeWeightsPosterior();
			this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosterior17(initialise);
			this.Changed_numTesting_eventsStartTimeWeightsPosterior();
			this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosteri13(initialise);
			this.Changed_numTesting_numEventsTest();
			this.Changed_numTesting_numEventsTest_Init_eventsWeightsPosterior_routineWeightsPosterior_routineFeatures19(initialise);
			this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_events15(initialise);
			this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_ev11(initialise);
			this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeatures10(initialise);
			this.Changed_numTesting_eventsWeightsPosterior();
			this.Changed_numTesting_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeaturesTest_numEvents8(initialise);
			this.Changed_numTesting_routineWeightsPosterior_Init_routineFeaturesTest_numEventsTest_eventsWeightsPoste5(initialise);
			this.Changed_numTesting_Init_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPoste3(initialise);
			this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4(numberOfIterations);
			this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0();
			this.numberOfIterationsDone = numberOfIterations;
		}

		public void Execute(int numberOfIterations)
		{
			this.Execute(numberOfIterations, true);
		}

		public void Update(int additionalIterations)
		{
			this.Execute(this.numberOfIterationsDone+additionalIterations, false);
		}

		private void OnProgressChanged(ProgressChangedEventArgs e)
		{
			// Make a temporary copy of the event to avoid a race condition
			// if the last subscriber unsubscribes immediately after the null check and before the event is raised.
			EventHandler<ProgressChangedEventArgs> handler = this.ProgressChanged;
			if (handler!=null) {
				handler(this, e);
			}
		}

		/// <summary>Reset all messages to their initial values.  Sets NumberOfIterationsDone to 0.</summary>
		public void Reset()
		{
			this.Execute(0);
		}

		/// <summary>Computations that do not depend on observed values</summary>
		public void Constant()
		{
			if (this.Constant_iterationsDone==1) {
				return ;
			}
			this.Constant_iterationsDone = 1;
			this.Changed_numTesting_iterationsDone = 0;
			this.Changed_routineWeightsPosterior_Init_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPoste6_iterationsDone = 0;
			this.Changed_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosteri14_iterationsDone = 0;
			this.Changed_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosterior18_iterationsDone = 0;
			this.Changed_eventsWeightsPosterior_Init_numTesting_routineWeightsPosterior_routineFeaturesTest_numEvents20_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of eventsWeightsPosterior and must reset on changes to numTesting and routineWeightsPosterior and routineFeaturesTest and numEventsTest and eventsStartTimeWeightsPosterior and eventsEndTimeWeightsPosterior and eventsFeaturesTest and eventsStartTimeFeaturesTest and eventsMissingStartTimesTest and eventsEndTimeFeaturesTest and eventsMissingEndTimesTest and numberOfIterationsDecreased</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_eventsWeightsPosterior_Init_numTesting_routineWeightsPosterior_routineFeaturesTest_numEvents20(bool initialise)
		{
			if ((this.Changed_eventsWeightsPosterior_Init_numTesting_routineWeightsPosterior_routineFeaturesTest_numEvents20_iterationsDone==1)&&((!initialise)||this.Changed_eventsWeightsPosterior_Init_numTesting_routineWeightsPosterior_routineFeaturesTest_numEvents20_isInitialised)) {
				return ;
			}
			// Message to 'vVector36_rep' from Replicate factor
			this.vVector36_rep_B_toDef = ReplicateOp_Divide.ToDefInit<VectorGaussian>(this.EventsWeightsPosterior);
			this.Changed_eventsWeightsPosterior_Init_numTesting_routineWeightsPosterior_routineFeaturesTest_numEvents20_iterationsDone = 1;
			this.Changed_eventsWeightsPosterior_Init_numTesting_routineWeightsPosterior_routineFeaturesTest_numEvents20_isInitialised = true;
			this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of eventsEndTimeWeightsPosterior and must reset on changes to eventsWeightsPosterior and numTesting and routineWeightsPosterior and routineFeaturesTest and numEventsTest and eventsStartTimeWeightsPosterior and eventsFeaturesTest and eventsStartTimeFeaturesTest and eventsMissingStartTimesTest and eventsEndTimeFeaturesTest and eventsMissingEndTimesTest and numberOfIterationsDecreased</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosterior18(bool initialise)
		{
			if ((this.Changed_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosterior18_iterationsDone==1)&&((!initialise)||this.Changed_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosterior18_isInitialised)) {
				return ;
			}
			// Message to 'vVector38_rep' from Replicate factor
			this.vVector38_rep_B_toDef = ReplicateOp_Divide.ToDefInit<VectorGaussian>(this.EventsEndTimeWeightsPosterior);
			this.Changed_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosterior18_iterationsDone = 1;
			this.Changed_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosterior18_isInitialised = true;
			this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of eventsStartTimeWeightsPosterior and must reset on changes to eventsWeightsPosterior and numTesting and routineWeightsPosterior and routineFeaturesTest and numEventsTest and eventsEndTimeWeightsPosterior and eventsFeaturesTest and eventsStartTimeFeaturesTest and eventsMissingStartTimesTest and eventsEndTimeFeaturesTest and eventsMissingEndTimesTest and numberOfIterationsDecreased</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosteri14(bool initialise)
		{
			if ((this.Changed_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosteri14_iterationsDone==1)&&((!initialise)||this.Changed_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosteri14_isInitialised)) {
				return ;
			}
			// Message to 'vVector37_rep' from Replicate factor
			this.vVector37_rep_B_toDef = ReplicateOp_Divide.ToDefInit<VectorGaussian>(this.EventsStartTimeWeightsPosterior);
			this.Changed_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosteri14_iterationsDone = 1;
			this.Changed_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_numTesting_routineWeightsPosteri14_isInitialised = true;
			this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of routineWeightsPosterior and must reset on changes to numTesting and routineFeaturesTest and numEventsTest and eventsWeightsPosterior and eventsStartTimeWeightsPosterior and eventsEndTimeWeightsPosterior and eventsFeaturesTest and eventsStartTimeFeaturesTest and eventsMissingStartTimesTest and eventsEndTimeFeaturesTest and eventsMissingEndTimesTest and numberOfIterationsDecreased</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_routineWeightsPosterior_Init_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPoste6(bool initialise)
		{
			if ((this.Changed_routineWeightsPosterior_Init_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPoste6_iterationsDone==1)&&((!initialise)||this.Changed_routineWeightsPosterior_Init_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPoste6_isInitialised)) {
				return ;
			}
			// Message to 'vVector34_rep' from Replicate factor
			this.vVector34_rep_B_toDef = ReplicateOp_Divide.ToDefInit<VectorGaussian>(this.RoutineWeightsPosterior);
			this.Changed_routineWeightsPosterior_Init_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPoste6_iterationsDone = 1;
			this.Changed_routineWeightsPosterior_Init_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPoste6_isInitialised = true;
			this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTesting</summary>
		public void Changed_numTesting()
		{
			if (this.Changed_numTesting_iterationsDone==1) {
				return ;
			}
			// Create array for 'routineContributionsTest_uses' Backwards messages.
			this.routineContributionsTest_uses_B = new DistributionStructArray<Gaussian,double>[this.NumTesting];
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for 'routineContributionsTest_uses' Backwards messages.
				this.routineContributionsTest_uses_B[Ntest] = new DistributionStructArray<Gaussian,double>(2);
			}
			// Create array for 'vVector34_rep' Backwards messages.
			this.vVector34_rep_B = new DistributionRefArray<VectorGaussian,Vector>(this.NumTesting);
			// Create array for 'routineContributionsTest' Forwards messages.
			this.routineContributionsTest_F = new DistributionStructArray<Gaussian,double>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				this.routineContributionsTest_F[Ntest] = Gaussian.Uniform();
			}
			// Create array for replicates of 'routineContributionsTest_uses_B_Ntest__toDef'
			this.routineContributionsTest_uses_B_Ntest__toDef = new DistributionStructArray<Gaussian,double>(this.NumTesting);
			// Create array for 'vVector36_rep' Forwards messages.
			this.vVector36_rep_F = new DistributionRefArray<VectorGaussian,Vector>(this.NumTesting);
			// Create array for replicates of 'vVector36_rep_rep_B_toDef'
			this.vVector36_rep_rep_B_toDef = new DistributionRefArray<VectorGaussian,Vector>(this.NumTesting);
			// Create array for replicates of 'vVector36_rep_rep_B'
			this.vVector36_rep_rep_B = new DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]>(this.NumTesting);
			// Create array for replicates of 'vVector37_rep_rep_B'
			this.vVector37_rep_rep_B = new DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]>(this.NumTesting);
			// Create array for 'vVector37_rep' Forwards messages.
			this.vVector37_rep_F = new DistributionRefArray<VectorGaussian,Vector>(this.NumTesting);
			// Create array for replicates of 'vVector37_rep_rep_B_toDef'
			this.vVector37_rep_rep_B_toDef = new DistributionRefArray<VectorGaussian,Vector>(this.NumTesting);
			// Create array for replicates of 'vVector38_rep_rep_B'
			this.vVector38_rep_rep_B = new DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]>(this.NumTesting);
			// Create array for 'vVector38_rep' Forwards messages.
			this.vVector38_rep_F = new DistributionRefArray<VectorGaussian,Vector>(this.NumTesting);
			// Create array for replicates of 'vVector38_rep_rep_B_toDef'
			this.vVector38_rep_rep_B_toDef = new DistributionRefArray<VectorGaussian,Vector>(this.NumTesting);
			// Create array for 'eventsContributionsTest' Forwards messages.
			this.eventsContributionsTest_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			// Create array for 'eventsContributionsTest_depth2' Backwards messages.
			this.eventsContributionsTest_depth2_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			// Create array for replicates of 'eventsContributionsTest_uses_B_Ntest__toDef'
			this.eventsContributionsTest_uses_B_Ntest__toDef = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			this.Changed_numTesting_iterationsDone = 1;
			this.Changed_numTesting_Init_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPoste3_iterationsDone = 0;
			this.Changed_numTesting_routineWeightsPosterior_Init_routineFeaturesTest_numEventsTest_eventsWeightsPoste5_iterationsDone = 0;
			this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
			this.Changed_numTesting_eventsWeightsPosterior_iterationsDone = 0;
			this.Changed_numTesting_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeaturesTest_numEvents8_iterationsDone = 0;
			this.Changed_numTesting_numEventsTest_iterationsDone = 0;
			this.Changed_numTesting_eventsStartTimeWeightsPosterior_iterationsDone = 0;
			this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosteri13_iterationsDone = 0;
			this.Changed_numTesting_eventsEndTimeWeightsPosterior_iterationsDone = 0;
			this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosterior17_iterationsDone = 0;
			this.Changed_numTesting_numEventsTest_Init_eventsWeightsPosterior_routineWeightsPosterior_routineFeatures19_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTesting and eventsEndTimeWeightsPosterior</summary>
		public void Changed_numTesting_eventsEndTimeWeightsPosterior()
		{
			if (this.Changed_numTesting_eventsEndTimeWeightsPosterior_iterationsDone==1) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				this.vVector38_rep_F[Ntest] = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsEndTimeWeightsPosterior);
			}
			this.Changed_numTesting_eventsEndTimeWeightsPosterior_iterationsDone = 1;
			this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosterior17_iterationsDone = 0;
			this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTesting and eventsEndTimeWeightsPosterior and must reset on changes to eventsWeightsPosterior and routineWeightsPosterior and routineFeaturesTest and numEventsTest and eventsStartTimeWeightsPosterior and eventsFeaturesTest and eventsStartTimeFeaturesTest and eventsMissingStartTimesTest and eventsEndTimeFeaturesTest and eventsMissingEndTimesTest and numberOfIterationsDecreased</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_numTesting_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosterior17(bool initialise)
		{
			if ((this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosterior17_iterationsDone==1)&&((!initialise)||this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosterior17_isInitialised)) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Message to 'vVector38_rep_rep' from Replicate factor
				this.vVector38_rep_rep_B_toDef[Ntest] = ReplicateOp_Divide.ToDefInit<VectorGaussian>(this.vVector38_rep_F[Ntest]);
			}
			this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosterior17_iterationsDone = 1;
			this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosterior17_isInitialised = true;
			this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTesting and eventsStartTimeWeightsPosterior</summary>
		public void Changed_numTesting_eventsStartTimeWeightsPosterior()
		{
			if (this.Changed_numTesting_eventsStartTimeWeightsPosterior_iterationsDone==1) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				this.vVector37_rep_F[Ntest] = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsStartTimeWeightsPosterior);
			}
			this.Changed_numTesting_eventsStartTimeWeightsPosterior_iterationsDone = 1;
			this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosteri13_iterationsDone = 0;
			this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTesting and eventsStartTimeWeightsPosterior and must reset on changes to eventsWeightsPosterior and routineWeightsPosterior and routineFeaturesTest and numEventsTest and eventsEndTimeWeightsPosterior and eventsFeaturesTest and eventsStartTimeFeaturesTest and eventsMissingStartTimesTest and eventsEndTimeFeaturesTest and eventsMissingEndTimesTest and numberOfIterationsDecreased</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_numTesting_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosteri13(bool initialise)
		{
			if ((this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosteri13_iterationsDone==1)&&((!initialise)||this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosteri13_isInitialised)) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Message to 'vVector37_rep_rep' from Replicate factor
				this.vVector37_rep_rep_B_toDef[Ntest] = ReplicateOp_Divide.ToDefInit<VectorGaussian>(this.vVector37_rep_F[Ntest]);
			}
			this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosteri13_iterationsDone = 1;
			this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_eventsWeightsPosterior_routineWeightsPosteri13_isInitialised = true;
			this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTesting and numEventsTest</summary>
		public void Changed_numTesting_numEventsTest()
		{
			if (this.Changed_numTesting_numEventsTest_iterationsDone==1) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for 'vVector36_rep_rep' Backwards messages.
				this.vVector36_rep_rep_B[Ntest] = new DistributionRefArray<VectorGaussian,Vector>(this.NumEventsTest[Ntest]);
				// Create array for 'vVector37_rep_rep' Backwards messages.
				this.vVector37_rep_rep_B[Ntest] = new DistributionRefArray<VectorGaussian,Vector>(this.NumEventsTest[Ntest]);
				// Create array for 'vVector38_rep_rep' Backwards messages.
				this.vVector38_rep_rep_B[Ntest] = new DistributionRefArray<VectorGaussian,Vector>(this.NumEventsTest[Ntest]);
				// Create array for 'eventsContributionsTest' Forwards messages.
				this.eventsContributionsTest_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					this.eventsContributionsTest_F[Ntest][Etest] = Gaussian.Uniform();
				}
				// Create array for 'eventsContributionsTest_depth2' Backwards messages.
				this.eventsContributionsTest_depth2_B[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
			}
			this.Changed_numTesting_numEventsTest_iterationsDone = 1;
			this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeatures10_iterationsDone = 0;
			this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_ev11_iterationsDone = 0;
			this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_events15_iterationsDone = 0;
			this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
			this.Changed_numTesting_numEventsTest_Init_eventsWeightsPosterior_routineWeightsPosterior_routineFeatures19_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTesting and numEventsTest and must reset on changes to eventsWeightsPosterior and routineWeightsPosterior and routineFeaturesTest and eventsStartTimeWeightsPosterior and eventsEndTimeWeightsPosterior and eventsFeaturesTest and eventsStartTimeFeaturesTest and eventsMissingStartTimesTest and eventsEndTimeFeaturesTest and eventsMissingEndTimesTest and numberOfIterationsDecreased</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_numTesting_numEventsTest_Init_eventsWeightsPosterior_routineWeightsPosterior_routineFeatures19(bool initialise)
		{
			if ((this.Changed_numTesting_numEventsTest_Init_eventsWeightsPosterior_routineWeightsPosterior_routineFeatures19_iterationsDone==1)&&((!initialise)||this.Changed_numTesting_numEventsTest_Init_eventsWeightsPosterior_routineWeightsPosterior_routineFeatures19_isInitialised)) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					this.eventsContributionsTest_depth2_B[Ntest][Etest] = Gaussian.Uniform();
				}
				// Message to 'eventsContributionsTest_uses' from Replicate factor
				this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest] = ReplicateOp_Divide.ToDefInit<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTest_F[Ntest]);
			}
			this.Changed_numTesting_numEventsTest_Init_eventsWeightsPosterior_routineWeightsPosterior_routineFeatures19_iterationsDone = 1;
			this.Changed_numTesting_numEventsTest_Init_eventsWeightsPosterior_routineWeightsPosterior_routineFeatures19_isInitialised = true;
			this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTesting and numEventsTest and eventsEndTimeWeightsPosterior and eventsMissingEndTimesTest and must reset on changes to eventsWeightsPosterior and routineWeightsPosterior and routineFeaturesTest and eventsStartTimeWeightsPosterior and eventsFeaturesTest and eventsStartTimeFeaturesTest and eventsMissingStartTimesTest and eventsEndTimeFeaturesTest and numberOfIterationsDecreased</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_events15(bool initialise)
		{
			if ((this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_events15_iterationsDone==1)&&((!initialise)||this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_events15_isInitialised)) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					this.vVector38_rep_rep_B[Ntest][Etest] = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsEndTimeWeightsPosterior);
				}
			}
			this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_events15_iterationsDone = 1;
			this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_events15_isInitialised = true;
			this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTesting and numEventsTest and eventsStartTimeWeightsPosterior and eventsMissingStartTimesTest and must reset on changes to eventsWeightsPosterior and routineWeightsPosterior and routineFeaturesTest and eventsEndTimeWeightsPosterior and eventsFeaturesTest and eventsStartTimeFeaturesTest and eventsEndTimeFeaturesTest and eventsMissingEndTimesTest and numberOfIterationsDecreased</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_ev11(bool initialise)
		{
			if ((this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_ev11_iterationsDone==1)&&((!initialise)||this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_ev11_isInitialised)) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					this.vVector37_rep_rep_B[Ntest][Etest] = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsStartTimeWeightsPosterior);
				}
			}
			this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_ev11_iterationsDone = 1;
			this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_ev11_isInitialised = true;
			this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTesting and numEventsTest and eventsWeightsPosterior and must reset on changes to routineWeightsPosterior and routineFeaturesTest and eventsStartTimeWeightsPosterior and eventsEndTimeWeightsPosterior and eventsFeaturesTest and eventsStartTimeFeaturesTest and eventsMissingStartTimesTest and eventsEndTimeFeaturesTest and eventsMissingEndTimesTest and numberOfIterationsDecreased</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeatures10(bool initialise)
		{
			if ((this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeatures10_iterationsDone==1)&&((!initialise)||this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeatures10_isInitialised)) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					this.vVector36_rep_rep_B[Ntest][Etest] = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsWeightsPosterior);
				}
			}
			this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeatures10_iterationsDone = 1;
			this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeatures10_isInitialised = true;
			this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTesting and eventsWeightsPosterior</summary>
		public void Changed_numTesting_eventsWeightsPosterior()
		{
			if (this.Changed_numTesting_eventsWeightsPosterior_iterationsDone==1) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				this.vVector36_rep_F[Ntest] = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsWeightsPosterior);
			}
			this.Changed_numTesting_eventsWeightsPosterior_iterationsDone = 1;
			this.Changed_numTesting_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeaturesTest_numEvents8_iterationsDone = 0;
			this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTesting and eventsWeightsPosterior and must reset on changes to routineWeightsPosterior and routineFeaturesTest and numEventsTest and eventsStartTimeWeightsPosterior and eventsEndTimeWeightsPosterior and eventsFeaturesTest and eventsStartTimeFeaturesTest and eventsMissingStartTimesTest and eventsEndTimeFeaturesTest and eventsMissingEndTimesTest and numberOfIterationsDecreased</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_numTesting_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeaturesTest_numEvents8(bool initialise)
		{
			if ((this.Changed_numTesting_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeaturesTest_numEvents8_iterationsDone==1)&&((!initialise)||this.Changed_numTesting_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeaturesTest_numEvents8_isInitialised)) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Message to 'vVector36_rep_rep' from Replicate factor
				this.vVector36_rep_rep_B_toDef[Ntest] = ReplicateOp_Divide.ToDefInit<VectorGaussian>(this.vVector36_rep_F[Ntest]);
			}
			this.Changed_numTesting_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeaturesTest_numEvents8_iterationsDone = 1;
			this.Changed_numTesting_eventsWeightsPosterior_Init_routineWeightsPosterior_routineFeaturesTest_numEvents8_isInitialised = true;
			this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTesting and routineWeightsPosterior and must reset on changes to routineFeaturesTest and numEventsTest and eventsWeightsPosterior and eventsStartTimeWeightsPosterior and eventsEndTimeWeightsPosterior and eventsFeaturesTest and eventsStartTimeFeaturesTest and eventsMissingStartTimesTest and eventsEndTimeFeaturesTest and eventsMissingEndTimesTest and numberOfIterationsDecreased</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_numTesting_routineWeightsPosterior_Init_routineFeaturesTest_numEventsTest_eventsWeightsPoste5(bool initialise)
		{
			if ((this.Changed_numTesting_routineWeightsPosterior_Init_routineFeaturesTest_numEventsTest_eventsWeightsPoste5_iterationsDone==1)&&((!initialise)||this.Changed_numTesting_routineWeightsPosterior_Init_routineFeaturesTest_numEventsTest_eventsWeightsPoste5_isInitialised)) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				this.vVector34_rep_B[Ntest] = ArrayHelper.MakeUniform<VectorGaussian>(this.RoutineWeightsPosterior);
			}
			this.Changed_numTesting_routineWeightsPosterior_Init_routineFeaturesTest_numEventsTest_eventsWeightsPoste5_iterationsDone = 1;
			this.Changed_numTesting_routineWeightsPosterior_Init_routineFeaturesTest_numEventsTest_eventsWeightsPoste5_isInitialised = true;
			this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTesting and must reset on changes to routineWeightsPosterior and routineFeaturesTest and numEventsTest and eventsWeightsPosterior and eventsStartTimeWeightsPosterior and eventsEndTimeWeightsPosterior and eventsFeaturesTest and eventsStartTimeFeaturesTest and eventsMissingStartTimesTest and eventsEndTimeFeaturesTest and eventsMissingEndTimesTest and numberOfIterationsDecreased</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_numTesting_Init_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPoste3(bool initialise)
		{
			if ((this.Changed_numTesting_Init_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPoste3_iterationsDone==1)&&((!initialise)||this.Changed_numTesting_Init_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPoste3_isInitialised)) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				for(int _ind = 0; _ind<2; _ind++) {
					this.routineContributionsTest_uses_B[Ntest][_ind] = Gaussian.Uniform();
				}
				// Message to 'routineContributionsTest_uses' from Replicate factor
				this.routineContributionsTest_uses_B_Ntest__toDef[Ntest] = ReplicateOp_Divide.ToDefInit<Gaussian>(this.routineContributionsTest_F[Ntest]);
			}
			this.Changed_numTesting_Init_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPoste3_iterationsDone = 1;
			this.Changed_numTesting_Init_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPoste3_isInitialised = true;
			this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of routineWeightsPosterior and numTesting and routineFeaturesTest and numEventsTest and eventsWeightsPosterior and eventsStartTimeWeightsPosterior and eventsEndTimeWeightsPosterior and eventsFeaturesTest and eventsStartTimeFeaturesTest and eventsMissingStartTimesTest and eventsEndTimeFeaturesTest and eventsMissingEndTimesTest and numberOfIterationsDecreased</summary>
		/// <param name="numberOfIterations">The number of times to iterate each loop</param>
		public void Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4(int numberOfIterations)
		{
			if (this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone==numberOfIterations) {
				return ;
			}
			// Buffer for ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>
			VectorGaussian vVector34_rep_F_marginal = default(VectorGaussian);
			// Message to 'vVector34_rep' from Replicate factor
			vVector34_rep_F_marginal = ReplicateOp_Divide.MarginalInit<VectorGaussian>(this.RoutineWeightsPosterior);
			DistributionRefArray<VectorGaussian,Vector> vVector34_rep_F = default(DistributionRefArray<VectorGaussian,Vector>);
			// Create array for 'vVector34_rep' Forwards messages.
			vVector34_rep_F = new DistributionRefArray<VectorGaussian,Vector>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				vVector34_rep_F[Ntest] = ArrayHelper.MakeUniform<VectorGaussian>(this.RoutineWeightsPosterior);
			}
			// Buffer for InnerProductOp.BMean
			// Create array for replicates of 'vVector34_rep_F_Ntest__BVariance'
			PositiveDefiniteMatrix[] vVector34_rep_F_Ntest__BVariance = new PositiveDefiniteMatrix[this.NumTesting];
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Message to 'vdouble82' from InnerProduct factor
				vVector34_rep_F_Ntest__BVariance[Ntest] = InnerProductOp.BVarianceInit(vVector34_rep_F[Ntest]);
			}
			// Buffer for InnerProductOp.InnerProductAverageConditional
			// Create array for replicates of 'vVector34_rep_F_Ntest__BMean'
			Vector[] vVector34_rep_F_Ntest__BMean = new Vector[this.NumTesting];
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Message to 'vdouble82' from InnerProduct factor
				vVector34_rep_F_Ntest__BMean[Ntest] = InnerProductOp.BMeanInit(vVector34_rep_F[Ntest]);
			}
			// Create array for replicates of 'vdouble82_F'
			DistributionStructArray<Gaussian,double> vdouble82_F = new DistributionStructArray<Gaussian,double>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				vdouble82_F[Ntest] = Gaussian.Uniform();
			}
			// Buffer for ReplicateOp_Divide.UsesAverageConditional<Gaussian>
			// Create array for replicates of 'routineContributionsTest_uses_F_Ntest__marginal'
			DistributionStructArray<Gaussian,double> routineContributionsTest_uses_F_Ntest__marginal = new DistributionStructArray<Gaussian,double>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Message to 'routineContributionsTest_uses' from Replicate factor
				routineContributionsTest_uses_F_Ntest__marginal[Ntest] = ReplicateOp_Divide.MarginalInit<Gaussian>(this.routineContributionsTest_F[Ntest]);
			}
			// Messages to use of 'routineContributionsTest'
			DistributionStructArray<Gaussian,double>[] routineContributionsTest_uses_F = default(DistributionStructArray<Gaussian,double>[]);
			// Create array for 'routineContributionsTest_uses' Forwards messages.
			routineContributionsTest_uses_F = new DistributionStructArray<Gaussian,double>[this.NumTesting];
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for 'routineContributionsTest_uses' Forwards messages.
				routineContributionsTest_uses_F[Ntest] = new DistributionStructArray<Gaussian,double>(2);
				for(int _ind = 0; _ind<2; _ind++) {
					routineContributionsTest_uses_F[Ntest][_ind] = Gaussian.Uniform();
				}
			}
			// Create array for replicates of 'vdouble82_B'
			DistributionStructArray<Gaussian,double> vdouble82_B = new DistributionStructArray<Gaussian,double>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				vdouble82_B[Ntest] = Gaussian.Uniform();
			}
			// Message to 'vVector34_rep' from Replicate factor
			vVector34_rep_F_marginal = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector34_rep_B_toDef, this.RoutineWeightsPosterior, vVector34_rep_F_marginal);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Message to 'vVector34_rep' from Replicate factor
				vVector34_rep_F[Ntest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector34_rep_B[Ntest], vVector34_rep_F_marginal, Ntest, vVector34_rep_F[Ntest]);
				// Message to 'vdouble82' from InnerProduct factor
				vVector34_rep_F_Ntest__BVariance[Ntest] = InnerProductOp.BVariance(vVector34_rep_F[Ntest], vVector34_rep_F_Ntest__BVariance[Ntest]);
				// Message to 'vdouble82' from InnerProduct factor
				vVector34_rep_F_Ntest__BMean[Ntest] = InnerProductOp.BMean(vVector34_rep_F[Ntest], vVector34_rep_F_Ntest__BVariance[Ntest], vVector34_rep_F_Ntest__BMean[Ntest]);
				// Message to 'vdouble82' from InnerProduct factor
				vdouble82_F[Ntest] = InnerProductOp.InnerProductAverageConditional(this.RoutineFeaturesTest[Ntest], vVector34_rep_F_Ntest__BMean[Ntest], vVector34_rep_F_Ntest__BVariance[Ntest]);
				// Message to 'routineContributionsTest' from GaussianFromMeanAndVariance factor
				this.routineContributionsTest_F[Ntest] = GaussianFromMeanAndVarianceOp.SampleAverageConditional(vdouble82_F[Ntest], 1.0);
				// Message to 'routineContributionsTest_uses' from Replicate factor
				routineContributionsTest_uses_F_Ntest__marginal[Ntest] = ReplicateOp_Divide.Marginal<Gaussian>(this.routineContributionsTest_uses_B_Ntest__toDef[Ntest], this.routineContributionsTest_F[Ntest], routineContributionsTest_uses_F_Ntest__marginal[Ntest]);
			}
			for(int iteration = this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone; iteration<numberOfIterations; iteration++) {
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Message to 'routineContributionsTest_uses' from Replicate factor
					routineContributionsTest_uses_F[Ntest][0] = ReplicateOp_Divide.UsesAverageConditional<Gaussian>(this.routineContributionsTest_uses_B[Ntest][0], routineContributionsTest_uses_F_Ntest__marginal[Ntest], 0, routineContributionsTest_uses_F[Ntest][0]);
					// Message to 'routineContributionsTest_uses' from IsPositive factor
					this.routineContributionsTest_uses_B[Ntest][0] = IsPositiveOp_Proper.XAverageConditional(Bernoulli.PointMass(true), routineContributionsTest_uses_F[Ntest][0]);
					// Message to 'routineContributionsTest_uses' from Replicate factor
					this.routineContributionsTest_uses_B_Ntest__toDef[Ntest] = ReplicateOp_Divide.ToDef<Gaussian>(this.routineContributionsTest_uses_B[Ntest], this.routineContributionsTest_uses_B_Ntest__toDef[Ntest]);
					// Message to 'vdouble82' from GaussianFromMeanAndVariance factor
					vdouble82_B[Ntest] = GaussianFromMeanAndVarianceOp.MeanAverageConditional(this.routineContributionsTest_uses_B_Ntest__toDef[Ntest], 1.0);
					// Message to 'vVector34_rep' from InnerProduct factor
					this.vVector34_rep_B[Ntest] = InnerProductOp.BAverageConditional(vdouble82_B[Ntest], this.RoutineFeaturesTest[Ntest], this.vVector34_rep_B[Ntest]);
				}
				// Message to 'vVector34_rep' from Replicate factor
				this.vVector34_rep_B_toDef = ReplicateOp_Divide.ToDef<VectorGaussian>(this.vVector34_rep_B, this.vVector34_rep_B_toDef);
				// Message to 'vVector34_rep' from Replicate factor
				vVector34_rep_F_marginal = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector34_rep_B_toDef, this.RoutineWeightsPosterior, vVector34_rep_F_marginal);
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Message to 'vVector34_rep' from Replicate factor
					vVector34_rep_F[Ntest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector34_rep_B[Ntest], vVector34_rep_F_marginal, Ntest, vVector34_rep_F[Ntest]);
					// Message to 'vdouble82' from InnerProduct factor
					vVector34_rep_F_Ntest__BVariance[Ntest] = InnerProductOp.BVariance(vVector34_rep_F[Ntest], vVector34_rep_F_Ntest__BVariance[Ntest]);
					// Message to 'vdouble82' from InnerProduct factor
					vVector34_rep_F_Ntest__BMean[Ntest] = InnerProductOp.BMean(vVector34_rep_F[Ntest], vVector34_rep_F_Ntest__BVariance[Ntest], vVector34_rep_F_Ntest__BMean[Ntest]);
					// Message to 'vdouble82' from InnerProduct factor
					vdouble82_F[Ntest] = InnerProductOp.InnerProductAverageConditional(this.RoutineFeaturesTest[Ntest], vVector34_rep_F_Ntest__BMean[Ntest], vVector34_rep_F_Ntest__BVariance[Ntest]);
					// Message to 'routineContributionsTest' from GaussianFromMeanAndVariance factor
					this.routineContributionsTest_F[Ntest] = GaussianFromMeanAndVarianceOp.SampleAverageConditional(vdouble82_F[Ntest], 1.0);
					// Message to 'routineContributionsTest_uses' from Replicate factor
					routineContributionsTest_uses_F_Ntest__marginal[Ntest] = ReplicateOp_Divide.Marginal<Gaussian>(this.routineContributionsTest_uses_B_Ntest__toDef[Ntest], this.routineContributionsTest_F[Ntest], routineContributionsTest_uses_F_Ntest__marginal[Ntest]);
				}
				this.OnProgressChanged(new ProgressChangedEventArgs(iteration));
			}
			this.vVector34_marginal_F = ArrayHelper.MakeUniform<VectorGaussian>(this.RoutineWeightsPosterior);
			// Message to 'vVector34_marginal' from Variable factor
			this.vVector34_marginal_F = VariableOp.MarginalAverageConditional<VectorGaussian>(this.vVector34_rep_B_toDef, this.RoutineWeightsPosterior, this.vVector34_marginal_F);
			// Messages from use of 'eventsContributionsTest'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>[] eventsContributionsTest_uses_B = default(DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>[]);
			// Create array for 'eventsContributionsTest_uses' Backwards messages.
			eventsContributionsTest_uses_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>[this.NumTesting];
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for 'eventsContributionsTest_uses' Backwards messages.
				eventsContributionsTest_uses_B[Ntest] = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(2);
				for(int _ind = 0; _ind<2; _ind++) {
					// Create array for 'eventsContributionsTest_uses' Backwards messages.
					eventsContributionsTest_uses_B[Ntest][_ind] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						eventsContributionsTest_uses_B[Ntest][_ind][Etest] = Gaussian.Uniform();
					}
				}
			}
			// Buffer for ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>
			VectorGaussian vVector36_rep_F_marginal = default(VectorGaussian);
			// Message to 'vVector36_rep' from Replicate factor
			vVector36_rep_F_marginal = ReplicateOp_Divide.MarginalInit<VectorGaussian>(this.EventsWeightsPosterior);
			// Buffer for ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>
			// Create array for replicates of 'vVector36_rep_rep_F_marginal'
			DistributionRefArray<VectorGaussian,Vector> vVector36_rep_rep_F_marginal = new DistributionRefArray<VectorGaussian,Vector>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Message to 'vVector36_rep_rep' from Replicate factor
				vVector36_rep_rep_F_marginal[Ntest] = ReplicateOp_Divide.MarginalInit<VectorGaussian>(this.vVector36_rep_F[Ntest]);
			}
			// Create array for replicates of 'vVector36_rep_rep_F'
			DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]> vVector36_rep_rep_F = new DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for 'vVector36_rep_rep' Forwards messages.
				vVector36_rep_rep_F[Ntest] = new DistributionRefArray<VectorGaussian,Vector>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					vVector36_rep_rep_F[Ntest][Etest] = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsWeightsPosterior);
				}
			}
			// Buffer for InnerProductOp.BMean
			// Create array for replicates of 'vVector36_rep_rep_F_Etest__BVariance'
			PositiveDefiniteMatrix[][] vVector36_rep_rep_F_Etest__BVariance = new PositiveDefiniteMatrix[this.NumTesting][];
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vVector36_rep_rep_F_Etest__BVariance'
				vVector36_rep_rep_F_Etest__BVariance[Ntest] = new PositiveDefiniteMatrix[this.NumEventsTest[Ntest]];
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					// Message to 'vdouble86' from InnerProduct factor
					vVector36_rep_rep_F_Etest__BVariance[Ntest][Etest] = InnerProductOp.BVarianceInit(vVector36_rep_rep_F[Ntest][Etest]);
				}
			}
			// Buffer for InnerProductOp.InnerProductAverageConditional
			// Create array for replicates of 'vVector36_rep_rep_F_Etest__BMean'
			Vector[][] vVector36_rep_rep_F_Etest__BMean = new Vector[this.NumTesting][];
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vVector36_rep_rep_F_Etest__BMean'
				vVector36_rep_rep_F_Etest__BMean[Ntest] = new Vector[this.NumEventsTest[Ntest]];
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					// Message to 'vdouble86' from InnerProduct factor
					vVector36_rep_rep_F_Etest__BMean[Ntest][Etest] = InnerProductOp.BMeanInit(vVector36_rep_rep_F[Ntest][Etest]);
				}
			}
			// Create array for replicates of 'vdouble86_F'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble86_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble86_F'
				vdouble86_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					vdouble86_F[Ntest][Etest] = Gaussian.Uniform();
				}
			}
			// Create array for replicates of 'vdouble88_F'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble88_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble88_F'
				vdouble88_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					vdouble88_F[Ntest][Etest] = Gaussian.Uniform();
				}
			}
			// Create array for replicates of 'vdouble89_B'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble89_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble89_B'
				vdouble89_B[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					vdouble89_B[Ntest][Etest] = Gaussian.Uniform();
				}
			}
			// Create array for replicates of 'vdouble91_B'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble91_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble91_B'
				vdouble91_B[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (!this.EventsMissingStartTimesTest[Ntest][Etest]) {
						vdouble91_B[Ntest][Etest] = Gaussian.Uniform();
					}
				}
			}
			// Create array for replicates of 'vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_B'
			DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]> vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_B = new DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_B'
				vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_B[Ntest] = new DistributionRefArray<VectorGaussian,Vector>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (!this.EventsMissingStartTimesTest[Ntest][Etest]) {
						vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_B[Ntest][Etest] = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsStartTimeWeightsPosterior);
					}
				}
			}
			// Buffer for ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>
			VectorGaussian vVector37_rep_F_marginal = default(VectorGaussian);
			// Message to 'vVector37_rep' from Replicate factor
			vVector37_rep_F_marginal = ReplicateOp_Divide.MarginalInit<VectorGaussian>(this.EventsStartTimeWeightsPosterior);
			// Buffer for ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>
			// Create array for replicates of 'vVector37_rep_rep_F_marginal'
			DistributionRefArray<VectorGaussian,Vector> vVector37_rep_rep_F_marginal = new DistributionRefArray<VectorGaussian,Vector>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Message to 'vVector37_rep_rep' from Replicate factor
				vVector37_rep_rep_F_marginal[Ntest] = ReplicateOp_Divide.MarginalInit<VectorGaussian>(this.vVector37_rep_F[Ntest]);
			}
			// Create array for replicates of 'vVector37_rep_rep_F'
			DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]> vVector37_rep_rep_F = new DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for 'vVector37_rep_rep' Forwards messages.
				vVector37_rep_rep_F[Ntest] = new DistributionRefArray<VectorGaussian,Vector>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					vVector37_rep_rep_F[Ntest][Etest] = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsStartTimeWeightsPosterior);
				}
			}
			// Buffer for InnerProductOp.BMean
			// Create array for replicates of 'vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BVariance'
			PositiveDefiniteMatrix[][] vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BVariance = new PositiveDefiniteMatrix[this.NumTesting][];
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BVariance'
				vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BVariance[Ntest] = new PositiveDefiniteMatrix[this.NumEventsTest[Ntest]];
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (!this.EventsMissingStartTimesTest[Ntest][Etest]) {
						// Message to 'vdouble91' from InnerProduct factor
						vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest] = InnerProductOp.BVarianceInit(vVector37_rep_rep_F[Ntest][Etest]);
					}
				}
			}
			// Buffer for InnerProductOp.InnerProductAverageConditional
			// Create array for replicates of 'vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BMean'
			Vector[][] vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BMean = new Vector[this.NumTesting][];
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BMean'
				vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BMean[Ntest] = new Vector[this.NumEventsTest[Ntest]];
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (!this.EventsMissingStartTimesTest[Ntest][Etest]) {
						// Message to 'vdouble91' from InnerProduct factor
						vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BMean[Ntest][Etest] = InnerProductOp.BMeanInit(vVector37_rep_rep_F[Ntest][Etest]);
					}
				}
			}
			// Create array for replicates of 'vdouble91_F'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble91_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble91_F'
				vdouble91_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (!this.EventsMissingStartTimesTest[Ntest][Etest]) {
						vdouble91_F[Ntest][Etest] = Gaussian.Uniform();
					}
				}
			}
			// Create array for replicates of 'vdouble89_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble89_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble89_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F'
				vdouble89_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (!this.EventsMissingStartTimesTest[Ntest][Etest]) {
						vdouble89_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F[Ntest][Etest] = Gaussian.Uniform();
					}
				}
			}
			// Create array for replicates of 'vdouble89_F'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble89_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble89_F'
				vdouble89_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					vdouble89_F[Ntest][Etest] = Gaussian.Uniform();
				}
			}
			Gaussian _hoist = default(Gaussian);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (this.EventsMissingStartTimesTest[Ntest][Etest]) {
						_hoist = Gaussian.Uniform();
						Ntest = this.NumTesting-1;
						Etest = this.NumEventsTest[Ntest]-1;
					}
				}
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (this.EventsMissingStartTimesTest[Ntest][Etest]) {
						_hoist = GaussianOpBase.SampleAverageConditional(0.0, 1.0);
						Ntest = this.NumTesting-1;
						Etest = this.NumEventsTest[Ntest]-1;
					}
				}
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (this.EventsMissingStartTimesTest[Ntest][Etest]) {
						// Message to 'vdouble89' from Copy factor
						vdouble89_F[Ntest][Etest] = ArrayHelper.SetTo<Gaussian>(vdouble89_F[Ntest][Etest], _hoist);
					}
				}
			}
			// Create array for replicates of 'vdouble103_F'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble103_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble103_F'
				vdouble103_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					vdouble103_F[Ntest][Etest] = Gaussian.Uniform();
				}
			}
			// Create array for replicates of 'vdouble90_B'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble90_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble90_B'
				vdouble90_B[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					vdouble90_B[Ntest][Etest] = Gaussian.Uniform();
				}
			}
			// Create array for replicates of 'vdouble97_B'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble97_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble97_B'
				vdouble97_B[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (!this.EventsMissingEndTimesTest[Ntest][Etest]) {
						vdouble97_B[Ntest][Etest] = Gaussian.Uniform();
					}
				}
			}
			// Create array for replicates of 'vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_B'
			DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]> vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_B = new DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_B'
				vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_B[Ntest] = new DistributionRefArray<VectorGaussian,Vector>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (!this.EventsMissingEndTimesTest[Ntest][Etest]) {
						vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_B[Ntest][Etest] = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsEndTimeWeightsPosterior);
					}
				}
			}
			// Buffer for ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>
			VectorGaussian vVector38_rep_F_marginal = default(VectorGaussian);
			// Message to 'vVector38_rep' from Replicate factor
			vVector38_rep_F_marginal = ReplicateOp_Divide.MarginalInit<VectorGaussian>(this.EventsEndTimeWeightsPosterior);
			// Buffer for ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>
			// Create array for replicates of 'vVector38_rep_rep_F_marginal'
			DistributionRefArray<VectorGaussian,Vector> vVector38_rep_rep_F_marginal = new DistributionRefArray<VectorGaussian,Vector>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Message to 'vVector38_rep_rep' from Replicate factor
				vVector38_rep_rep_F_marginal[Ntest] = ReplicateOp_Divide.MarginalInit<VectorGaussian>(this.vVector38_rep_F[Ntest]);
			}
			// Create array for replicates of 'vVector38_rep_rep_F'
			DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]> vVector38_rep_rep_F = new DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for 'vVector38_rep_rep' Forwards messages.
				vVector38_rep_rep_F[Ntest] = new DistributionRefArray<VectorGaussian,Vector>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					vVector38_rep_rep_F[Ntest][Etest] = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsEndTimeWeightsPosterior);
				}
			}
			// Buffer for InnerProductOp.BMean
			// Create array for replicates of 'vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BVariance'
			PositiveDefiniteMatrix[][] vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BVariance = new PositiveDefiniteMatrix[this.NumTesting][];
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BVariance'
				vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BVariance[Ntest] = new PositiveDefiniteMatrix[this.NumEventsTest[Ntest]];
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (!this.EventsMissingEndTimesTest[Ntest][Etest]) {
						// Message to 'vdouble97' from InnerProduct factor
						vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest] = InnerProductOp.BVarianceInit(vVector38_rep_rep_F[Ntest][Etest]);
					}
				}
			}
			// Buffer for InnerProductOp.InnerProductAverageConditional
			// Create array for replicates of 'vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BMean'
			Vector[][] vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BMean = new Vector[this.NumTesting][];
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BMean'
				vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BMean[Ntest] = new Vector[this.NumEventsTest[Ntest]];
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (!this.EventsMissingEndTimesTest[Ntest][Etest]) {
						// Message to 'vdouble97' from InnerProduct factor
						vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BMean[Ntest][Etest] = InnerProductOp.BMeanInit(vVector38_rep_rep_F[Ntest][Etest]);
					}
				}
			}
			// Create array for replicates of 'vdouble97_F'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble97_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble97_F'
				vdouble97_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (!this.EventsMissingEndTimesTest[Ntest][Etest]) {
						vdouble97_F[Ntest][Etest] = Gaussian.Uniform();
					}
				}
			}
			// Create array for replicates of 'vdouble90_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble90_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble90_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F'
				vdouble90_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (!this.EventsMissingEndTimesTest[Ntest][Etest]) {
						vdouble90_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F[Ntest][Etest] = Gaussian.Uniform();
					}
				}
			}
			// Create array for replicates of 'vdouble90_F'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble90_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble90_F'
				vdouble90_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					vdouble90_F[Ntest][Etest] = Gaussian.Uniform();
				}
			}
			Gaussian _hoist2 = default(Gaussian);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (this.EventsMissingEndTimesTest[Ntest][Etest]) {
						_hoist2 = Gaussian.Uniform();
						Ntest = this.NumTesting-1;
						Etest = this.NumEventsTest[Ntest]-1;
					}
				}
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (this.EventsMissingEndTimesTest[Ntest][Etest]) {
						_hoist2 = GaussianOpBase.SampleAverageConditional(0.0, 1.0);
						Ntest = this.NumTesting-1;
						Etest = this.NumEventsTest[Ntest]-1;
					}
				}
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (this.EventsMissingEndTimesTest[Ntest][Etest]) {
						// Message to 'vdouble90' from Copy factor
						vdouble90_F[Ntest][Etest] = ArrayHelper.SetTo<Gaussian>(vdouble90_F[Ntest][Etest], _hoist2);
					}
				}
			}
			// Buffer for ReplicateOp_Divide.UsesAverageConditional<DistributionStructArray<Gaussian,double>>
			// Create array for replicates of 'eventsContributionsTest_uses_F_Ntest__marginal'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTest_uses_F_Ntest__marginal = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Message to 'eventsContributionsTest_uses' from Replicate factor
				eventsContributionsTest_uses_F_Ntest__marginal[Ntest] = ReplicateOp_Divide.MarginalInit<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTest_F[Ntest]);
			}
			// Messages to use of 'eventsContributionsTest'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>[] eventsContributionsTest_uses_F = default(DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>[]);
			// Create array for 'eventsContributionsTest_uses' Forwards messages.
			eventsContributionsTest_uses_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>[this.NumTesting];
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for 'eventsContributionsTest_uses' Forwards messages.
				eventsContributionsTest_uses_F[Ntest] = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(2);
				for(int _ind = 0; _ind<2; _ind++) {
					// Create array for 'eventsContributionsTest_uses' Forwards messages.
					eventsContributionsTest_uses_F[Ntest][_ind] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						eventsContributionsTest_uses_F[Ntest][_ind][Etest] = Gaussian.Uniform();
					}
				}
			}
			// Create array for replicates of 'vdouble103_B'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble103_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble103_B'
				vdouble103_B[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					vdouble103_B[Ntest][Etest] = Gaussian.Uniform();
				}
			}
			// Message from use of 'vdouble88'
			// Create array for replicates of 'vdouble88_use_B'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble88_use_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble88_use_B'
				vdouble88_use_B[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					vdouble88_use_B[Ntest][Etest] = Gaussian.Uniform();
				}
			}
			// Create array for replicates of 'vdouble86_B'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble86_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble86_B'
				vdouble86_B[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					vdouble86_B[Ntest][Etest] = Gaussian.Uniform();
				}
			}
			// Message to 'vVector38_rep' from Replicate factor
			vVector38_rep_F_marginal = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector38_rep_B_toDef, this.EventsEndTimeWeightsPosterior, vVector38_rep_F_marginal);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Message to 'vVector38_rep' from Replicate factor
				this.vVector38_rep_F[Ntest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector38_rep_rep_B_toDef[Ntest], vVector38_rep_F_marginal, Ntest, this.vVector38_rep_F[Ntest]);
				// Message to 'vVector38_rep_rep' from Replicate factor
				vVector38_rep_rep_F_marginal[Ntest] = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector38_rep_rep_B_toDef[Ntest], this.vVector38_rep_F[Ntest], vVector38_rep_rep_F_marginal[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					// Message to 'vVector38_rep_rep' from Replicate factor
					vVector38_rep_rep_F[Ntest][Etest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector38_rep_rep_B[Ntest][Etest], vVector38_rep_rep_F_marginal[Ntest], Etest, vVector38_rep_rep_F[Ntest][Etest]);
					if (!this.EventsMissingEndTimesTest[Ntest][Etest]) {
						// Message to 'vdouble97' from InnerProduct factor
						vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest] = InnerProductOp.BVariance(vVector38_rep_rep_F[Ntest][Etest], vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest]);
						// Message to 'vdouble97' from InnerProduct factor
						vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BMean[Ntest][Etest] = InnerProductOp.BMean(vVector38_rep_rep_F[Ntest][Etest], vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest], vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BMean[Ntest][Etest]);
						// Message to 'vdouble97' from InnerProduct factor
						vdouble97_F[Ntest][Etest] = InnerProductOp.InnerProductAverageConditional(this.EventsEndTimeFeaturesTest[Ntest][Etest], vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BMean[Ntest][Etest], vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest]);
						// Message to 'vdouble90_cond_eventsMissingEndTimesTest_Ntest__Etest__1' from GaussianFromMeanAndVariance factor
						vdouble90_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F[Ntest][Etest] = GaussianFromMeanAndVarianceOp.SampleAverageConditional(vdouble97_F[Ntest][Etest], 1.0);
						// Message to 'vdouble90' from Copy factor
						vdouble90_F[Ntest][Etest] = ArrayHelper.SetTo<Gaussian>(vdouble90_F[Ntest][Etest], vdouble90_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F[Ntest][Etest]);
					}
				}
			}
			// vdouble90_F[Ntest][Etest] is now updated in all contexts
			// Message to 'vVector37_rep' from Replicate factor
			vVector37_rep_F_marginal = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector37_rep_B_toDef, this.EventsStartTimeWeightsPosterior, vVector37_rep_F_marginal);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Message to 'vVector37_rep' from Replicate factor
				this.vVector37_rep_F[Ntest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector37_rep_rep_B_toDef[Ntest], vVector37_rep_F_marginal, Ntest, this.vVector37_rep_F[Ntest]);
				// Message to 'vVector37_rep_rep' from Replicate factor
				vVector37_rep_rep_F_marginal[Ntest] = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector37_rep_rep_B_toDef[Ntest], this.vVector37_rep_F[Ntest], vVector37_rep_rep_F_marginal[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					// Message to 'vVector37_rep_rep' from Replicate factor
					vVector37_rep_rep_F[Ntest][Etest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector37_rep_rep_B[Ntest][Etest], vVector37_rep_rep_F_marginal[Ntest], Etest, vVector37_rep_rep_F[Ntest][Etest]);
					if (!this.EventsMissingStartTimesTest[Ntest][Etest]) {
						// Message to 'vdouble91' from InnerProduct factor
						vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest] = InnerProductOp.BVariance(vVector37_rep_rep_F[Ntest][Etest], vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest]);
						// Message to 'vdouble91' from InnerProduct factor
						vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BMean[Ntest][Etest] = InnerProductOp.BMean(vVector37_rep_rep_F[Ntest][Etest], vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest], vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BMean[Ntest][Etest]);
						// Message to 'vdouble91' from InnerProduct factor
						vdouble91_F[Ntest][Etest] = InnerProductOp.InnerProductAverageConditional(this.EventsStartTimeFeaturesTest[Ntest][Etest], vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BMean[Ntest][Etest], vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest]);
						// Message to 'vdouble89_cond_eventsMissingStartTimesTest_Ntest__Etest__1' from GaussianFromMeanAndVariance factor
						vdouble89_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F[Ntest][Etest] = GaussianFromMeanAndVarianceOp.SampleAverageConditional(vdouble91_F[Ntest][Etest], 1.0);
						// Message to 'vdouble89' from Copy factor
						vdouble89_F[Ntest][Etest] = ArrayHelper.SetTo<Gaussian>(vdouble89_F[Ntest][Etest], vdouble89_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F[Ntest][Etest]);
					}
				}
			}
			// vdouble89_F[Ntest][Etest] is now updated in all contexts
			// Message to 'vVector36_rep' from Replicate factor
			vVector36_rep_F_marginal = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector36_rep_B_toDef, this.EventsWeightsPosterior, vVector36_rep_F_marginal);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Message to 'vVector36_rep' from Replicate factor
				this.vVector36_rep_F[Ntest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector36_rep_rep_B_toDef[Ntest], vVector36_rep_F_marginal, Ntest, this.vVector36_rep_F[Ntest]);
				// Message to 'vVector36_rep_rep' from Replicate factor
				vVector36_rep_rep_F_marginal[Ntest] = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector36_rep_rep_B_toDef[Ntest], this.vVector36_rep_F[Ntest], vVector36_rep_rep_F_marginal[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					// Message to 'vVector36_rep_rep' from Replicate factor
					vVector36_rep_rep_F[Ntest][Etest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector36_rep_rep_B[Ntest][Etest], vVector36_rep_rep_F_marginal[Ntest], Etest, vVector36_rep_rep_F[Ntest][Etest]);
					// Message to 'vdouble86' from InnerProduct factor
					vVector36_rep_rep_F_Etest__BVariance[Ntest][Etest] = InnerProductOp.BVariance(vVector36_rep_rep_F[Ntest][Etest], vVector36_rep_rep_F_Etest__BVariance[Ntest][Etest]);
					// Message to 'vdouble86' from InnerProduct factor
					vVector36_rep_rep_F_Etest__BMean[Ntest][Etest] = InnerProductOp.BMean(vVector36_rep_rep_F[Ntest][Etest], vVector36_rep_rep_F_Etest__BVariance[Ntest][Etest], vVector36_rep_rep_F_Etest__BMean[Ntest][Etest]);
					// Message to 'vdouble86' from InnerProduct factor
					vdouble86_F[Ntest][Etest] = InnerProductOp.InnerProductAverageConditional(this.EventsFeaturesTest[Ntest][Etest], vVector36_rep_rep_F_Etest__BMean[Ntest][Etest], vVector36_rep_rep_F_Etest__BVariance[Ntest][Etest]);
					// Message to 'vdouble88' from GaussianFromMeanAndVariance factor
					vdouble88_F[Ntest][Etest] = GaussianFromMeanAndVarianceOp.SampleAverageConditional(vdouble86_F[Ntest][Etest], 1.0);
					// Message to 'vdouble103' from Plus factor
					vdouble103_F[Ntest][Etest] = DoublePlusOp.SumAverageConditional(vdouble88_F[Ntest][Etest], vdouble89_F[Ntest][Etest]);
					// Message to 'eventsContributionsTest' from Plus factor
					this.eventsContributionsTest_F[Ntest][Etest] = DoublePlusOp.SumAverageConditional(vdouble103_F[Ntest][Etest], vdouble90_F[Ntest][Etest]);
				}
				// Message to 'eventsContributionsTest_uses' from Replicate factor
				eventsContributionsTest_uses_F_Ntest__marginal[Ntest] = ReplicateOp_Divide.Marginal<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest], this.eventsContributionsTest_F[Ntest], eventsContributionsTest_uses_F_Ntest__marginal[Ntest]);
			}
			// Create array for 'routineContributionsTest_marginal' Forwards messages.
			this.routineContributionsTest_marginal_F = new DistributionStructArray<Gaussian,double>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				this.routineContributionsTest_marginal_F[Ntest] = Gaussian.Uniform();
				// Message to 'routineContributionsTest_marginal' from Variable factor
				this.routineContributionsTest_marginal_F[Ntest] = VariableOp.MarginalAverageConditional<Gaussian>(this.routineContributionsTest_uses_B_Ntest__toDef[Ntest], this.routineContributionsTest_F[Ntest], this.routineContributionsTest_marginal_F[Ntest]);
			}
			for(int iteration = this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone; iteration<numberOfIterations; iteration++) {
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Message to 'eventsContributionsTest_uses' from Replicate factor
					eventsContributionsTest_uses_F[Ntest][0] = ReplicateOp_Divide.UsesAverageConditional<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTest_depth2_B[Ntest], eventsContributionsTest_uses_F_Ntest__marginal[Ntest], 0, eventsContributionsTest_uses_F[Ntest][0]);
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						// Message to 'eventsContributionsTest_depth2' from IsPositive factor
						this.eventsContributionsTest_depth2_B[Ntest][Etest] = IsPositiveOp_Proper.XAverageConditional(Bernoulli.PointMass(true), eventsContributionsTest_uses_F[Ntest][0][Etest]);
						// Message to 'eventsContributionsTest_uses' from Copy factor
						eventsContributionsTest_uses_B[Ntest][0][Etest] = ArrayHelper.SetTo<Gaussian>(eventsContributionsTest_uses_B[Ntest][0][Etest], this.eventsContributionsTest_depth2_B[Ntest][Etest]);
					}
					// Message to 'eventsContributionsTest_uses' from Replicate factor
					this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest] = ReplicateOp_Divide.ToDef<DistributionStructArray<Gaussian,double>>(eventsContributionsTest_uses_B[Ntest], this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest]);
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						// Message to 'vdouble103' from Plus factor
						vdouble103_B[Ntest][Etest] = DoublePlusOp.AAverageConditional(this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest][Etest], vdouble90_F[Ntest][Etest]);
						// Message to 'vdouble88_use' from Plus factor
						vdouble88_use_B[Ntest][Etest] = DoublePlusOp.AAverageConditional(vdouble103_B[Ntest][Etest], vdouble89_F[Ntest][Etest]);
						// Message to 'vdouble86' from GaussianFromMeanAndVariance factor
						vdouble86_B[Ntest][Etest] = GaussianFromMeanAndVarianceOp.MeanAverageConditional(vdouble88_use_B[Ntest][Etest], 1.0);
						// Message to 'vVector36_rep_rep' from InnerProduct factor
						this.vVector36_rep_rep_B[Ntest][Etest] = InnerProductOp.BAverageConditional(vdouble86_B[Ntest][Etest], this.EventsFeaturesTest[Ntest][Etest], this.vVector36_rep_rep_B[Ntest][Etest]);
					}
					// Message to 'vVector36_rep_rep' from Replicate factor
					this.vVector36_rep_rep_B_toDef[Ntest] = ReplicateOp_Divide.ToDef<VectorGaussian>(this.vVector36_rep_rep_B[Ntest], this.vVector36_rep_rep_B_toDef[Ntest]);
				}
				// Message to 'vVector36_rep' from Replicate factor
				this.vVector36_rep_B_toDef = ReplicateOp_Divide.ToDef<VectorGaussian>(this.vVector36_rep_rep_B_toDef, this.vVector36_rep_B_toDef);
				// Message to 'vVector36_rep' from Replicate factor
				vVector36_rep_F_marginal = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector36_rep_B_toDef, this.EventsWeightsPosterior, vVector36_rep_F_marginal);
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Message to 'vVector36_rep' from Replicate factor
					this.vVector36_rep_F[Ntest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector36_rep_rep_B_toDef[Ntest], vVector36_rep_F_marginal, Ntest, this.vVector36_rep_F[Ntest]);
					// Message to 'vVector36_rep_rep' from Replicate factor
					vVector36_rep_rep_F_marginal[Ntest] = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector36_rep_rep_B_toDef[Ntest], this.vVector36_rep_F[Ntest], vVector36_rep_rep_F_marginal[Ntest]);
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						// Message to 'vVector36_rep_rep' from Replicate factor
						vVector36_rep_rep_F[Ntest][Etest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector36_rep_rep_B[Ntest][Etest], vVector36_rep_rep_F_marginal[Ntest], Etest, vVector36_rep_rep_F[Ntest][Etest]);
						// Message to 'vdouble86' from InnerProduct factor
						vVector36_rep_rep_F_Etest__BVariance[Ntest][Etest] = InnerProductOp.BVariance(vVector36_rep_rep_F[Ntest][Etest], vVector36_rep_rep_F_Etest__BVariance[Ntest][Etest]);
						// Message to 'vdouble86' from InnerProduct factor
						vVector36_rep_rep_F_Etest__BMean[Ntest][Etest] = InnerProductOp.BMean(vVector36_rep_rep_F[Ntest][Etest], vVector36_rep_rep_F_Etest__BVariance[Ntest][Etest], vVector36_rep_rep_F_Etest__BMean[Ntest][Etest]);
						// Message to 'vdouble86' from InnerProduct factor
						vdouble86_F[Ntest][Etest] = InnerProductOp.InnerProductAverageConditional(this.EventsFeaturesTest[Ntest][Etest], vVector36_rep_rep_F_Etest__BMean[Ntest][Etest], vVector36_rep_rep_F_Etest__BVariance[Ntest][Etest]);
						// Message to 'vdouble88' from GaussianFromMeanAndVariance factor
						vdouble88_F[Ntest][Etest] = GaussianFromMeanAndVarianceOp.SampleAverageConditional(vdouble86_F[Ntest][Etest], 1.0);
						// Message to 'vdouble89' from Plus factor
						vdouble89_B[Ntest][Etest] = DoublePlusOp.BAverageConditional(vdouble103_B[Ntest][Etest], vdouble88_F[Ntest][Etest]);
						if (!this.EventsMissingStartTimesTest[Ntest][Etest]) {
							// Message to 'vdouble91' from GaussianFromMeanAndVariance factor
							vdouble91_B[Ntest][Etest] = GaussianFromMeanAndVarianceOp.MeanAverageConditional(vdouble89_B[Ntest][Etest], 1.0);
							// Message to 'vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1' from InnerProduct factor
							vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_B[Ntest][Etest] = InnerProductOp.BAverageConditional(vdouble91_B[Ntest][Etest], this.EventsStartTimeFeaturesTest[Ntest][Etest], vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_B[Ntest][Etest]);
							// Message to 'vVector37_rep_rep' from Copy factor
							this.vVector37_rep_rep_B[Ntest][Etest] = ArrayHelper.SetTo<VectorGaussian>(this.vVector37_rep_rep_B[Ntest][Etest], vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_B[Ntest][Etest]);
						}
					}
					// Message to 'vVector37_rep_rep' from Replicate factor
					this.vVector37_rep_rep_B_toDef[Ntest] = ReplicateOp_Divide.ToDef<VectorGaussian>(this.vVector37_rep_rep_B[Ntest], this.vVector37_rep_rep_B_toDef[Ntest]);
				}
				// Message to 'vVector37_rep' from Replicate factor
				this.vVector37_rep_B_toDef = ReplicateOp_Divide.ToDef<VectorGaussian>(this.vVector37_rep_rep_B_toDef, this.vVector37_rep_B_toDef);
				// Message to 'vVector37_rep' from Replicate factor
				vVector37_rep_F_marginal = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector37_rep_B_toDef, this.EventsStartTimeWeightsPosterior, vVector37_rep_F_marginal);
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Message to 'vVector37_rep' from Replicate factor
					this.vVector37_rep_F[Ntest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector37_rep_rep_B_toDef[Ntest], vVector37_rep_F_marginal, Ntest, this.vVector37_rep_F[Ntest]);
					// Message to 'vVector37_rep_rep' from Replicate factor
					vVector37_rep_rep_F_marginal[Ntest] = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector37_rep_rep_B_toDef[Ntest], this.vVector37_rep_F[Ntest], vVector37_rep_rep_F_marginal[Ntest]);
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						// Message to 'vVector37_rep_rep' from Replicate factor
						vVector37_rep_rep_F[Ntest][Etest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector37_rep_rep_B[Ntest][Etest], vVector37_rep_rep_F_marginal[Ntest], Etest, vVector37_rep_rep_F[Ntest][Etest]);
						if (!this.EventsMissingStartTimesTest[Ntest][Etest]) {
							// Message to 'vdouble91' from InnerProduct factor
							vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest] = InnerProductOp.BVariance(vVector37_rep_rep_F[Ntest][Etest], vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest]);
							// Message to 'vdouble91' from InnerProduct factor
							vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BMean[Ntest][Etest] = InnerProductOp.BMean(vVector37_rep_rep_F[Ntest][Etest], vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest], vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BMean[Ntest][Etest]);
							// Message to 'vdouble91' from InnerProduct factor
							vdouble91_F[Ntest][Etest] = InnerProductOp.InnerProductAverageConditional(this.EventsStartTimeFeaturesTest[Ntest][Etest], vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BMean[Ntest][Etest], vVector37_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest]);
							// Message to 'vdouble89_cond_eventsMissingStartTimesTest_Ntest__Etest__1' from GaussianFromMeanAndVariance factor
							vdouble89_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F[Ntest][Etest] = GaussianFromMeanAndVarianceOp.SampleAverageConditional(vdouble91_F[Ntest][Etest], 1.0);
							// Message to 'vdouble89' from Copy factor
							vdouble89_F[Ntest][Etest] = ArrayHelper.SetTo<Gaussian>(vdouble89_F[Ntest][Etest], vdouble89_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F[Ntest][Etest]);
						}
					}
				}
				// vdouble89_F[Ntest][Etest] is now updated in all contexts
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						// Message to 'vdouble103' from Plus factor
						vdouble103_F[Ntest][Etest] = DoublePlusOp.SumAverageConditional(vdouble88_F[Ntest][Etest], vdouble89_F[Ntest][Etest]);
						// Message to 'vdouble90' from Plus factor
						vdouble90_B[Ntest][Etest] = DoublePlusOp.BAverageConditional(this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest][Etest], vdouble103_F[Ntest][Etest]);
						if (!this.EventsMissingEndTimesTest[Ntest][Etest]) {
							// Message to 'vdouble97' from GaussianFromMeanAndVariance factor
							vdouble97_B[Ntest][Etest] = GaussianFromMeanAndVarianceOp.MeanAverageConditional(vdouble90_B[Ntest][Etest], 1.0);
							// Message to 'vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1' from InnerProduct factor
							vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_B[Ntest][Etest] = InnerProductOp.BAverageConditional(vdouble97_B[Ntest][Etest], this.EventsEndTimeFeaturesTest[Ntest][Etest], vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_B[Ntest][Etest]);
							// Message to 'vVector38_rep_rep' from Copy factor
							this.vVector38_rep_rep_B[Ntest][Etest] = ArrayHelper.SetTo<VectorGaussian>(this.vVector38_rep_rep_B[Ntest][Etest], vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_B[Ntest][Etest]);
						}
					}
					// Message to 'vVector38_rep_rep' from Replicate factor
					this.vVector38_rep_rep_B_toDef[Ntest] = ReplicateOp_Divide.ToDef<VectorGaussian>(this.vVector38_rep_rep_B[Ntest], this.vVector38_rep_rep_B_toDef[Ntest]);
				}
				// Message to 'vVector38_rep' from Replicate factor
				this.vVector38_rep_B_toDef = ReplicateOp_Divide.ToDef<VectorGaussian>(this.vVector38_rep_rep_B_toDef, this.vVector38_rep_B_toDef);
				// Message to 'vVector38_rep' from Replicate factor
				vVector38_rep_F_marginal = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector38_rep_B_toDef, this.EventsEndTimeWeightsPosterior, vVector38_rep_F_marginal);
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Message to 'vVector38_rep' from Replicate factor
					this.vVector38_rep_F[Ntest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector38_rep_rep_B_toDef[Ntest], vVector38_rep_F_marginal, Ntest, this.vVector38_rep_F[Ntest]);
					// Message to 'vVector38_rep_rep' from Replicate factor
					vVector38_rep_rep_F_marginal[Ntest] = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector38_rep_rep_B_toDef[Ntest], this.vVector38_rep_F[Ntest], vVector38_rep_rep_F_marginal[Ntest]);
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						// Message to 'vVector38_rep_rep' from Replicate factor
						vVector38_rep_rep_F[Ntest][Etest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector38_rep_rep_B[Ntest][Etest], vVector38_rep_rep_F_marginal[Ntest], Etest, vVector38_rep_rep_F[Ntest][Etest]);
						if (!this.EventsMissingEndTimesTest[Ntest][Etest]) {
							// Message to 'vdouble97' from InnerProduct factor
							vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest] = InnerProductOp.BVariance(vVector38_rep_rep_F[Ntest][Etest], vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest]);
							// Message to 'vdouble97' from InnerProduct factor
							vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BMean[Ntest][Etest] = InnerProductOp.BMean(vVector38_rep_rep_F[Ntest][Etest], vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest], vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BMean[Ntest][Etest]);
							// Message to 'vdouble97' from InnerProduct factor
							vdouble97_F[Ntest][Etest] = InnerProductOp.InnerProductAverageConditional(this.EventsEndTimeFeaturesTest[Ntest][Etest], vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BMean[Ntest][Etest], vVector38_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest]);
							// Message to 'vdouble90_cond_eventsMissingEndTimesTest_Ntest__Etest__1' from GaussianFromMeanAndVariance factor
							vdouble90_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F[Ntest][Etest] = GaussianFromMeanAndVarianceOp.SampleAverageConditional(vdouble97_F[Ntest][Etest], 1.0);
							// Message to 'vdouble90' from Copy factor
							vdouble90_F[Ntest][Etest] = ArrayHelper.SetTo<Gaussian>(vdouble90_F[Ntest][Etest], vdouble90_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F[Ntest][Etest]);
						}
					}
				}
				// vdouble90_F[Ntest][Etest] is now updated in all contexts
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						// Message to 'eventsContributionsTest' from Plus factor
						this.eventsContributionsTest_F[Ntest][Etest] = DoublePlusOp.SumAverageConditional(vdouble103_F[Ntest][Etest], vdouble90_F[Ntest][Etest]);
					}
					// Message to 'eventsContributionsTest_uses' from Replicate factor
					eventsContributionsTest_uses_F_Ntest__marginal[Ntest] = ReplicateOp_Divide.Marginal<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest], this.eventsContributionsTest_F[Ntest], eventsContributionsTest_uses_F_Ntest__marginal[Ntest]);
				}
				this.OnProgressChanged(new ProgressChangedEventArgs(iteration));
			}
			this.vVector36_marginal_F = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsWeightsPosterior);
			// Message to 'vVector36_marginal' from Variable factor
			this.vVector36_marginal_F = VariableOp.MarginalAverageConditional<VectorGaussian>(this.vVector36_rep_B_toDef, this.EventsWeightsPosterior, this.vVector36_marginal_F);
			this.vVector37_marginal_F = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsStartTimeWeightsPosterior);
			// Message to 'vVector37_marginal' from Variable factor
			this.vVector37_marginal_F = VariableOp.MarginalAverageConditional<VectorGaussian>(this.vVector37_rep_B_toDef, this.EventsStartTimeWeightsPosterior, this.vVector37_marginal_F);
			this.vVector38_marginal_F = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsEndTimeWeightsPosterior);
			// Message to 'vVector38_marginal' from Variable factor
			this.vVector38_marginal_F = VariableOp.MarginalAverageConditional<VectorGaussian>(this.vVector38_rep_B_toDef, this.EventsEndTimeWeightsPosterior, this.vVector38_marginal_F);
			DistributionStructArray<Gaussian,double> observedCountsTest_F = default(DistributionStructArray<Gaussian,double>);
			// Create array for 'observedCountsTest' Forwards messages.
			observedCountsTest_F = new DistributionStructArray<Gaussian,double>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				observedCountsTest_F[Ntest] = Gaussian.Uniform();
				// Message to 'routineContributionsTest_uses' from Replicate factor
				routineContributionsTest_uses_F[Ntest][1] = ReplicateOp_Divide.UsesAverageConditional<Gaussian>(this.routineContributionsTest_uses_B[Ntest][1], routineContributionsTest_uses_F_Ntest__marginal[Ntest], 1, routineContributionsTest_uses_F[Ntest][1]);
			}
			// Create array for 'eventsContributionsTest_marginal' Forwards messages.
			this.eventsContributionsTest_marginal_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for 'eventsContributionsTest_marginal' Forwards messages.
				this.eventsContributionsTest_marginal_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					this.eventsContributionsTest_marginal_F[Ntest][Etest] = Gaussian.Uniform();
					// Message to 'eventsContributionsTest_marginal' from DerivedVariable factor
					this.eventsContributionsTest_marginal_F[Ntest][Etest] = DerivedVariableOp.MarginalAverageConditional<Gaussian>(this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest][Etest], this.eventsContributionsTest_F[Ntest][Etest], this.eventsContributionsTest_marginal_F[Ntest][Etest]);
				}
				// Message to 'eventsContributionsTest_uses' from Replicate factor
				eventsContributionsTest_uses_F[Ntest][1] = ReplicateOp_Divide.UsesAverageConditional<DistributionStructArray<Gaussian,double>>(eventsContributionsTest_uses_B[Ntest][1], eventsContributionsTest_uses_F_Ntest__marginal[Ntest], 1, eventsContributionsTest_uses_F[Ntest][1]);
			}
			// Create array for replicates of 'vdouble106_F'
			DistributionStructArray<Gaussian,double> vdouble106_F = new DistributionStructArray<Gaussian,double>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				vdouble106_F[Ntest] = Gaussian.Uniform();
				// Message to 'vdouble106' from Sum factor
				vdouble106_F[Ntest] = FastSumOp.SumAverageConditional(eventsContributionsTest_uses_F[Ntest][1]);
			}
			// Create array for 'observedCountsTest_marginal' Forwards messages.
			this.observedCountsTest_marginal_F = new DistributionStructArray<Gaussian,double>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				this.observedCountsTest_marginal_F[Ntest] = Gaussian.Uniform();
			}
			// Message from use of 'observedCountsTest'
			DistributionStructArray<Gaussian,double> observedCountsTest_use_B = default(DistributionStructArray<Gaussian,double>);
			// Create array for 'observedCountsTest_use' Backwards messages.
			observedCountsTest_use_B = new DistributionStructArray<Gaussian,double>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				observedCountsTest_use_B[Ntest] = Gaussian.Uniform();
				// Message to 'observedCountsTest' from Plus factor
				observedCountsTest_F[Ntest] = DoublePlusOp.SumAverageConditional(routineContributionsTest_uses_F[Ntest][1], vdouble106_F[Ntest]);
				// Message to 'observedCountsTest_marginal' from DerivedVariable factor
				this.observedCountsTest_marginal_F[Ntest] = DerivedVariableOp.MarginalAverageConditional<Gaussian>(observedCountsTest_use_B[Ntest], observedCountsTest_F[Ntest], this.observedCountsTest_marginal_F[Ntest]);
			}
			this.Changed_routineWeightsPosterior_numTesting_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_4_iterationsDone = numberOfIterations;
		}

		/// <summary>
		/// Returns the marginal distribution for 'vVector34' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public VectorGaussian VVector34Marginal()
		{
			return this.vVector34_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'routineContributionsTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionStructArray<Gaussian,double> RoutineContributionsTestMarginal()
		{
			return this.routineContributionsTest_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'vVector36' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public VectorGaussian VVector36Marginal()
		{
			return this.vVector36_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'vVector37' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public VectorGaussian VVector37Marginal()
		{
			return this.vVector37_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'vVector38' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public VectorGaussian VVector38Marginal()
		{
			return this.vVector38_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsContributionsTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> EventsContributionsTestMarginal()
		{
			return this.eventsContributionsTest_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'observedCountsTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionStructArray<Gaussian,double> ObservedCountsTestMarginal()
		{
			return this.observedCountsTest_marginal_F;
		}

		/// <summary>Computations that depend on the observed value of numTesting and routineWeightsPosterior and routineFeaturesTest and numEventsTest and eventsWeightsPosterior and eventsStartTimeWeightsPosterior and eventsEndTimeWeightsPosterior and eventsFeaturesTest and eventsStartTimeFeaturesTest and eventsMissingStartTimesTest and eventsEndTimeFeaturesTest and eventsMissingEndTimesTest</summary>
		public void Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0()
		{
			if (this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone==1) {
				return ;
			}
			this.numTesting_marginal = new PointMass<int>(this.NumTesting);
			this.routineWeightsPosterior_marginal = new PointMass<VectorGaussian>(this.RoutineWeightsPosterior);
			this.routineFeaturesTest_marginal = new PointMass<Vector[]>(this.RoutineFeaturesTest);
			this.numEventsTest_marginal = new PointMass<int[]>(this.NumEventsTest);
			this.eventsWeightsPosterior_marginal = new PointMass<VectorGaussian>(this.EventsWeightsPosterior);
			this.eventsStartTimeWeightsPosterior_marginal = new PointMass<VectorGaussian>(this.EventsStartTimeWeightsPosterior);
			this.eventsEndTimeWeightsPosterior_marginal = new PointMass<VectorGaussian>(this.EventsEndTimeWeightsPosterior);
			this.eventsFeaturesTest_marginal = new PointMass<Vector[][]>(this.EventsFeaturesTest);
			this.eventsStartTimeFeaturesTest_marginal = new PointMass<Vector[][]>(this.EventsStartTimeFeaturesTest);
			this.eventsMissingStartTimesTest_marginal = new DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]>(this.NumTesting, delegate(int Ntest) {
				return new DistributionStructArray<Bernoulli,bool>(this.NumEventsTest[Ntest], delegate(int Etest) {
					return Bernoulli.Uniform();
				});
			});
			this.eventsMissingStartTimesTest_marginal = Distribution.SetPoint<DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]>,bool[][]>(this.eventsMissingStartTimesTest_marginal, this.EventsMissingStartTimesTest);
			this.eventsEndTimeFeaturesTest_marginal = new PointMass<Vector[][]>(this.EventsEndTimeFeaturesTest);
			this.eventsMissingEndTimesTest_marginal = new DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]>(this.NumTesting, delegate(int Ntest) {
				return new DistributionStructArray<Bernoulli,bool>(this.NumEventsTest[Ntest], delegate(int Etest) {
					return Bernoulli.Uniform();
				});
			});
			this.eventsMissingEndTimesTest_marginal = Distribution.SetPoint<DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]>,bool[][]>(this.eventsMissingEndTimesTest_marginal, this.EventsMissingEndTimesTest);
			this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone = 1;
		}

		/// <summary>
		/// Returns the marginal distribution for 'numTesting' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<int> NumTestingMarginal()
		{
			return this.numTesting_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'routineWeightsPosterior' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<VectorGaussian> RoutineWeightsPosteriorMarginal()
		{
			return this.routineWeightsPosterior_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'routineFeaturesTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<Vector[]> RoutineFeaturesTestMarginal()
		{
			return this.routineFeaturesTest_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'numEventsTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<int[]> NumEventsTestMarginal()
		{
			return this.numEventsTest_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsWeightsPosterior' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<VectorGaussian> EventsWeightsPosteriorMarginal()
		{
			return this.eventsWeightsPosterior_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsStartTimeWeightsPosterior' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<VectorGaussian> EventsStartTimeWeightsPosteriorMarginal()
		{
			return this.eventsStartTimeWeightsPosterior_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsEndTimeWeightsPosterior' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<VectorGaussian> EventsEndTimeWeightsPosteriorMarginal()
		{
			return this.eventsEndTimeWeightsPosterior_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsFeaturesTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<Vector[][]> EventsFeaturesTestMarginal()
		{
			return this.eventsFeaturesTest_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsStartTimeFeaturesTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<Vector[][]> EventsStartTimeFeaturesTestMarginal()
		{
			return this.eventsStartTimeFeaturesTest_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsMissingStartTimesTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]> EventsMissingStartTimesTestMarginal()
		{
			return this.eventsMissingStartTimesTest_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsEndTimeFeaturesTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<Vector[][]> EventsEndTimeFeaturesTestMarginal()
		{
			return this.eventsEndTimeFeaturesTest_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsMissingEndTimesTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]> EventsMissingEndTimesTestMarginal()
		{
			return this.eventsMissingEndTimesTest_marginal;
		}

		#endregion

		#region Events
		/// <summary>Event that is fired when the progress of inference changes, typically at the end of one iteration of the inference algorithm.</summary>
		public event EventHandler<ProgressChangedEventArgs> ProgressChanged;
		#endregion

	}

}
