using System;
using MicrosoftResearch.Infer;
using MicrosoftResearch.Infer.Maths;
using MicrosoftResearch.Infer.Distributions;
using MicrosoftResearch.Infer.Collections;
using MicrosoftResearch.Infer.Factors;

namespace MicrosoftResearch.Infer.Models.User
{
	/// <summary>
	/// Generated algorithm for performing inference
	/// </summary>
	/// <remarks>
	/// The easiest way to use this class is to wrap an instance in a CompiledAlgorithm object and use
	/// the methods on CompiledAlgorithm to set parameters and execute inference.
	/// 
	/// If you instead wish to use this class directly, you must perform the following steps:
	/// 1) Create an instance of the class
	/// 2) Set the value of any externally-set fields e.g. data, priors
	/// 3) Call the Execute(numberOfIterations) method
	/// 4) Use the XXXMarginal() methods to retrieve posterior marginals for different variables.
	/// 
	/// Generated by Infer.NET 2.5 at 17:00 on domingo, 29 de Setembro de 2013.
	/// </remarks>
	public partial class Model_EP : IGeneratedAlgorithm
	{
		#region Fields
		/// <summary>Field backing the NumberOfIterationsDone property</summary>
		private int numberOfIterationsDone;
		/// <summary>Field backing the numTraining property</summary>
		private int NumTraining;
		/// <summary>Field backing the baseFeaturesTrain property</summary>
		private Vector[] BaseFeaturesTrain;
		/// <summary>Field backing the numEventsTrain property</summary>
		private int[] NumEventsTrain;
		/// <summary>Field backing the eventsFeaturesTrain property</summary>
		private Vector[][] EventsFeaturesTrain;
		/// <summary>Field backing the observedCountsTrain property</summary>
		private double[] ObservedCountsTrain;
		/// <summary>The number of iterations last computed by Changed_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_observedCountsTrain. Set this to zero to force re-execution of Changed_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_observedCountsTrain</summary>
		public int Changed_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_observedCountsTrain_iterationsDone;
		/// <summary>The number of iterations last computed by Constant. Set this to zero to force re-execution of Constant</summary>
		public int Constant_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain2. Set this to zero to force re-execution of Changed_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain2</summary>
		public int Changed_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain2_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_numTraining. Set this to zero to force re-execution of Changed_numTraining</summary>
		public int Changed_numTraining_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_numTraining_Init_numberOfIterationsDecreased_baseFeaturesTrain_numEventsTrain_eventsFeatures4. Set this to zero to force re-execution of Changed_numTraining_Init_numberOfIterationsDecreased_baseFeaturesTrain_numEventsTrain_eventsFeatures4</summary>
		public int Changed_numTraining_Init_numberOfIterationsDecreased_baseFeaturesTrain_numEventsTrain_eventsFeatures4_iterationsDone;
		/// <summary>True if Changed_numTraining_Init_numberOfIterationsDecreased_baseFeaturesTrain_numEventsTrain_eventsFeatures4 has performed initialisation. Set this to false to force re-execution of Changed_numTraining_Init_numberOfIterationsDecreased_baseFeaturesTrain_numEventsTrain_eventsFeatures4</summary>
		public bool Changed_numTraining_Init_numberOfIterationsDecreased_baseFeaturesTrain_numEventsTrain_eventsFeatures4_isInitialised;
		/// <summary>The number of iterations last computed by Changed_numTraining_numEventsTrain. Set this to zero to force re-execution of Changed_numTraining_numEventsTrain</summary>
		public int Changed_numTraining_numEventsTrain_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_numTraining_numEventsTrain_Init_numberOfIterationsDecreased_baseFeaturesTrain_eventsFeatures6. Set this to zero to force re-execution of Changed_numTraining_numEventsTrain_Init_numberOfIterationsDecreased_baseFeaturesTrain_eventsFeatures6</summary>
		public int Changed_numTraining_numEventsTrain_Init_numberOfIterationsDecreased_baseFeaturesTrain_eventsFeatures6_iterationsDone;
		/// <summary>True if Changed_numTraining_numEventsTrain_Init_numberOfIterationsDecreased_baseFeaturesTrain_eventsFeatures6 has performed initialisation. Set this to false to force re-execution of Changed_numTraining_numEventsTrain_Init_numberOfIterationsDecreased_baseFeaturesTrain_eventsFeatures6</summary>
		public bool Changed_numTraining_numEventsTrain_Init_numberOfIterationsDecreased_baseFeaturesTrain_eventsFeatures6_isInitialised;
		/// <summary>The number of iterations last computed by Init_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_ob7. Set this to zero to force re-execution of Init_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_ob7</summary>
		public int Init_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_ob7_iterationsDone;
		/// <summary>True if Init_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_ob7 has performed initialisation. Set this to false to force re-execution of Init_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_ob7</summary>
		public bool Init_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_ob7_isInitialised;
		/// <summary>The constant 'vVector0'</summary>
		public DenseVector vVector0;
		public VectorGaussian dummyWeights_F;
		public DistributionStructArray<Gaussian,double> dummyContributionsTrain_F;
		/// <summary>Messages from use of 'dummyContributionsTrain'</summary>
		public DistributionStructArray<Gaussian,double>[] dummyContributionsTrain_uses_B;
		/// <summary>The constant 'vVector3'</summary>
		public DenseVector vVector3;
		public VectorGaussian eventsFeatureWeights_F;
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTrain_depth2_B;
		/// <summary>Messages from use of 'eventsContributionsTrain'</summary>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>[] eventsContributionsTrain_uses_B;
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTrain_F;
		public DistributionRefArray<VectorGaussian,Vector> eventsFeatureWeights_rep_F;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<VectorGaussian></summary>
		public VectorGaussian eventsFeatureWeights_rep_B_toDef;
		/// <summary>Buffer for ReplicateOp_Divide.UsesAverageConditional<VectorGaussian></summary>
		public VectorGaussian eventsFeatureWeights_rep_F_marginal;
		public DistributionRefArray<VectorGaussian,Vector> dummyWeights_rep_B;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<VectorGaussian></summary>
		public VectorGaussian dummyWeights_rep_B_toDef;
		/// <summary>Buffer for ReplicateOp_Divide.UsesAverageConditional<VectorGaussian></summary>
		public VectorGaussian dummyWeights_rep_F_marginal;
		/// <summary>Buffer for ReplicateOp_Divide.UsesAverageConditional<Gaussian></summary>
		public DistributionStructArray<Gaussian,double> dummyContributionsTrain_uses_F_Ntrain__marginal;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<DistributionStructArray<Gaussian,double>></summary>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTrain_uses_B_Ntrain__toDef;
		public DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]> eventsFeatureWeights_rep_rep_B;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<VectorGaussian></summary>
		public DistributionRefArray<VectorGaussian,Vector> eventsFeatureWeights_rep_rep_B_toDef;
		/// <summary>Buffer for ReplicateOp_Divide.UsesAverageConditional<DistributionStructArray<Gaussian,double>></summary>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTrain_uses_F_Ntrain__marginal;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<Gaussian></summary>
		public DistributionStructArray<Gaussian,double> dummyContributionsTrain_uses_B_Ntrain__toDef;
		/// <summary>Message to marginal of 'evidence'</summary>
		public Bernoulli evidence_marginal_F;
		/// <summary>Message to marginal of 'dummyWeights'</summary>
		public VectorGaussian dummyWeights_marginal_F;
		/// <summary>Message to marginal of 'eventsFeatureWeights'</summary>
		public VectorGaussian eventsFeatureWeights_marginal_F;
		/// <summary>Message to marginal of 'dummyContributionsTrain'</summary>
		public DistributionStructArray<Gaussian,double> dummyContributionsTrain_marginal_F;
		/// <summary>Message to marginal of 'eventsContributionsTrain'</summary>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTrain_marginal_F;
		public PointMass<int> numTraining_marginal;
		public PointMass<Vector[]> baseFeaturesTrain_marginal;
		public PointMass<int[]> numEventsTrain_marginal;
		public PointMass<Vector[][]> eventsFeaturesTrain_marginal;
		public DistributionStructArray<Gaussian,double> observedCountsTrain_marginal;
		/// <summary>Message to marginal of 'vdouble5'</summary>
		public Gaussian vdouble5_marginal_F;
		#endregion

		#region Properties
		/// <summary>The number of iterations done from the initial state</summary>
		public int NumberOfIterationsDone
		{			get {
				return this.numberOfIterationsDone;
			}
		}

		/// <summary>The externally-specified value of 'numTraining'</summary>
		public int numTraining
		{			get {
				return this.NumTraining;
			}
			set {
				if (this.NumTraining!=value) {
					this.NumTraining = value;
					this.numberOfIterationsDone = 0;
					this.Init_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_ob7_isInitialised = false;
					this.Changed_numTraining_iterationsDone = 0;
					this.Changed_numTraining_numEventsTrain_iterationsDone = 0;
					this.Changed_numTraining_numEventsTrain_Init_numberOfIterationsDecreased_baseFeaturesTrain_eventsFeatures6_iterationsDone = 0;
					this.Changed_numTraining_Init_numberOfIterationsDecreased_baseFeaturesTrain_numEventsTrain_eventsFeatures4_iterationsDone = 0;
					this.Changed_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain2_iterationsDone = 0;
					this.Changed_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_observedCountsTrain_iterationsDone = 0;
				}
			}
		}

		/// <summary>The externally-specified value of 'baseFeaturesTrain'</summary>
		public Vector[] baseFeaturesTrain
		{			get {
				return this.BaseFeaturesTrain;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTraining)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTraining)+" was expected for variable \'baseFeaturesTrain\'");
				}
				this.BaseFeaturesTrain = value;
				this.numberOfIterationsDone = 0;
				this.Init_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_ob7_isInitialised = false;
				this.Changed_numTraining_numEventsTrain_Init_numberOfIterationsDecreased_baseFeaturesTrain_eventsFeatures6_isInitialised = false;
				this.Changed_numTraining_Init_numberOfIterationsDecreased_baseFeaturesTrain_numEventsTrain_eventsFeatures4_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain2_iterationsDone = 0;
				this.Changed_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_observedCountsTrain_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'numEventsTrain'</summary>
		public int[] numEventsTrain
		{			get {
				return this.NumEventsTrain;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTraining)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTraining)+" was expected for variable \'numEventsTrain\'");
				}
				this.NumEventsTrain = value;
				this.numberOfIterationsDone = 0;
				this.Init_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_ob7_isInitialised = false;
				this.Changed_numTraining_numEventsTrain_iterationsDone = 0;
				this.Changed_numTraining_numEventsTrain_Init_numberOfIterationsDecreased_baseFeaturesTrain_eventsFeatures6_iterationsDone = 0;
				this.Changed_numTraining_Init_numberOfIterationsDecreased_baseFeaturesTrain_numEventsTrain_eventsFeatures4_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain2_iterationsDone = 0;
				this.Changed_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_observedCountsTrain_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'eventsFeaturesTrain'</summary>
		public Vector[][] eventsFeaturesTrain
		{			get {
				return this.EventsFeaturesTrain;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTraining)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTraining)+" was expected for variable \'eventsFeaturesTrain\'");
				}
				this.EventsFeaturesTrain = value;
				this.numberOfIterationsDone = 0;
				this.Init_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_ob7_isInitialised = false;
				this.Changed_numTraining_numEventsTrain_Init_numberOfIterationsDecreased_baseFeaturesTrain_eventsFeatures6_isInitialised = false;
				this.Changed_numTraining_Init_numberOfIterationsDecreased_baseFeaturesTrain_numEventsTrain_eventsFeatures4_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain2_iterationsDone = 0;
				this.Changed_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_observedCountsTrain_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'observedCountsTrain'</summary>
		public double[] observedCountsTrain
		{			get {
				return this.ObservedCountsTrain;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTraining)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTraining)+" was expected for variable \'observedCountsTrain\'");
				}
				this.ObservedCountsTrain = value;
				this.numberOfIterationsDone = 0;
				this.Init_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_ob7_isInitialised = false;
				this.Changed_numTraining_numEventsTrain_Init_numberOfIterationsDecreased_baseFeaturesTrain_eventsFeatures6_isInitialised = false;
				this.Changed_numTraining_Init_numberOfIterationsDecreased_baseFeaturesTrain_numEventsTrain_eventsFeatures4_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain2_iterationsDone = 0;
				this.Changed_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_observedCountsTrain_iterationsDone = 0;
			}
		}

		#endregion

		#region Methods
		/// <summary>Get the observed value of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		public object GetObservedValue(string variableName)
		{
			if (variableName=="numTraining") {
				return this.numTraining;
			}
			if (variableName=="baseFeaturesTrain") {
				return this.baseFeaturesTrain;
			}
			if (variableName=="numEventsTrain") {
				return this.numEventsTrain;
			}
			if (variableName=="eventsFeaturesTrain") {
				return this.eventsFeaturesTrain;
			}
			if (variableName=="observedCountsTrain") {
				return this.observedCountsTrain;
			}
			throw new ArgumentException("Not an observed variable name: "+variableName);
		}

		/// <summary>Set the observed value of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		/// <param name="value">Observed value</param>
		public void SetObservedValue(string variableName, object value)
		{
			if (variableName=="numTraining") {
				this.numTraining = (int)value;
				return ;
			}
			if (variableName=="baseFeaturesTrain") {
				this.baseFeaturesTrain = (Vector[])value;
				return ;
			}
			if (variableName=="numEventsTrain") {
				this.numEventsTrain = (int[])value;
				return ;
			}
			if (variableName=="eventsFeaturesTrain") {
				this.eventsFeaturesTrain = (Vector[][])value;
				return ;
			}
			if (variableName=="observedCountsTrain") {
				this.observedCountsTrain = (double[])value;
				return ;
			}
			throw new ArgumentException("Not an observed variable name: "+variableName);
		}

		/// <summary>The marginal distribution of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		public object Marginal(string variableName)
		{
			if (variableName=="evidence") {
				return this.EvidenceMarginal();
			}
			if (variableName=="dummyWeights") {
				return this.DummyWeightsMarginal();
			}
			if (variableName=="dummyContributionsTrain") {
				return this.DummyContributionsTrainMarginal();
			}
			if (variableName=="eventsFeatureWeights") {
				return this.EventsFeatureWeightsMarginal();
			}
			if (variableName=="eventsContributionsTrain") {
				return this.EventsContributionsTrainMarginal();
			}
			if (variableName=="numTraining") {
				return this.NumTrainingMarginal();
			}
			if (variableName=="baseFeaturesTrain") {
				return this.BaseFeaturesTrainMarginal();
			}
			if (variableName=="numEventsTrain") {
				return this.NumEventsTrainMarginal();
			}
			if (variableName=="eventsFeaturesTrain") {
				return this.EventsFeaturesTrainMarginal();
			}
			if (variableName=="observedCountsTrain") {
				return this.ObservedCountsTrainMarginal();
			}
			if (variableName=="vdouble5") {
				return this.Vdouble5Marginal();
			}
			throw new ArgumentException("This class was not built to infer "+variableName);
		}

		public T Marginal<T>(string variableName)
		{
			return Distribution.ChangeType<T>(this.Marginal(variableName));
		}

		/// <summary>The query-specific marginal distribution of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		/// <param name="query">QueryType name. For example, GibbsSampling answers 'Marginal', 'Samples', and 'Conditionals' queries</param>
		public object Marginal(string variableName, string query)
		{
			if (query=="Marginal") {
				return this.Marginal(variableName);
			}
			throw new ArgumentException(((("This class was not built to infer \'"+variableName)+"\' with query \'")+query)+"\'");
		}

		public T Marginal<T>(string variableName, string query)
		{
			return Distribution.ChangeType<T>(this.Marginal(variableName, query));
		}

		/// <summary>Update all marginals, by iterating message passing the given number of times</summary>
		/// <param name="numberOfIterations">The number of times to iterate each loop</param>
		/// <param name="initialise">If true, messages that initialise loops are reset when observed values change</param>
		private void Execute(int numberOfIterations, bool initialise)
		{
			if (numberOfIterations<this.Changed_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain2_iterationsDone) {
				this.Init_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_ob7_isInitialised = false;
				this.Changed_numTraining_numEventsTrain_Init_numberOfIterationsDecreased_baseFeaturesTrain_eventsFeatures6_isInitialised = false;
				this.Changed_numTraining_Init_numberOfIterationsDecreased_baseFeaturesTrain_numEventsTrain_eventsFeatures4_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain2_iterationsDone = 0;
			}
			this.Constant();
			this.Init_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_ob7(initialise);
			this.Changed_numTraining();
			this.Changed_numTraining_numEventsTrain();
			this.Changed_numTraining_numEventsTrain_Init_numberOfIterationsDecreased_baseFeaturesTrain_eventsFeatures6(initialise);
			this.Changed_numTraining_Init_numberOfIterationsDecreased_baseFeaturesTrain_numEventsTrain_eventsFeatures4(initialise);
			this.Changed_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain2(numberOfIterations);
			this.Changed_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_observedCountsTrain();
			this.numberOfIterationsDone = numberOfIterations;
		}

		public void Execute(int numberOfIterations)
		{
			this.Execute(numberOfIterations, true);
		}

		public void Update(int additionalIterations)
		{
			this.Execute(this.numberOfIterationsDone+additionalIterations, false);
		}

		private void OnProgressChanged(ProgressChangedEventArgs e)
		{
			// Make a temporary copy of the event to avoid a race condition
			// if the last subscriber unsubscribes immediately after the null check and before the event is raised.
			EventHandler<ProgressChangedEventArgs> handler = this.ProgressChanged;
			if (handler!=null) {
				handler(this, e);
			}
		}

		/// <summary>Reset all messages to their initial values.  Sets NumberOfIterationsDone to 0.</summary>
		public void Reset()
		{
			this.Execute(0);
		}

		/// <summary>Computations that do not depend on observed values</summary>
		public void Constant()
		{
			if (this.Constant_iterationsDone==1) {
				return ;
			}
			this.vVector0 = DenseVector.FromArray(new double[11] {0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0});
			this.dummyWeights_F = ArrayHelper.MakeUniform<VectorGaussian>(VectorGaussian.Uniform(this.vVector0.Count));
			this.vVector3 = DenseVector.FromArray(new double[83] {0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0});
			this.eventsFeatureWeights_F = ArrayHelper.MakeUniform<VectorGaussian>(VectorGaussian.Uniform(this.vVector3.Count));
			this.Constant_iterationsDone = 1;
			this.Changed_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain2_iterationsDone = 0;
			this.Changed_numTraining_iterationsDone = 0;
			this.Changed_numTraining_numEventsTrain_Init_numberOfIterationsDecreased_baseFeaturesTrain_eventsFeatures6_iterationsDone = 0;
			this.Init_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_ob7_iterationsDone = 0;
			this.Changed_numTraining_Init_numberOfIterationsDecreased_baseFeaturesTrain_numEventsTrain_eventsFeatures4_iterationsDone = 0;
		}

		/// <summary>Computations that must reset on changes to numberOfIterationsDecreased and numTraining and baseFeaturesTrain and numEventsTrain and eventsFeaturesTrain and observedCountsTrain</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Init_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_ob7(bool initialise)
		{
			if ((this.Init_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_ob7_iterationsDone==1)&&((!initialise)||this.Init_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_ob7_isInitialised)) {
				return ;
			}
			// Message to 'eventsFeatureWeights_rep' from Replicate factor
			this.eventsFeatureWeights_rep_B_toDef = ReplicateOp_Divide.ToDefInit<VectorGaussian>(this.eventsFeatureWeights_F);
			// Message to 'eventsFeatureWeights_rep' from Replicate factor
			this.eventsFeatureWeights_rep_F_marginal = ReplicateOp_Divide.MarginalInit<VectorGaussian>(this.eventsFeatureWeights_F);
			// Message to 'dummyWeights_rep' from Replicate factor
			this.dummyWeights_rep_B_toDef = ReplicateOp_Divide.ToDefInit<VectorGaussian>(this.dummyWeights_F);
			// Message to 'dummyWeights_rep' from Replicate factor
			this.dummyWeights_rep_F_marginal = ReplicateOp_Divide.MarginalInit<VectorGaussian>(this.dummyWeights_F);
			this.Init_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_ob7_iterationsDone = 1;
			this.Init_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_ob7_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain2_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTraining</summary>
		public void Changed_numTraining()
		{
			if (this.Changed_numTraining_iterationsDone==1) {
				return ;
			}
			// Create array for 'dummyContributionsTrain' Forwards messages.
			this.dummyContributionsTrain_F = new DistributionStructArray<Gaussian,double>(this.NumTraining);
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				this.dummyContributionsTrain_F[Ntrain] = Gaussian.Uniform();
			}
			// Create array for replicates of 'dummyContributionsTrain_uses_F_Ntrain__marginal'
			this.dummyContributionsTrain_uses_F_Ntrain__marginal = new DistributionStructArray<Gaussian,double>(this.NumTraining);
			// Create array for 'dummyContributionsTrain_uses' Backwards messages.
			this.dummyContributionsTrain_uses_B = new DistributionStructArray<Gaussian,double>[this.NumTraining];
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				// Create array for 'dummyContributionsTrain_uses' Backwards messages.
				this.dummyContributionsTrain_uses_B[Ntrain] = new DistributionStructArray<Gaussian,double>(2);
			}
			// Create array for 'eventsContributionsTrain_depth2' Backwards messages.
			this.eventsContributionsTrain_depth2_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTraining);
			// Create array for 'eventsContributionsTrain_uses' Backwards messages.
			this.eventsContributionsTrain_uses_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>[this.NumTraining];
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				// Create array for 'eventsContributionsTrain_uses' Backwards messages.
				this.eventsContributionsTrain_uses_B[Ntrain] = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(2);
			}
			// Create array for 'eventsContributionsTrain' Forwards messages.
			this.eventsContributionsTrain_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTraining);
			// Create array for replicates of 'eventsContributionsTrain_uses_B_Ntrain__toDef'
			this.eventsContributionsTrain_uses_B_Ntrain__toDef = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTraining);
			// Create array for replicates of 'eventsFeatureWeights_rep_rep_B'
			this.eventsFeatureWeights_rep_rep_B = new DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]>(this.NumTraining);
			// Create array for 'eventsFeatureWeights_rep' Forwards messages.
			this.eventsFeatureWeights_rep_F = new DistributionRefArray<VectorGaussian,Vector>(this.NumTraining);
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				this.eventsFeatureWeights_rep_F[Ntrain] = ArrayHelper.MakeUniform<VectorGaussian>(VectorGaussian.Uniform(this.vVector3.Count));
			}
			// Create array for replicates of 'eventsFeatureWeights_rep_rep_B_toDef'
			this.eventsFeatureWeights_rep_rep_B_toDef = new DistributionRefArray<VectorGaussian,Vector>(this.NumTraining);
			// Create array for replicates of 'eventsContributionsTrain_uses_F_Ntrain__marginal'
			this.eventsContributionsTrain_uses_F_Ntrain__marginal = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTraining);
			// Create array for replicates of 'dummyContributionsTrain_uses_B_Ntrain__toDef'
			this.dummyContributionsTrain_uses_B_Ntrain__toDef = new DistributionStructArray<Gaussian,double>(this.NumTraining);
			// Create array for 'dummyWeights_rep' Backwards messages.
			this.dummyWeights_rep_B = new DistributionRefArray<VectorGaussian,Vector>(this.NumTraining);
			this.Changed_numTraining_iterationsDone = 1;
			this.Changed_numTraining_Init_numberOfIterationsDecreased_baseFeaturesTrain_numEventsTrain_eventsFeatures4_iterationsDone = 0;
			this.Changed_numTraining_numEventsTrain_iterationsDone = 0;
			this.Changed_numTraining_numEventsTrain_Init_numberOfIterationsDecreased_baseFeaturesTrain_eventsFeatures6_iterationsDone = 0;
			this.Changed_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain2_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTraining and numEventsTrain</summary>
		public void Changed_numTraining_numEventsTrain()
		{
			if (this.Changed_numTraining_numEventsTrain_iterationsDone==1) {
				return ;
			}
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				// Create array for 'eventsContributionsTrain_depth2' Backwards messages.
				this.eventsContributionsTrain_depth2_B[Ntrain] = new DistributionStructArray<Gaussian,double>(this.NumEventsTrain[Ntrain]);
				for(int _ind = 0; _ind<2; _ind++) {
					// Create array for 'eventsContributionsTrain_uses' Backwards messages.
					this.eventsContributionsTrain_uses_B[Ntrain][_ind] = new DistributionStructArray<Gaussian,double>(this.NumEventsTrain[Ntrain]);
				}
				// Create array for 'eventsContributionsTrain' Forwards messages.
				this.eventsContributionsTrain_F[Ntrain] = new DistributionStructArray<Gaussian,double>(this.NumEventsTrain[Ntrain]);
				for(int Etrain = 0; Etrain<this.NumEventsTrain[Ntrain]; Etrain++) {
					this.eventsContributionsTrain_F[Ntrain][Etrain] = Gaussian.Uniform();
				}
				// Create array for 'eventsFeatureWeights_rep_rep' Backwards messages.
				this.eventsFeatureWeights_rep_rep_B[Ntrain] = new DistributionRefArray<VectorGaussian,Vector>(this.NumEventsTrain[Ntrain]);
			}
			this.Changed_numTraining_numEventsTrain_iterationsDone = 1;
			this.Changed_numTraining_numEventsTrain_Init_numberOfIterationsDecreased_baseFeaturesTrain_eventsFeatures6_iterationsDone = 0;
			this.Changed_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain2_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTraining and numEventsTrain and must reset on changes to numberOfIterationsDecreased and baseFeaturesTrain and eventsFeaturesTrain and observedCountsTrain</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_numTraining_numEventsTrain_Init_numberOfIterationsDecreased_baseFeaturesTrain_eventsFeatures6(bool initialise)
		{
			if ((this.Changed_numTraining_numEventsTrain_Init_numberOfIterationsDecreased_baseFeaturesTrain_eventsFeatures6_iterationsDone==1)&&((!initialise)||this.Changed_numTraining_numEventsTrain_Init_numberOfIterationsDecreased_baseFeaturesTrain_eventsFeatures6_isInitialised)) {
				return ;
			}
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				for(int Etrain = 0; Etrain<this.NumEventsTrain[Ntrain]; Etrain++) {
					this.eventsContributionsTrain_depth2_B[Ntrain][Etrain] = Gaussian.Uniform();
					for(int _ind = 0; _ind<2; _ind++) {
						this.eventsContributionsTrain_uses_B[Ntrain][_ind][Etrain] = Gaussian.Uniform();
					}
				}
				// Message to 'eventsContributionsTrain_uses' from Replicate factor
				this.eventsContributionsTrain_uses_B_Ntrain__toDef[Ntrain] = ReplicateOp_Divide.ToDefInit<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTrain_F[Ntrain]);
				for(int Etrain = 0; Etrain<this.NumEventsTrain[Ntrain]; Etrain++) {
					this.eventsFeatureWeights_rep_rep_B[Ntrain][Etrain] = ArrayHelper.MakeUniform<VectorGaussian>(VectorGaussian.Uniform(this.vVector3.Count));
				}
				// Message to 'eventsContributionsTrain_uses' from Replicate factor
				this.eventsContributionsTrain_uses_F_Ntrain__marginal[Ntrain] = ReplicateOp_Divide.MarginalInit<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTrain_F[Ntrain]);
			}
			this.Changed_numTraining_numEventsTrain_Init_numberOfIterationsDecreased_baseFeaturesTrain_eventsFeatures6_iterationsDone = 1;
			this.Changed_numTraining_numEventsTrain_Init_numberOfIterationsDecreased_baseFeaturesTrain_eventsFeatures6_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain2_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTraining and must reset on changes to numberOfIterationsDecreased and baseFeaturesTrain and numEventsTrain and eventsFeaturesTrain and observedCountsTrain</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_numTraining_Init_numberOfIterationsDecreased_baseFeaturesTrain_numEventsTrain_eventsFeatures4(bool initialise)
		{
			if ((this.Changed_numTraining_Init_numberOfIterationsDecreased_baseFeaturesTrain_numEventsTrain_eventsFeatures4_iterationsDone==1)&&((!initialise)||this.Changed_numTraining_Init_numberOfIterationsDecreased_baseFeaturesTrain_numEventsTrain_eventsFeatures4_isInitialised)) {
				return ;
			}
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				// Message to 'dummyContributionsTrain_uses' from Replicate factor
				this.dummyContributionsTrain_uses_F_Ntrain__marginal[Ntrain] = ReplicateOp_Divide.MarginalInit<Gaussian>(this.dummyContributionsTrain_F[Ntrain]);
				for(int _ind = 0; _ind<2; _ind++) {
					this.dummyContributionsTrain_uses_B[Ntrain][_ind] = Gaussian.Uniform();
				}
				// Message to 'eventsFeatureWeights_rep_rep' from Replicate factor
				this.eventsFeatureWeights_rep_rep_B_toDef[Ntrain] = ReplicateOp_Divide.ToDefInit<VectorGaussian>(this.eventsFeatureWeights_rep_F[Ntrain]);
				// Message to 'dummyContributionsTrain_uses' from Replicate factor
				this.dummyContributionsTrain_uses_B_Ntrain__toDef[Ntrain] = ReplicateOp_Divide.ToDefInit<Gaussian>(this.dummyContributionsTrain_F[Ntrain]);
				this.dummyWeights_rep_B[Ntrain] = ArrayHelper.MakeUniform<VectorGaussian>(VectorGaussian.Uniform(this.vVector0.Count));
			}
			this.Changed_numTraining_Init_numberOfIterationsDecreased_baseFeaturesTrain_numEventsTrain_eventsFeatures4_iterationsDone = 1;
			this.Changed_numTraining_Init_numberOfIterationsDecreased_baseFeaturesTrain_numEventsTrain_eventsFeatures4_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain2_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numberOfIterationsDecreased and numTraining and baseFeaturesTrain and numEventsTrain and eventsFeaturesTrain and observedCountsTrain</summary>
		/// <param name="numberOfIterations">The number of times to iterate each loop</param>
		public void Changed_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain2(int numberOfIterations)
		{
			if (this.Changed_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain2_iterationsDone==numberOfIterations) {
				return ;
			}
			// The constant 'vPositiveDefiniteMatrix0'
			PositiveDefiniteMatrix vPositiveDefiniteMatrix0 = new PositiveDefiniteMatrix(new double[11, 11] {{1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0}});
			// Message to 'dummyWeights' from VectorGaussian factor
			this.dummyWeights_F = VectorGaussianOp.SampleAverageConditional(this.vVector0, vPositiveDefiniteMatrix0, this.dummyWeights_F);
			DistributionRefArray<VectorGaussian,Vector> dummyWeights_rep_F = default(DistributionRefArray<VectorGaussian,Vector>);
			// Create array for 'dummyWeights_rep' Forwards messages.
			dummyWeights_rep_F = new DistributionRefArray<VectorGaussian,Vector>(this.NumTraining);
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				dummyWeights_rep_F[Ntrain] = ArrayHelper.MakeUniform<VectorGaussian>(VectorGaussian.Uniform(this.vVector0.Count));
			}
			// Buffer for InnerProductOp.BMean
			// Create array for replicates of 'dummyWeights_rep_F_Ntrain__BVariance'
			PositiveDefiniteMatrix[] dummyWeights_rep_F_Ntrain__BVariance = new PositiveDefiniteMatrix[this.NumTraining];
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				// Message to 'vdouble6' from InnerProduct factor
				dummyWeights_rep_F_Ntrain__BVariance[Ntrain] = InnerProductOp.BVarianceInit(dummyWeights_rep_F[Ntrain]);
			}
			// Buffer for InnerProductOp.InnerProductAverageConditional
			// Create array for replicates of 'dummyWeights_rep_F_Ntrain__BMean'
			Vector[] dummyWeights_rep_F_Ntrain__BMean = new Vector[this.NumTraining];
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				// Message to 'vdouble6' from InnerProduct factor
				dummyWeights_rep_F_Ntrain__BMean[Ntrain] = InnerProductOp.BMeanInit(dummyWeights_rep_F[Ntrain]);
			}
			// Create array for replicates of 'vdouble6_F'
			DistributionStructArray<Gaussian,double> vdouble6_F = new DistributionStructArray<Gaussian,double>(this.NumTraining);
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				vdouble6_F[Ntrain] = Gaussian.Uniform();
			}
			// Messages to use of 'dummyContributionsTrain'
			DistributionStructArray<Gaussian,double>[] dummyContributionsTrain_uses_F = default(DistributionStructArray<Gaussian,double>[]);
			// Create array for 'dummyContributionsTrain_uses' Forwards messages.
			dummyContributionsTrain_uses_F = new DistributionStructArray<Gaussian,double>[this.NumTraining];
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				// Create array for 'dummyContributionsTrain_uses' Forwards messages.
				dummyContributionsTrain_uses_F[Ntrain] = new DistributionStructArray<Gaussian,double>(2);
				for(int _ind = 0; _ind<2; _ind++) {
					dummyContributionsTrain_uses_F[Ntrain][_ind] = Gaussian.Uniform();
				}
			}
			// The constant 'vPositiveDefiniteMatrix1'
			PositiveDefiniteMatrix vPositiveDefiniteMatrix1 = new PositiveDefiniteMatrix(new double[83, 83] {{1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0,0.0},{0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,1.0}});
			// Message to 'eventsFeatureWeights' from VectorGaussian factor
			this.eventsFeatureWeights_F = VectorGaussianOp.SampleAverageConditional(this.vVector3, vPositiveDefiniteMatrix1, this.eventsFeatureWeights_F);
			// Messages to use of 'eventsContributionsTrain'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>[] eventsContributionsTrain_uses_F = default(DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>[]);
			// Create array for 'eventsContributionsTrain_uses' Forwards messages.
			eventsContributionsTrain_uses_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>[this.NumTraining];
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				// Create array for 'eventsContributionsTrain_uses' Forwards messages.
				eventsContributionsTrain_uses_F[Ntrain] = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(2);
				for(int _ind = 0; _ind<2; _ind++) {
					// Create array for 'eventsContributionsTrain_uses' Forwards messages.
					eventsContributionsTrain_uses_F[Ntrain][_ind] = new DistributionStructArray<Gaussian,double>(this.NumEventsTrain[Ntrain]);
					for(int Etrain = 0; Etrain<this.NumEventsTrain[Ntrain]; Etrain++) {
						eventsContributionsTrain_uses_F[Ntrain][_ind][Etrain] = Gaussian.Uniform();
					}
				}
			}
			// Create array for replicates of 'vdouble14_B'
			DistributionStructArray<Gaussian,double> vdouble14_B = new DistributionStructArray<Gaussian,double>(this.NumTraining);
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				vdouble14_B[Ntrain] = Gaussian.Uniform();
			}
			// Create array for replicates of 'vdouble10_B'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble10_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTraining);
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				// Create array for replicates of 'vdouble10_B'
				vdouble10_B[Ntrain] = new DistributionStructArray<Gaussian,double>(this.NumEventsTrain[Ntrain]);
				for(int Etrain = 0; Etrain<this.NumEventsTrain[Ntrain]; Etrain++) {
					vdouble10_B[Ntrain][Etrain] = Gaussian.Uniform();
				}
			}
			// Buffer for ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>
			// Create array for replicates of 'eventsFeatureWeights_rep_rep_F_marginal'
			DistributionRefArray<VectorGaussian,Vector> eventsFeatureWeights_rep_rep_F_marginal = new DistributionRefArray<VectorGaussian,Vector>(this.NumTraining);
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				// Message to 'eventsFeatureWeights_rep_rep' from Replicate factor
				eventsFeatureWeights_rep_rep_F_marginal[Ntrain] = ReplicateOp_Divide.MarginalInit<VectorGaussian>(this.eventsFeatureWeights_rep_F[Ntrain]);
			}
			// Create array for replicates of 'eventsFeatureWeights_rep_rep_F'
			DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]> eventsFeatureWeights_rep_rep_F = new DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]>(this.NumTraining);
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				// Create array for 'eventsFeatureWeights_rep_rep' Forwards messages.
				eventsFeatureWeights_rep_rep_F[Ntrain] = new DistributionRefArray<VectorGaussian,Vector>(this.NumEventsTrain[Ntrain]);
				for(int Etrain = 0; Etrain<this.NumEventsTrain[Ntrain]; Etrain++) {
					eventsFeatureWeights_rep_rep_F[Ntrain][Etrain] = ArrayHelper.MakeUniform<VectorGaussian>(VectorGaussian.Uniform(this.vVector3.Count));
				}
			}
			// Buffer for InnerProductOp.BMean
			// Create array for replicates of 'eventsFeatureWeights_rep_rep_F_Etrain__BVariance'
			PositiveDefiniteMatrix[][] eventsFeatureWeights_rep_rep_F_Etrain__BVariance = new PositiveDefiniteMatrix[this.NumTraining][];
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				// Create array for replicates of 'eventsFeatureWeights_rep_rep_F_Etrain__BVariance'
				eventsFeatureWeights_rep_rep_F_Etrain__BVariance[Ntrain] = new PositiveDefiniteMatrix[this.NumEventsTrain[Ntrain]];
				for(int Etrain = 0; Etrain<this.NumEventsTrain[Ntrain]; Etrain++) {
					// Message to 'vdouble10' from InnerProduct factor
					eventsFeatureWeights_rep_rep_F_Etrain__BVariance[Ntrain][Etrain] = InnerProductOp.BVarianceInit(eventsFeatureWeights_rep_rep_F[Ntrain][Etrain]);
				}
			}
			// Buffer for InnerProductOp.InnerProductAverageConditional
			// Create array for replicates of 'eventsFeatureWeights_rep_rep_F_Etrain__BMean'
			Vector[][] eventsFeatureWeights_rep_rep_F_Etrain__BMean = new Vector[this.NumTraining][];
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				// Create array for replicates of 'eventsFeatureWeights_rep_rep_F_Etrain__BMean'
				eventsFeatureWeights_rep_rep_F_Etrain__BMean[Ntrain] = new Vector[this.NumEventsTrain[Ntrain]];
				for(int Etrain = 0; Etrain<this.NumEventsTrain[Ntrain]; Etrain++) {
					// Message to 'vdouble10' from InnerProduct factor
					eventsFeatureWeights_rep_rep_F_Etrain__BMean[Ntrain][Etrain] = InnerProductOp.BMeanInit(eventsFeatureWeights_rep_rep_F[Ntrain][Etrain]);
				}
			}
			// Create array for replicates of 'vdouble10_F'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble10_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTraining);
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				// Create array for replicates of 'vdouble10_F'
				vdouble10_F[Ntrain] = new DistributionStructArray<Gaussian,double>(this.NumEventsTrain[Ntrain]);
				for(int Etrain = 0; Etrain<this.NumEventsTrain[Ntrain]; Etrain++) {
					vdouble10_F[Ntrain][Etrain] = Gaussian.Uniform();
				}
			}
			// Create array for replicates of 'vdouble14_F'
			DistributionStructArray<Gaussian,double> vdouble14_F = new DistributionStructArray<Gaussian,double>(this.NumTraining);
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				vdouble14_F[Ntrain] = Gaussian.Uniform();
			}
			// Create array for replicates of 'vdouble6_B'
			DistributionStructArray<Gaussian,double> vdouble6_B = new DistributionStructArray<Gaussian,double>(this.NumTraining);
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				vdouble6_B[Ntrain] = Gaussian.Uniform();
			}
			for(int iteration = this.Changed_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain2_iterationsDone; iteration<numberOfIterations; iteration++) {
				// Message to 'dummyWeights_rep' from Replicate factor
				this.dummyWeights_rep_F_marginal = ReplicateOp_Divide.Marginal<VectorGaussian>(this.dummyWeights_rep_B_toDef, this.dummyWeights_F, this.dummyWeights_rep_F_marginal);
				// Message to 'eventsFeatureWeights_rep' from Replicate factor
				this.eventsFeatureWeights_rep_F_marginal = ReplicateOp_Divide.Marginal<VectorGaussian>(this.eventsFeatureWeights_rep_B_toDef, this.eventsFeatureWeights_F, this.eventsFeatureWeights_rep_F_marginal);
				for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
					// Message to 'dummyWeights_rep' from Replicate factor
					dummyWeights_rep_F[Ntrain] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.dummyWeights_rep_B[Ntrain], this.dummyWeights_rep_F_marginal, Ntrain, dummyWeights_rep_F[Ntrain]);
					// Message to 'vdouble6' from InnerProduct factor
					dummyWeights_rep_F_Ntrain__BVariance[Ntrain] = InnerProductOp.BVariance(dummyWeights_rep_F[Ntrain], dummyWeights_rep_F_Ntrain__BVariance[Ntrain]);
					// Message to 'vdouble6' from InnerProduct factor
					dummyWeights_rep_F_Ntrain__BMean[Ntrain] = InnerProductOp.BMean(dummyWeights_rep_F[Ntrain], dummyWeights_rep_F_Ntrain__BVariance[Ntrain], dummyWeights_rep_F_Ntrain__BMean[Ntrain]);
					// Message to 'vdouble6' from InnerProduct factor
					vdouble6_F[Ntrain] = InnerProductOp.InnerProductAverageConditional(this.BaseFeaturesTrain[Ntrain], dummyWeights_rep_F_Ntrain__BMean[Ntrain], dummyWeights_rep_F_Ntrain__BVariance[Ntrain]);
					// Message to 'dummyContributionsTrain' from GaussianFromMeanAndVariance factor
					this.dummyContributionsTrain_F[Ntrain] = GaussianFromMeanAndVarianceOp.SampleAverageConditional(vdouble6_F[Ntrain], 5.0);
					// Message to 'eventsFeatureWeights_rep' from Replicate factor
					this.eventsFeatureWeights_rep_F[Ntrain] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.eventsFeatureWeights_rep_rep_B_toDef[Ntrain], this.eventsFeatureWeights_rep_F_marginal, Ntrain, this.eventsFeatureWeights_rep_F[Ntrain]);
					// Message to 'eventsFeatureWeights_rep_rep' from Replicate factor
					eventsFeatureWeights_rep_rep_F_marginal[Ntrain] = ReplicateOp_Divide.Marginal<VectorGaussian>(this.eventsFeatureWeights_rep_rep_B_toDef[Ntrain], this.eventsFeatureWeights_rep_F[Ntrain], eventsFeatureWeights_rep_rep_F_marginal[Ntrain]);
					for(int Etrain = 0; Etrain<this.NumEventsTrain[Ntrain]; Etrain++) {
						// Message to 'eventsFeatureWeights_rep_rep' from Replicate factor
						eventsFeatureWeights_rep_rep_F[Ntrain][Etrain] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.eventsFeatureWeights_rep_rep_B[Ntrain][Etrain], eventsFeatureWeights_rep_rep_F_marginal[Ntrain], Etrain, eventsFeatureWeights_rep_rep_F[Ntrain][Etrain]);
						// Message to 'vdouble10' from InnerProduct factor
						eventsFeatureWeights_rep_rep_F_Etrain__BVariance[Ntrain][Etrain] = InnerProductOp.BVariance(eventsFeatureWeights_rep_rep_F[Ntrain][Etrain], eventsFeatureWeights_rep_rep_F_Etrain__BVariance[Ntrain][Etrain]);
						// Message to 'vdouble10' from InnerProduct factor
						eventsFeatureWeights_rep_rep_F_Etrain__BMean[Ntrain][Etrain] = InnerProductOp.BMean(eventsFeatureWeights_rep_rep_F[Ntrain][Etrain], eventsFeatureWeights_rep_rep_F_Etrain__BVariance[Ntrain][Etrain], eventsFeatureWeights_rep_rep_F_Etrain__BMean[Ntrain][Etrain]);
						// Message to 'vdouble10' from InnerProduct factor
						vdouble10_F[Ntrain][Etrain] = InnerProductOp.InnerProductAverageConditional(this.EventsFeaturesTrain[Ntrain][Etrain], eventsFeatureWeights_rep_rep_F_Etrain__BMean[Ntrain][Etrain], eventsFeatureWeights_rep_rep_F_Etrain__BVariance[Ntrain][Etrain]);
						// Message to 'eventsContributionsTrain' from GaussianFromMeanAndVariance factor
						this.eventsContributionsTrain_F[Ntrain][Etrain] = GaussianFromMeanAndVarianceOp.SampleAverageConditional(vdouble10_F[Ntrain][Etrain], 5.0);
					}
					// Message to 'eventsContributionsTrain_uses' from Replicate factor
					this.eventsContributionsTrain_uses_F_Ntrain__marginal[Ntrain] = ReplicateOp_Divide.Marginal<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTrain_uses_B_Ntrain__toDef[Ntrain], this.eventsContributionsTrain_F[Ntrain], this.eventsContributionsTrain_uses_F_Ntrain__marginal[Ntrain]);
					// Message to 'eventsContributionsTrain_uses' from Replicate factor
					eventsContributionsTrain_uses_F[Ntrain][1] = ReplicateOp_Divide.UsesAverageConditional<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTrain_uses_B[Ntrain][1], this.eventsContributionsTrain_uses_F_Ntrain__marginal[Ntrain], 1, eventsContributionsTrain_uses_F[Ntrain][1]);
					// Message to 'vdouble14' from Sum factor
					vdouble14_F[Ntrain] = FastSumOp.SumAverageConditional(eventsContributionsTrain_uses_F[Ntrain][1]);
					// Message to 'dummyContributionsTrain_uses' from Plus factor
					this.dummyContributionsTrain_uses_B[Ntrain][1] = DoublePlusOp.AAverageConditional(this.ObservedCountsTrain[Ntrain], vdouble14_F[Ntrain]);
					// Message to 'dummyContributionsTrain_uses' from Replicate factor
					this.dummyContributionsTrain_uses_B_Ntrain__toDef[Ntrain] = ReplicateOp_Divide.ToDef<Gaussian>(this.dummyContributionsTrain_uses_B[Ntrain], this.dummyContributionsTrain_uses_B_Ntrain__toDef[Ntrain]);
					// Message to 'dummyContributionsTrain_uses' from Replicate factor
					this.dummyContributionsTrain_uses_F_Ntrain__marginal[Ntrain] = ReplicateOp_Divide.Marginal<Gaussian>(this.dummyContributionsTrain_uses_B_Ntrain__toDef[Ntrain], this.dummyContributionsTrain_F[Ntrain], this.dummyContributionsTrain_uses_F_Ntrain__marginal[Ntrain]);
					// Message to 'dummyContributionsTrain_uses' from Replicate factor
					dummyContributionsTrain_uses_F[Ntrain][0] = ReplicateOp_Divide.UsesAverageConditional<Gaussian>(this.dummyContributionsTrain_uses_B[Ntrain][0], this.dummyContributionsTrain_uses_F_Ntrain__marginal[Ntrain], 0, dummyContributionsTrain_uses_F[Ntrain][0]);
					// Message to 'dummyContributionsTrain_uses' from IsPositive factor
					this.dummyContributionsTrain_uses_B[Ntrain][0] = IsPositiveOp_Proper.XAverageConditional(Bernoulli.PointMass(true), dummyContributionsTrain_uses_F[Ntrain][0]);
					// Message to 'dummyContributionsTrain_uses' from Replicate factor
					this.dummyContributionsTrain_uses_B_Ntrain__toDef[Ntrain] = ReplicateOp_Divide.ToDef<Gaussian>(this.dummyContributionsTrain_uses_B[Ntrain], this.dummyContributionsTrain_uses_B_Ntrain__toDef[Ntrain]);
					// Message to 'dummyContributionsTrain_uses' from Replicate factor
					this.dummyContributionsTrain_uses_F_Ntrain__marginal[Ntrain] = ReplicateOp_Divide.Marginal<Gaussian>(this.dummyContributionsTrain_uses_B_Ntrain__toDef[Ntrain], this.dummyContributionsTrain_F[Ntrain], this.dummyContributionsTrain_uses_F_Ntrain__marginal[Ntrain]);
					// Message to 'dummyContributionsTrain_uses' from Replicate factor
					dummyContributionsTrain_uses_F[Ntrain][1] = ReplicateOp_Divide.UsesAverageConditional<Gaussian>(this.dummyContributionsTrain_uses_B[Ntrain][1], this.dummyContributionsTrain_uses_F_Ntrain__marginal[Ntrain], 1, dummyContributionsTrain_uses_F[Ntrain][1]);
					// Message to 'vdouble14' from Plus factor
					vdouble14_B[Ntrain] = DoublePlusOp.BAverageConditional(this.ObservedCountsTrain[Ntrain], dummyContributionsTrain_uses_F[Ntrain][1]);
					// Message to 'eventsContributionsTrain_uses' from Sum factor
					this.eventsContributionsTrain_uses_B[Ntrain][1] = FastSumOp.ArrayAverageConditional<DistributionStructArray<Gaussian,double>>(vdouble14_B[Ntrain], vdouble14_F[Ntrain], eventsContributionsTrain_uses_F[Ntrain][1], this.eventsContributionsTrain_uses_B[Ntrain][1]);
					// Message to 'eventsContributionsTrain_uses' from Replicate factor
					this.eventsContributionsTrain_uses_B_Ntrain__toDef[Ntrain] = ReplicateOp_Divide.ToDef<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTrain_uses_B[Ntrain], this.eventsContributionsTrain_uses_B_Ntrain__toDef[Ntrain]);
					// Message to 'eventsContributionsTrain_uses' from Replicate factor
					this.eventsContributionsTrain_uses_F_Ntrain__marginal[Ntrain] = ReplicateOp_Divide.Marginal<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTrain_uses_B_Ntrain__toDef[Ntrain], this.eventsContributionsTrain_F[Ntrain], this.eventsContributionsTrain_uses_F_Ntrain__marginal[Ntrain]);
					// Message to 'eventsContributionsTrain_uses' from Replicate factor
					eventsContributionsTrain_uses_F[Ntrain][0] = ReplicateOp_Divide.UsesAverageConditional<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTrain_depth2_B[Ntrain], this.eventsContributionsTrain_uses_F_Ntrain__marginal[Ntrain], 0, eventsContributionsTrain_uses_F[Ntrain][0]);
					for(int Etrain = 0; Etrain<this.NumEventsTrain[Ntrain]; Etrain++) {
						// Message to 'eventsContributionsTrain_depth2' from IsPositive factor
						this.eventsContributionsTrain_depth2_B[Ntrain][Etrain] = IsPositiveOp_Proper.XAverageConditional(Bernoulli.PointMass(true), eventsContributionsTrain_uses_F[Ntrain][0][Etrain]);
						// Message to 'eventsContributionsTrain_uses' from Copy factor
						this.eventsContributionsTrain_uses_B[Ntrain][0][Etrain] = ArrayHelper.SetTo<Gaussian>(this.eventsContributionsTrain_uses_B[Ntrain][0][Etrain], this.eventsContributionsTrain_depth2_B[Ntrain][Etrain]);
					}
					// Message to 'eventsContributionsTrain_uses' from Replicate factor
					this.eventsContributionsTrain_uses_B_Ntrain__toDef[Ntrain] = ReplicateOp_Divide.ToDef<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTrain_uses_B[Ntrain], this.eventsContributionsTrain_uses_B_Ntrain__toDef[Ntrain]);
					for(int Etrain = 0; Etrain<this.NumEventsTrain[Ntrain]; Etrain++) {
						// Message to 'vdouble10' from GaussianFromMeanAndVariance factor
						vdouble10_B[Ntrain][Etrain] = GaussianFromMeanAndVarianceOp.MeanAverageConditional(this.eventsContributionsTrain_uses_B_Ntrain__toDef[Ntrain][Etrain], 5.0);
						// Message to 'eventsFeatureWeights_rep_rep' from InnerProduct factor
						this.eventsFeatureWeights_rep_rep_B[Ntrain][Etrain] = InnerProductOp.BAverageConditional(vdouble10_B[Ntrain][Etrain], this.EventsFeaturesTrain[Ntrain][Etrain], this.eventsFeatureWeights_rep_rep_B[Ntrain][Etrain]);
					}
					// Message to 'eventsFeatureWeights_rep_rep' from Replicate factor
					this.eventsFeatureWeights_rep_rep_B_toDef[Ntrain] = ReplicateOp_Divide.ToDef<VectorGaussian>(this.eventsFeatureWeights_rep_rep_B[Ntrain], this.eventsFeatureWeights_rep_rep_B_toDef[Ntrain]);
					// Message to 'vdouble6' from GaussianFromMeanAndVariance factor
					vdouble6_B[Ntrain] = GaussianFromMeanAndVarianceOp.MeanAverageConditional(this.dummyContributionsTrain_uses_B_Ntrain__toDef[Ntrain], 5.0);
					// Message to 'dummyWeights_rep' from InnerProduct factor
					this.dummyWeights_rep_B[Ntrain] = InnerProductOp.BAverageConditional(vdouble6_B[Ntrain], this.BaseFeaturesTrain[Ntrain], this.dummyWeights_rep_B[Ntrain]);
					this.dummyWeights_rep_F_marginal = ReplicateOp_Divide.MarginalIncrement<VectorGaussian>(this.dummyWeights_rep_F_marginal, dummyWeights_rep_F[Ntrain], this.dummyWeights_rep_B[Ntrain]);
					this.eventsFeatureWeights_rep_F_marginal = ReplicateOp_Divide.MarginalIncrement<VectorGaussian>(this.eventsFeatureWeights_rep_F_marginal, this.eventsFeatureWeights_rep_F[Ntrain], this.eventsFeatureWeights_rep_rep_B_toDef[Ntrain]);
				}
				// Message to 'dummyWeights_rep' from Replicate factor
				this.dummyWeights_rep_B_toDef = ReplicateOp_Divide.ToDef<VectorGaussian>(this.dummyWeights_rep_B, this.dummyWeights_rep_B_toDef);
				// Message to 'eventsFeatureWeights_rep' from Replicate factor
				this.eventsFeatureWeights_rep_B_toDef = ReplicateOp_Divide.ToDef<VectorGaussian>(this.eventsFeatureWeights_rep_rep_B_toDef, this.eventsFeatureWeights_rep_B_toDef);
				this.OnProgressChanged(new ProgressChangedEventArgs(iteration));
			}
			// The constant 'vBernoulli0'
			Bernoulli vBernoulli0 = Bernoulli.Uniform();
			this.evidence_marginal_F = Bernoulli.Uniform();
			Bernoulli[] evidence_selector_cases_0_uses_B = default(Bernoulli[]);
			// Create array for 'evidence_selector_cases_0_uses' Backwards messages.
			evidence_selector_cases_0_uses_B = new Bernoulli[47];
			for(int _ind = 0; _ind<47; _ind++) {
				evidence_selector_cases_0_uses_B[_ind] = Bernoulli.Uniform();
			}
			// Message to 'evidence_selector_cases_0_uses' from Replicate factor
			evidence_selector_cases_0_uses_B[21] = Bernoulli.FromLogOdds(ReplicateOp.LogEvidenceRatio<VectorGaussian>(this.dummyWeights_rep_B, this.dummyWeights_F, dummyWeights_rep_F));
			DistributionStructArray<Bernoulli,bool>[] evidence_selector_cases_0_rep4_uses_B = default(DistributionStructArray<Bernoulli,bool>[]);
			// Create array for 'evidence_selector_cases_0_rep4_uses' Backwards messages.
			evidence_selector_cases_0_rep4_uses_B = new DistributionStructArray<Bernoulli,bool>[this.NumTraining];
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				// Create array for 'evidence_selector_cases_0_rep4_uses' Backwards messages.
				evidence_selector_cases_0_rep4_uses_B[Ntrain] = new DistributionStructArray<Bernoulli,bool>(3);
				for(int _ind = 0; _ind<3; _ind++) {
					evidence_selector_cases_0_rep4_uses_B[Ntrain][_ind] = Bernoulli.Uniform();
				}
				// Message to 'evidence_selector_cases_0_rep4_uses' from Replicate factor
				evidence_selector_cases_0_rep4_uses_B[Ntrain][2] = Bernoulli.FromLogOdds(ReplicateOp.LogEvidenceRatio<Gaussian>(this.dummyContributionsTrain_uses_B[Ntrain], this.dummyContributionsTrain_F[Ntrain], dummyContributionsTrain_uses_F[Ntrain]));
			}
			DistributionStructArray<Bernoulli,bool> evidence_selector_cases_0_rep4_B = default(DistributionStructArray<Bernoulli,bool>);
			// Create array for 'evidence_selector_cases_0_rep4' Backwards messages.
			evidence_selector_cases_0_rep4_B = new DistributionStructArray<Bernoulli,bool>(this.NumTraining);
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				evidence_selector_cases_0_rep4_B[Ntrain] = Bernoulli.Uniform();
				// Message to 'evidence_selector_cases_0_rep4' from Replicate factor
				evidence_selector_cases_0_rep4_B[Ntrain] = ReplicateOp_NoDivide.DefAverageConditional<Bernoulli>(evidence_selector_cases_0_rep4_uses_B[Ntrain], evidence_selector_cases_0_rep4_B[Ntrain]);
			}
			// Message to 'evidence_selector_cases_0_uses' from Replicate factor
			evidence_selector_cases_0_uses_B[22] = ReplicateOp_NoDivide.DefAverageConditional<Bernoulli>(evidence_selector_cases_0_rep4_B, evidence_selector_cases_0_uses_B[22]);
			DistributionStructArray<Bernoulli,bool> evidence_selector_cases_0_rep6_B = default(DistributionStructArray<Bernoulli,bool>);
			// Create array for 'evidence_selector_cases_0_rep6' Backwards messages.
			evidence_selector_cases_0_rep6_B = new DistributionStructArray<Bernoulli,bool>(this.NumTraining);
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				evidence_selector_cases_0_rep6_B[Ntrain] = Bernoulli.Uniform();
				// Message to 'evidence_selector_cases_0_rep6' from IsPositive factor
				evidence_selector_cases_0_rep6_B[Ntrain] = Bernoulli.FromLogOdds(IsPositiveOp.LogEvidenceRatio(true, dummyContributionsTrain_uses_F[Ntrain][0]));
			}
			// Message to 'evidence_selector_cases_0_uses' from Replicate factor
			evidence_selector_cases_0_uses_B[27] = ReplicateOp_NoDivide.DefAverageConditional<Bernoulli>(evidence_selector_cases_0_rep6_B, evidence_selector_cases_0_uses_B[27]);
			// The constant 'vbool1'
			// Create array for replicates of 'vbool1'
			bool[] vbool1 = new bool[this.NumTraining];
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				vbool1[Ntrain] = true;
			}
			DistributionStructArray<Bernoulli,bool> evidence_selector_cases_0_rep7_B = default(DistributionStructArray<Bernoulli,bool>);
			// Create array for 'evidence_selector_cases_0_rep7' Backwards messages.
			evidence_selector_cases_0_rep7_B = new DistributionStructArray<Bernoulli,bool>(this.NumTraining);
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				evidence_selector_cases_0_rep7_B[Ntrain] = Bernoulli.Uniform();
				// Message to 'evidence_selector_cases_0_rep7' from Equal factor
				evidence_selector_cases_0_rep7_B[Ntrain] = Bernoulli.FromLogOdds(ConstrainEqualOp<bool>.LogEvidenceRatio(true, vbool1[Ntrain]));
			}
			// Message to 'evidence_selector_cases_0_uses' from Replicate factor
			evidence_selector_cases_0_uses_B[28] = ReplicateOp_NoDivide.DefAverageConditional<Bernoulli>(evidence_selector_cases_0_rep7_B, evidence_selector_cases_0_uses_B[28]);
			// Message to 'evidence_selector_cases_0_uses' from Replicate factor
			evidence_selector_cases_0_uses_B[32] = Bernoulli.FromLogOdds(ReplicateOp.LogEvidenceRatio<VectorGaussian>(this.eventsFeatureWeights_rep_rep_B_toDef, this.eventsFeatureWeights_F, this.eventsFeatureWeights_rep_F));
			DistributionStructArray<Bernoulli,bool>[] evidence_selector_cases_0_rep10_uses_B = default(DistributionStructArray<Bernoulli,bool>[]);
			// Create array for 'evidence_selector_cases_0_rep10_uses' Backwards messages.
			evidence_selector_cases_0_rep10_uses_B = new DistributionStructArray<Bernoulli,bool>[this.NumTraining];
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				// Create array for 'evidence_selector_cases_0_rep10_uses' Backwards messages.
				evidence_selector_cases_0_rep10_uses_B[Ntrain] = new DistributionStructArray<Bernoulli,bool>(2);
				for(int _ind = 0; _ind<2; _ind++) {
					evidence_selector_cases_0_rep10_uses_B[Ntrain][_ind] = Bernoulli.Uniform();
				}
				// Message to 'evidence_selector_cases_0_rep10_uses' from Replicate factor
				evidence_selector_cases_0_rep10_uses_B[Ntrain][1] = Bernoulli.FromLogOdds(ReplicateOp.LogEvidenceRatio<VectorGaussian>(this.eventsFeatureWeights_rep_rep_B[Ntrain], this.eventsFeatureWeights_rep_F[Ntrain], eventsFeatureWeights_rep_rep_F[Ntrain]));
			}
			DistributionStructArray<Bernoulli,bool> evidence_selector_cases_0_rep10_B = default(DistributionStructArray<Bernoulli,bool>);
			// Create array for 'evidence_selector_cases_0_rep10' Backwards messages.
			evidence_selector_cases_0_rep10_B = new DistributionStructArray<Bernoulli,bool>(this.NumTraining);
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				evidence_selector_cases_0_rep10_B[Ntrain] = Bernoulli.Uniform();
				// Message to 'evidence_selector_cases_0_rep10' from Replicate factor
				evidence_selector_cases_0_rep10_B[Ntrain] = ReplicateOp_NoDivide.DefAverageConditional<Bernoulli>(evidence_selector_cases_0_rep10_uses_B[Ntrain], evidence_selector_cases_0_rep10_B[Ntrain]);
			}
			// Message to 'evidence_selector_cases_0_uses' from Replicate factor
			evidence_selector_cases_0_uses_B[33] = ReplicateOp_NoDivide.DefAverageConditional<Bernoulli>(evidence_selector_cases_0_rep10_B, evidence_selector_cases_0_uses_B[33]);
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				// Message to 'evidence_selector_cases_0_uses' from Replicate factor
				evidence_selector_cases_0_uses_B[38] = Bernoulli.FromLogOdds(ReplicateOp.LogEvidenceRatio<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTrain_uses_B[Ntrain], this.eventsContributionsTrain_F[Ntrain], eventsContributionsTrain_uses_F[Ntrain]));
			}
			// Create array for replicates of 'evidence_selector_cases_0_rep13_rep_B'
			DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]> evidence_selector_cases_0_rep13_rep_B = new DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]>(this.NumTraining);
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				// Create array for 'evidence_selector_cases_0_rep13_rep' Backwards messages.
				evidence_selector_cases_0_rep13_rep_B[Ntrain] = new DistributionStructArray<Bernoulli,bool>(this.NumEventsTrain[Ntrain]);
				for(int Etrain = 0; Etrain<this.NumEventsTrain[Ntrain]; Etrain++) {
					evidence_selector_cases_0_rep13_rep_B[Ntrain][Etrain] = Bernoulli.Uniform();
					// Message to 'evidence_selector_cases_0_rep13_rep' from IsPositive factor
					evidence_selector_cases_0_rep13_rep_B[Ntrain][Etrain] = Bernoulli.FromLogOdds(IsPositiveOp.LogEvidenceRatio(true, eventsContributionsTrain_uses_F[Ntrain][0][Etrain]));
				}
			}
			DistributionStructArray<Bernoulli,bool> evidence_selector_cases_0_rep13_B = default(DistributionStructArray<Bernoulli,bool>);
			// Create array for 'evidence_selector_cases_0_rep13' Backwards messages.
			evidence_selector_cases_0_rep13_B = new DistributionStructArray<Bernoulli,bool>(this.NumTraining);
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				evidence_selector_cases_0_rep13_B[Ntrain] = Bernoulli.Uniform();
				// Message to 'evidence_selector_cases_0_rep13' from Replicate factor
				evidence_selector_cases_0_rep13_B[Ntrain] = ReplicateOp_NoDivide.DefAverageConditional<Bernoulli>(evidence_selector_cases_0_rep13_rep_B[Ntrain], evidence_selector_cases_0_rep13_B[Ntrain]);
			}
			// Message to 'evidence_selector_cases_0_uses' from Replicate factor
			evidence_selector_cases_0_uses_B[42] = ReplicateOp_NoDivide.DefAverageConditional<Bernoulli>(evidence_selector_cases_0_rep13_B, evidence_selector_cases_0_uses_B[42]);
			// The constant 'vbool3'
			// Create array for replicates of 'vbool3'
			bool[][] vbool3 = new bool[this.NumTraining][];
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				// Create array for replicates of 'vbool3'
				vbool3[Ntrain] = new bool[this.NumEventsTrain[Ntrain]];
				for(int Etrain = 0; Etrain<this.NumEventsTrain[Ntrain]; Etrain++) {
					vbool3[Ntrain][Etrain] = true;
				}
			}
			// Create array for replicates of 'evidence_selector_cases_0_rep14_rep_B'
			DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]> evidence_selector_cases_0_rep14_rep_B = new DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]>(this.NumTraining);
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				// Create array for 'evidence_selector_cases_0_rep14_rep' Backwards messages.
				evidence_selector_cases_0_rep14_rep_B[Ntrain] = new DistributionStructArray<Bernoulli,bool>(this.NumEventsTrain[Ntrain]);
				for(int Etrain = 0; Etrain<this.NumEventsTrain[Ntrain]; Etrain++) {
					evidence_selector_cases_0_rep14_rep_B[Ntrain][Etrain] = Bernoulli.Uniform();
					// Message to 'evidence_selector_cases_0_rep14_rep' from Equal factor
					evidence_selector_cases_0_rep14_rep_B[Ntrain][Etrain] = Bernoulli.FromLogOdds(ConstrainEqualOp<bool>.LogEvidenceRatio(true, vbool3[Ntrain][Etrain]));
				}
			}
			DistributionStructArray<Bernoulli,bool> evidence_selector_cases_0_rep14_B = default(DistributionStructArray<Bernoulli,bool>);
			// Create array for 'evidence_selector_cases_0_rep14' Backwards messages.
			evidence_selector_cases_0_rep14_B = new DistributionStructArray<Bernoulli,bool>(this.NumTraining);
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				evidence_selector_cases_0_rep14_B[Ntrain] = Bernoulli.Uniform();
				// Message to 'evidence_selector_cases_0_rep14' from Replicate factor
				evidence_selector_cases_0_rep14_B[Ntrain] = ReplicateOp_NoDivide.DefAverageConditional<Bernoulli>(evidence_selector_cases_0_rep14_rep_B[Ntrain], evidence_selector_cases_0_rep14_B[Ntrain]);
			}
			// Message to 'evidence_selector_cases_0_uses' from Replicate factor
			evidence_selector_cases_0_uses_B[43] = ReplicateOp_NoDivide.DefAverageConditional<Bernoulli>(evidence_selector_cases_0_rep14_B, evidence_selector_cases_0_uses_B[43]);
			DistributionStructArray<Bernoulli,bool> evidence_selector_cases_0_rep17_B = default(DistributionStructArray<Bernoulli,bool>);
			// Create array for 'evidence_selector_cases_0_rep17' Backwards messages.
			evidence_selector_cases_0_rep17_B = new DistributionStructArray<Bernoulli,bool>(this.NumTraining);
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				evidence_selector_cases_0_rep17_B[Ntrain] = Bernoulli.Uniform();
				// Message to 'evidence_selector_cases_0_rep17' from Plus factor
				evidence_selector_cases_0_rep17_B[Ntrain] = Bernoulli.FromLogOdds(DoublePlusEvidenceOp.LogEvidenceRatio(this.ObservedCountsTrain[Ntrain], dummyContributionsTrain_uses_F[Ntrain][1], this.dummyContributionsTrain_uses_B[Ntrain][1]));
			}
			// Message to 'evidence_selector_cases_0_uses' from Replicate factor
			evidence_selector_cases_0_uses_B[46] = ReplicateOp_NoDivide.DefAverageConditional<Bernoulli>(evidence_selector_cases_0_rep17_B, evidence_selector_cases_0_uses_B[46]);
			Bernoulli evidence_selector_cases_0_B = Bernoulli.Uniform();
			// Message to 'evidence_selector_cases_0' from Replicate factor
			evidence_selector_cases_0_B = ReplicateOp_NoDivide.DefAverageConditional<Bernoulli>(evidence_selector_cases_0_uses_B, evidence_selector_cases_0_B);
			DistributionStructArray<Bernoulli,bool> evidence_selector_cases_B = default(DistributionStructArray<Bernoulli,bool>);
			// Create array for 'evidence_selector_cases' Backwards messages.
			evidence_selector_cases_B = new DistributionStructArray<Bernoulli,bool>(2);
			for(int _ind0 = 0; _ind0<2; _ind0++) {
				evidence_selector_cases_B[_ind0] = Bernoulli.Uniform();
			}
			// Message to 'evidence_selector_cases' from Copy factor
			evidence_selector_cases_B[0] = ArrayHelper.SetTo<Bernoulli>(evidence_selector_cases_B[0], evidence_selector_cases_0_B);
			Bernoulli evidence_selector_B = Bernoulli.Uniform();
			// Message to 'evidence_selector' from Cases factor
			evidence_selector_B = CasesOp.BAverageConditional(evidence_selector_cases_B);
			// Message to 'evidence_marginal' from Variable factor
			this.evidence_marginal_F = VariableOp.MarginalAverageConditional<Bernoulli>(evidence_selector_B, vBernoulli0, this.evidence_marginal_F);
			this.dummyWeights_marginal_F = ArrayHelper.MakeUniform<VectorGaussian>(VectorGaussian.Uniform(this.vVector0.Count));
			// Message to 'dummyWeights_marginal' from Variable factor
			this.dummyWeights_marginal_F = VariableOp.MarginalAverageConditional<VectorGaussian>(this.dummyWeights_rep_B_toDef, this.dummyWeights_F, this.dummyWeights_marginal_F);
			this.eventsFeatureWeights_marginal_F = ArrayHelper.MakeUniform<VectorGaussian>(VectorGaussian.Uniform(this.vVector3.Count));
			// Message to 'eventsFeatureWeights_marginal' from Variable factor
			this.eventsFeatureWeights_marginal_F = VariableOp.MarginalAverageConditional<VectorGaussian>(this.eventsFeatureWeights_rep_B_toDef, this.eventsFeatureWeights_F, this.eventsFeatureWeights_marginal_F);
			// Create array for 'dummyContributionsTrain_marginal' Forwards messages.
			this.dummyContributionsTrain_marginal_F = new DistributionStructArray<Gaussian,double>(this.NumTraining);
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				this.dummyContributionsTrain_marginal_F[Ntrain] = Gaussian.Uniform();
				// Message to 'dummyContributionsTrain_marginal' from Variable factor
				this.dummyContributionsTrain_marginal_F[Ntrain] = VariableOp.MarginalAverageConditional<Gaussian>(this.dummyContributionsTrain_uses_B_Ntrain__toDef[Ntrain], this.dummyContributionsTrain_F[Ntrain], this.dummyContributionsTrain_marginal_F[Ntrain]);
			}
			// Create array for 'eventsContributionsTrain_marginal' Forwards messages.
			this.eventsContributionsTrain_marginal_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTraining);
			for(int Ntrain = 0; Ntrain<this.NumTraining; Ntrain++) {
				// Create array for 'eventsContributionsTrain_marginal' Forwards messages.
				this.eventsContributionsTrain_marginal_F[Ntrain] = new DistributionStructArray<Gaussian,double>(this.NumEventsTrain[Ntrain]);
				for(int Etrain = 0; Etrain<this.NumEventsTrain[Ntrain]; Etrain++) {
					this.eventsContributionsTrain_marginal_F[Ntrain][Etrain] = Gaussian.Uniform();
					// Message to 'eventsContributionsTrain_marginal' from Variable factor
					this.eventsContributionsTrain_marginal_F[Ntrain][Etrain] = VariableOp.MarginalAverageConditional<Gaussian>(this.eventsContributionsTrain_uses_B_Ntrain__toDef[Ntrain][Etrain], this.eventsContributionsTrain_F[Ntrain][Etrain], this.eventsContributionsTrain_marginal_F[Ntrain][Etrain]);
				}
			}
			this.Changed_numberOfIterationsDecreased_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain2_iterationsDone = numberOfIterations;
		}

		/// <summary>
		/// Returns the marginal distribution for 'evidence' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public Bernoulli EvidenceMarginal()
		{
			return this.evidence_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'dummyWeights' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public VectorGaussian DummyWeightsMarginal()
		{
			return this.dummyWeights_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'dummyContributionsTrain' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionStructArray<Gaussian,double> DummyContributionsTrainMarginal()
		{
			return this.dummyContributionsTrain_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsFeatureWeights' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public VectorGaussian EventsFeatureWeightsMarginal()
		{
			return this.eventsFeatureWeights_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsContributionsTrain' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> EventsContributionsTrainMarginal()
		{
			return this.eventsContributionsTrain_marginal_F;
		}

		/// <summary>Computations that depend on the observed value of numTraining and baseFeaturesTrain and numEventsTrain and eventsFeaturesTrain and observedCountsTrain</summary>
		public void Changed_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_observedCountsTrain()
		{
			if (this.Changed_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_observedCountsTrain_iterationsDone==1) {
				return ;
			}
			this.numTraining_marginal = new PointMass<int>(this.NumTraining);
			this.baseFeaturesTrain_marginal = new PointMass<Vector[]>(this.BaseFeaturesTrain);
			this.numEventsTrain_marginal = new PointMass<int[]>(this.NumEventsTrain);
			this.eventsFeaturesTrain_marginal = new PointMass<Vector[][]>(this.EventsFeaturesTrain);
			this.observedCountsTrain_marginal = new DistributionStructArray<Gaussian,double>(this.NumTraining, delegate(int Ntrain) {
				return Gaussian.Uniform();
			});
			this.observedCountsTrain_marginal = Distribution.SetPoint<DistributionStructArray<Gaussian,double>,double[]>(this.observedCountsTrain_marginal, this.ObservedCountsTrain);
			Gaussian vdouble5_F = Gaussian.Uniform();
			this.vdouble5_marginal_F = Gaussian.Uniform();
			// Message from use of 'vdouble5'
			Gaussian vdouble5_use_B = Gaussian.Uniform();
			// Message to 'vdouble5' from GaussianFromMeanAndVariance factor
			vdouble5_F = GaussianFromMeanAndVarianceOp.SampleAverageConditional(0.0, 10.0);
			// Message to 'vdouble5_marginal' from Variable factor
			this.vdouble5_marginal_F = VariableOp.MarginalAverageConditional<Gaussian>(vdouble5_use_B, vdouble5_F, this.vdouble5_marginal_F);
			this.Changed_numTraining_baseFeaturesTrain_numEventsTrain_eventsFeaturesTrain_observedCountsTrain_iterationsDone = 1;
		}

		/// <summary>
		/// Returns the marginal distribution for 'numTraining' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<int> NumTrainingMarginal()
		{
			return this.numTraining_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'baseFeaturesTrain' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<Vector[]> BaseFeaturesTrainMarginal()
		{
			return this.baseFeaturesTrain_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'numEventsTrain' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<int[]> NumEventsTrainMarginal()
		{
			return this.numEventsTrain_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsFeaturesTrain' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<Vector[][]> EventsFeaturesTrainMarginal()
		{
			return this.eventsFeaturesTrain_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'observedCountsTrain' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionStructArray<Gaussian,double> ObservedCountsTrainMarginal()
		{
			return this.observedCountsTrain_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'vdouble5' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public Gaussian Vdouble5Marginal()
		{
			return this.vdouble5_marginal_F;
		}

		#endregion

		#region Events
		/// <summary>Event that is fired when the progress of inference changes, typically at the end of one iteration of the inference algorithm.</summary>
		public event EventHandler<ProgressChangedEventArgs> ProgressChanged;
		#endregion

	}

}
